#!/bin/csh -f
########################################################################
#                                                                      #
#                Copyright (c) 1986, 1991, 1995                        #
#           Regents of the University of California                    #
#                                                                      #
#                    All Rights Reserved                               #
#                                                                      #
#             Machine Dependency Handling System                       #
#                                                                      #
#                Bill Ross ross@cgl.ucsf.edu                           #
#            An extension of work of George Seibel                     #
#                                                                      #
#           Dependencies written by various authors.                   #
#                                                                      #
#  Permission to use, copy, modify, and distribute this software and   #
#  its documentation for any purpose and without fee is hereby         #
#  granted, provided that the above copyright notice appear in all     #
#  copies and that both that copyright notice and this permission      #
#  notice appear in supporting documentation, and that the name of     #
#  the University of California not be used in advertising or          #
#  publicity pertaining to distribution of the software without        #
#  specific, written prior permission.                                 #
#                                                                      #
#  THE REGENTS OF THE UNIVERSITY OF CALIFORNIA DISCLAIM ALL            #
#  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED      #
#  WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE    #
#  UNIVERSITY OF CALIFORNIA BE LIABLE FOR ANY SPECIAL, INDIRECT OR     #
#  CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM      #
#  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,     #
#  NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN           #
#  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.            #
#                                                                      #
########################################################################


setenv MACHINE "DEC Alpha OSF/1"
setenv MACH AXP_OSF
setenv MACHINEFLAGS " -DBYTE_REVERSED -DMEM_ALLOC -DHAS_FTN_ERFC "

# CPP is the cpp for this machine
setenv CPP /lib/cpp

# SYSDIR is the name of the system-specific source directory for makemake
setenv SYSDIR Machine/alpha
setenv LOADLIB  " "

# COMPILER ALIASES:

# LOADER/LINKER:
setenv LOAD "f90 "

# little or no optimization:
setenv L0 "f90 -c -O0 -assume noaccuracy_sensitive"

# modest optimization (local scalar):
setenv L1 "f90 -c -O1 -assume noaccuracy_sensitive"

# high scalar optimization (but not vectorization):
setenv L2 "f90 -c -O2 -assume noaccuracy_sensitive"

# high optimization (may be vectorization, not parallelization):
setenv L3 "f90 -c -O4 -assume noaccuracy_sensitive "

# ranlib, if it exists
setenv RANLIB ranlib

# spasms configuration
#SPASMS MACHINE.axp.f90_spasms_config
#SPASMS unix
#SPASMS n390
#SPASMS large
