c
c=========(UNIX FILE sys_proto.f:)
c
C
C#######################################################################
C                                                                      #
C                Copyright (c) 1986, 1991, 1995                        #
C           Regents of the University of California                    #
C                                                                      #
C                    All Rights Reserved                               #
C                                                                      #
C             Machine Dependency Handling System                       #
C                                                                      #
C                Bill Ross ross@cgl.ucsf.edu                           #
C            An extension of work of George Seibel                     #
C                                                                      #
C           Dependencies written by various authors.                   #
C                                                                      #
C  Permission to use, copy, modify, and distribute this software and   #
C  its documentation for any purpose and without fee is hereby         #
C  granted, provided that the above copyright notice appear in all     #
C  copies and that both that copyright notice and this permission      #
C  notice appear in supporting documentation, and that the name of     #
C  the University of California not be used in advertising or          #
C  publicity pertaining to distribution of the software without        #
C  specific, written prior permission.                                 #
C                                                                      #
C  THE REGENTS OF THE UNIVERSITY OF CALIFORNIA DISCLAIM ALL            #
C  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED      #
C  WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE    #
C  UNIVERSITY OF CALIFORNIA BE LIABLE FOR ANY SPECIAL, INDIRECT OR     #
C  CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM      #
C  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,     #
C  NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN           #
C  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.            #
C                                                                      #
C#######################################################################

C
c-----------------------------------------------------------------------
      subroutine amdate
c
c  --- prints out date onto file 6
c
      character*24 dat,ctime
      integer*4 stime,time
      external time
      external ctime
      stime = time()
      dat = ctime(stime)
      write(6,1) dat
    1 format('|',42x,'Run on ',a24)
      return
      end
c-----------------------------------------------------------------------
      subroutine amflsh(lun)
c     wrapper for i/o buffer flushing routine
c     Author: George Seibel
c
c     INPUT:
c
      integer lun
c        ... logical unit number to flush
c
c     --- most Unix (BSD, Convex, Sun, Stellar, SGI Iris...) ---
c
      call flush(lun)
      return
      end
c-----------------------------------------------------------------------
      integer function i1mach(i)
c
c --- return number of characters stored in integer variable
c
      if (i.eq.6) then
        i1mach = 4
      else
        write(6,*) 'error in i1mach'
        call mexit(6, 1)
      end if
      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE SECOND(TIM)
c
c     unix f77 version
c
c     use etime() for elapsed time from start of execution
c     use dtime() for delta time from last call to dtime()
c
      double precision tim
      real dumm(2),etime
c
      tim = etime(dumm)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine wall(isec)
      integer isec
c
c     unix f77 version - time in seconds local time since 1992
c
c     -- idate(): day, month, year
c     -- itime(): hour,minute,second
c
      integer itim(3),idat(3),i
c
      call itime(itim)
      call idate(idat)
c     write(6, *) idat(1), idat(2), idat(3), itim(1),itim(2),itim(3)
c
c     years to days
c
      isec = 0
      do 1 i=1992, idat(3)-1
        i2 = i / 4
        if (i2 * 4 .ne. i) then
          isec = isec + 365
        else
          isec = isec + 366
        endif
    1 continue
c
c     is this a leap year
c
      i2 = idat(3) / 4
      if (i2 * 4 .ne. idat(3)) then
        ifeb = 28
      else
        ifeb = 29
      endif
c
c     months to days
c
      if (idat(2) .eq. 2) then
        isec = isec + 31
      else if (idat(2) .eq. 3) then
        isec = isec + 31 + ifeb
      else if (idat(2) .eq. 4) then
        isec = isec + 31 + ifeb + 31
      else if (idat(2) .eq. 5) then
        isec = isec + 31 + ifeb + 31 + 30
      else if (idat(2) .eq. 6) then
        isec = isec + 31 + ifeb + 31 + 30 + 31
      else if (idat(2) .eq. 7) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30
      else if (idat(2) .eq. 8) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31
      else if (idat(2) .eq. 9) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31 + 31
      else if (idat(2) .eq. 10) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31 + 31 + 30
      else if (idat(2) .eq. 11) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31 + 31 + 30 + 31
      else if (idat(2) .eq. 12) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31 + 31 + 30 + 31
     .         + 30
      endif
      isec = isec + idat(1)
c
c     -- days to hours
c
      isec = isec * 24
      isec = isec + itim(1)
c
c     -- hours to minutes
c
      isec = isec * 60
      isec = isec + itim(2)
c
c     -- minutes to seconds
c
      isec = isec * 60
      isec = isec + itim(3)
c     write(6,*) isec
      return
      end


