C
C#######################################################################
C                                                                      #
C                Copyright (c) 1986, 1991, 1995                        #
C           Regents of the University of California                    #
C                                                                      #
C                    All Rights Reserved                               #
C                                                                      #
C             Machine Dependency Handling System                       #
C                                                                      #
C                Bill Ross ross@cgl.ucsf.edu                           #
C            An extension of work of George Seibel                     #
C                                                                      #
C           Dependencies written by various authors.                   #
C                                                                      #
C  Permission to use, copy, modify, and distribute this software and   #
C  its documentation for any purpose and without fee is hereby         #
C  granted, provided that the above copyright notice appear in all     #
C  copies and that both that copyright notice and this permission      #
C  notice appear in supporting documentation, and that the name of     #
C  the University of California not be used in advertising or          #
C  publicity pertaining to distribution of the software without        #
C  specific, written prior permission.                                 #
C                                                                      #
C  THE REGENTS OF THE UNIVERSITY OF CALIFORNIA DISCLAIM ALL            #
C  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED      #
C  WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE    #
C  UNIVERSITY OF CALIFORNIA BE LIABLE FOR ANY SPECIAL, INDIRECT OR     #
C  CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM      #
C  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,     #
C  NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN           #
C  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.            #
C                                                                      #
C#######################################################################
C
c-----------------------------------------------------------------------
      subroutine amdate
      return
      end
c-----------------------------------------------------------------------
      subroutine amflsh(lun)
c     wrapper for i/o buffer flushing routine
c     Author: George Seibel
c
c     INPUT:
c
      integer lun
c        ... logical unit number to flush
c
c     --- most Unix (BSD, Convex, Sun, Stellar, SGI Iris...) ---
c
C      call flush(lun)
      return
      end
c-----------------------------------------------------------------------
      INTEGER FUNCTION I1MACH(I)
C
C  I/O UNIT NUMBERS.
C
C    I1MACH( 1) = THE STANDARD INPUT UNIT.
C
C    I1MACH( 2) = THE STANDARD OUTPUT UNIT.
C
C    I1MACH( 3) = THE STANDARD PUNCH UNIT.
C
C    I1MACH( 4) = THE STANDARD ERROR MESSAGE UNIT.
C
C  WORDS.
C
C    I1MACH( 5) = THE NUMBER OF BITS PER INTEGER STORAGE UNIT.
C
C    I1MACH( 6) = THE NUMBER OF CHARACTERS PER INTEGER STORAGE UNIT.
C
C  INTEGERS.
C
C    ASSUME INTEGERS ARE REPRESENTED IN THE S-DIGIT, BASE-A FORM
C
C               SIGN ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C
C               WHERE 0 .LE. X(I) .LT. A FOR I=0,...,S-1.
C
C    I1MACH( 7) = A, THE BASE.
C
C    I1MACH( 8) = S, THE NUMBER OF BASE-A DIGITS.
C
C    I1MACH( 9) = A**S - 1, THE LARGEST MAGNITUDE.
C
C  FLOATING-POINT NUMBERS.
C
C    ASSUME FLOATING-POINT NUMBERS ARE REPRESENTED IN THE T-DIGIT,
C    BASE-B FORM
C
C               SIGN (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C               WHERE 0 .LE. X(I) .LT. B FOR I=1,...,T,
C               0 .LT. X(1), AND EMIN .LE. E .LE. EMAX.
C
C    I1MACH(10) = B, THE BASE.
C
C  SINGLE-PRECISION
C
C    I1MACH(11) = T, THE NUMBER OF BASE-B DIGITS.
C
C    I1MACH(12) = EMIN, THE SMALLEST EXPONENT E.
C
C    I1MACH(13) = EMAX, THE LARGEST EXPONENT E.
C
C  DOUBLE-PRECISION
C
C    I1MACH(14) = T, THE NUMBER OF BASE-B DIGITS.
C
C    I1MACH(15) = EMIN, THE SMALLEST EXPONENT E.
C
C    I1MACH(16) = EMAX, THE LARGEST EXPONENT E.
C
C  TO ALTER THIS FUNCTION FOR A PARTICULAR ENVIRONMENT,
C  THE DESIRED SET OF DATA STATEMENTS SHOULD BE ACTIVATED BY
C  REMOVING THE C FROM COLUMN 1.  ALSO, THE VALUES OF
C  I1MACH(1) - I1MACH(4) SHOULD BE CHECKED FOR CONSISTENCY
C  WITH THE LOCAL OPERATING SYSTEM.
C
      INTEGER IMACH(16),OUTPUT
C
      EQUIVALENCE (IMACH(4),OUTPUT)
C
C     MACHINE CONSTANTS FOR THE IBM 360/370 SERIES,
C     THE XEROX SIGMA 5/7/9 AND THE SEL SYSTEMS 85/86.
C
      DATA IMACH( 1) /   5 /
      DATA IMACH( 2) /   6 /
      DATA IMACH( 3) /   7 /
      DATA IMACH( 4) /   6 /
      DATA IMACH( 5) /  32 /
      DATA IMACH( 6) /   4 /
      DATA IMACH( 7) /   2 /
      DATA IMACH( 8) /  31 /
      DATA IMACH( 9) / Z7FFFFFFF /
      DATA IMACH(10) /  16 /
      DATA IMACH(11) /   6 /
      DATA IMACH(12) / -64 /
      DATA IMACH(13) /  63 /
      DATA IMACH(14) /  14 /
      DATA IMACH(15) / -64 /
      DATA IMACH(16) /  63 /
C
      IF (I .LT. 1  .OR.  I .GT. 16) GO TO 10
C
      I1MACH=IMACH(I)
      RETURN
C
 10   WRITE(OUTPUT,9000)
 9000 FORMAT(39H1ERROR    1 IN I1MACH - I OUT OF BOUNDS)
C
c     CALL FDUMP
C
      call mexit(output, 1)
C
      END
c-----------------------------------------------------------------------
      SUBROUTINE SECOND(TIM)
c     UXP FORT77EX version
      real dumm(2),rtim,tim
      real vpu, cpu
      CALL clockv (vpu, cpu, 0, 1)
      tim = cpu
      return
      end
c-----------------------------------------------------------------------
      subroutine wall(isec)
      integer isec
c
c     unix f77 version - time in seconds local time since 1992
c
c     -- idate(): day, month, year
c     -- itime(): hour,minute,second
c
      integer itim(3),idat(3),i
c
      call itime(itim)
      call idate(idat)
c     write(6, *) idat(1), idat(2), idat(3), itim(1),itim(2),itim(3)
c
c     years to days
c
      isec = 0
      do 1 i=1992, idat(3)-1
        i2 = i / 4
        if (i2 * 4 .ne. i) then
          isec = isec + 365
        else
          isec = isec + 366
        endif
    1 continue
c
c     is this a leap year
c
      i2 = idat(3) / 4
      if (i2 * 4 .ne. idat(3)) then
        ifeb = 28
      else
        ifeb = 29
      endif
c
c     months to days
c
      if (idat(2) .eq. 2) then
        isec = isec + 31
      else if (idat(2) .eq. 3) then
        isec = isec + 31 + ifeb
      else if (idat(2) .eq. 4) then
        isec = isec + 31 + ifeb + 31
      else if (idat(2) .eq. 5) then
        isec = isec + 31 + ifeb + 31 + 30
      else if (idat(2) .eq. 6) then
        isec = isec + 31 + ifeb + 31 + 30 + 31
      else if (idat(2) .eq. 7) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30
      else if (idat(2) .eq. 8) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31
      else if (idat(2) .eq. 9) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31 + 31
      else if (idat(2) .eq. 10) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31 + 31 + 30
      else if (idat(2) .eq. 11) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31 + 31 + 30 + 31
      else if (idat(2) .eq. 12) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31 + 31 + 30 + 31
     .         + 30
      endif
      isec = isec + idat(1)
c
c     -- days to hours
c
      isec = isec * 24
      isec = isec + itim(1)
c
c     -- hours to minutes
c
      isec = isec * 60
      isec = isec + itim(2)
c
c     -- minutes to seconds
c
      isec = isec * 60
      isec = isec + itim(3)
c     write(6,*) isec
      return
      end
