      subroutine MPI_allgatherv(
     &        sendbuf,len,MPI_dats,
     &        recvbuf,count,adr,MPI_datr,
     &        MPI_comm, ierr )

      implicit none

#include "mpif.h"

      integer len,count(*), adr(*), MPI_dats, MPI_datr
      integer MPI_comm,ierr
      double precision sendbuf(*), recvbuf(*)

      integer myid, numnodes

      integer Nele, Pmax
      parameter(Nele=500000, Pmax=128)

      integer r1a(Pmax), p2a(Pmax), r2a(Pmax), r1, p2, r2

      integer ncall, rm, is, N, N0, i, id, level, lev
      integer nsucc
      integer status ( MPI_STATUS_SIZE )

      integer last_comm
      save last_comm, ncall, myid, numnodes, r1a, p2a, r2a, level

      data ncall /-1/

      integer TAG
      parameter(TAG=1)

      character*4 fil
      save fil

      if( MPI_dats.ne.MPI_DOUBLE_PRECISION .or.
     &    MPI_datr.ne.MPI_DOUBLE_PRECISION ) then
        print*, 
     &'Err SMPI_ALLGATHERV only MPI_DOUBLE_PRECISION supported '
        ierr = 1
        return
      endif

      if( ncall.eq.-1 .or. MPI_comm.ne.last_comm ) then


      call MPI_COMM_RANK( MPI_comm, myid, ierr )
      call MPI_COMM_SIZE( MPI_comm, numnodes, ierr )

      if( ierr.ne.0 ) return

c Communications pattern:
      level=1
      r1a(level) = 0
      r2a(level) = numnodes-1
 
      do while( r1a(level).lt.r2a(level) )
 
        p2a(level) =(r2a(level)-r1a(level))/2 + 1
        rm = r1a(level)+p2a(level)
 
        level = level+1
 
        if(myid.lt.rm) then
 
          r2a(level) = min(r2a(level-1),rm-1)
          r1a(level) = r1a(level-1)
 
        else
 
          r1a(level) = rm
          r2a(level) = r2a(level-1)
 
        endif
 
      enddo
 
      level = level-1

      endif

      ncall = 0
      last_comm = MPI_comm

      do N=1,count(myid+1)
        recvbuf(adr(myid+1)+N) = sendbuf(N)
      enddo


      do lev=level,1,-1

        r1 = r1a(lev)+1
        r2 = r2a(lev)+1
        p2 = p2a(lev)
        rm = r1+p2

        if( myid+1.lt.rm ) then

          if( myid+p2+1.le.r2 ) then
           call MPI_SENDRECV(
     &              recvbuf(adr(r1)+1),adr(rm)-adr(r1),
     &              MPI_DOUBLE_PRECISION,
     &              myid+p2,TAG,
     &              recvbuf(adr(rm)+1),adr(r2)+count(r2)-adr(rm),
     &              MPI_DOUBLE_PRECISION,
     &              myid+p2,TAG,
     &              MPI_COMM_WORLD, status, ierr )
          else
           call MPI_RECV(
     &              recvbuf(adr(rm)+1),adr(r2)+count(r2)-adr(rm),
     &              MPI_DOUBLE_PRECISION,
     &              r2-1,TAG,
     &              MPI_COMM_WORLD, status, ierr )
          endif

        else

           if( rm+p2-1.gt.r2.and.myid+1.eq.r2 ) then
           call MPI_SEND(
     &              recvbuf(adr(rm)+1),adr(r2)+count(r2)-adr(rm),
     &              MPI_DOUBLE_PRECISION,
     &              rm-2,TAG,
     &              MPI_COMM_WORLD, ierr )
           endif

           call MPI_SENDRECV(
     &              recvbuf(adr(rm)+1),adr(r2)+count(r2)-adr(rm),
     &              MPI_DOUBLE_PRECISION,
     &              myid-p2,TAG,
     &              recvbuf(adr(r1)+1),adr(rm)-adr(r1),
     &              MPI_DOUBLE_PRECISION,
     &              myid-p2,TAG,
     &              MPI_COMM_WORLD, status, ierr )

        endif


      enddo


      return
      end
