
      subroutine MPI_reduce( sendbuf, recvbuf, count,
     &                        MPI_dat, MPI_op, root, MPI_comm, ierr )


#include "mpif.h"

      integer count, MPI_dat, MPI_op, root
      integer MPI_comm,ierr
      double precision sendbuf(*), recvbuf(*)

      integer myid, numnodes

      integer Nele, Pmax
      parameter(Nele=500000,Pmax=128)

      integer father, nsons, sons(Pmax), r1, r2, rm, rid, is, N, N0
      integer nsucc
      integer status ( MPI_STATUS_SIZE )

      integer last_root, last_comm
      save last_root, last_comm, nsons, sons, father

      data last_root /-1/
 
      integer TAG
      parameter(TAG=1)

      double precision internal_buf(2*Nele)

      character*4 fil
      save fil

      if( MPI_dat.ne.MPI_DOUBLE_PRECISION ) then
        print*, 'Err SMPI_REDUCE: only MPI_DOUBLE_PRECISION supported '
        ierr = 1
        return
      endif

      if( MPI_op.ne.MPI_SUM ) then
        print*, 'Err SMPI_REDUCE: only MPI_SUM supported '
        ierr = 1
        return
      endif

      if( last_root. ne. root .or. MPI_comm.ne.last_comm ) then


      call MPI_COMM_RANK( MPI_comm, myid, ierr )
      call MPI_COMM_SIZE( MPI_comm, numnodes, ierr )

c     write(fil,'(a2,i2.2)') 't_',myid
c     open(20,file=fil)

      if( ierr.ne.0 ) return


c Communications pattern:


      r1 = 0
      r2 = numnodes-1

      rid = mod(myid+numnodes-root,numnodes)
      
      nsons=0
      father = -1

      do while( r1.lt.r2 )


        rm = r2 - (r2-r1+1)/2 + 1

        if( rid.eq.r1 ) then

            nsons = nsons+1
            sons(nsons) = rm

        else if ( rid.eq.rm ) then

            father = r1

        endif 

        if( rid.lt.rm ) then
          r2 = rm-1
        else
          r1 = rm
        endif

      enddo

      father = mod(root+father, numnodes)

      do is=1,nsons
       sons(is) = mod( sons(is)+root, numnodes )
      enddo

c     write(20,*)
c    &  myid,'father/sons: ',father,' / ',(sons(is),is=1,nsons)

      endif

      last_root = root
      last_comm = MPI_comm

      if( Nele.lt.count ) then
        print*, 'Err SMPI_REDUCE: internal buffer overflow '
        ierr = 1
        return
      endif

      
      if( myid.ne.root ) then

      if(nsons.eq.0) then

       call MPI_SEND(sendbuf,count,MPI_DOUBLE_PRECISION,
     &               father,TAG,
     &               MPI_COMM_WORLD, ierr )

      else

      do N=1,count
          internal_buf(Nele+N) = sendbuf(N)
      enddo

      do is = nsons,1,-1
       call MPI_RECV(internal_buf,count,MPI_DOUBLE_PRECISION,
     &               sons(is),TAG,
     &               MPI_COMM_WORLD, status, ierr )

       do N=1,count
         internal_buf(Nele+N) = internal_buf(Nele+N) + internal_buf(N)
       enddo

      enddo

      call MPI_SEND(internal_buf(Nele+1),count,MPI_DOUBLE_PRECISION,
     &              father,TAG,
     &              MPI_COMM_WORLD, ierr )

      endif


      else

      do N=1,count
        recvbuf(N) = sendbuf(N)
      enddo

      do is = nsons,1,-1

       call MPI_RECV(internal_buf,count,MPI_DOUBLE_PRECISION,
     &               sons(is),TAG,
     &               MPI_COMM_WORLD, status, ierr )

       do N=1,count
         recvbuf(N) = recvbuf(N) + internal_buf(N)
       enddo

      enddo

      endif

      return
      end
