C
C#######################################################################
C                                                                      #
C                Copyright (c) 1986, 1991, 1995                        #
C           Regents of the University of California                    #
C                                                                      #
C                    All Rights Reserved                               #
C                                                                      #
C             Machine Dependency Handling System                       #
C                                                                      #
C                Bill Ross ross@cgl.ucsf.edu                           #
C            An extension of work of George Seibel                     #
C                                                                      #
C           Dependencies written by various authors.                   #
C                                                                      #
C  Permission to use, copy, modify, and distribute this software and   #
C  its documentation for any purpose and without fee is hereby         #
C  granted, provided that the above copyright notice appear in all     #
C  copies and that both that copyright notice and this permission      #
C  notice appear in supporting documentation, and that the name of     #
C  the University of California not be used in advertising or          #
C  publicity pertaining to distribution of the software without        #
C  specific, written prior permission.                                 #
C                                                                      #
C  THE REGENTS OF THE UNIVERSITY OF CALIFORNIA DISCLAIM ALL            #
C  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED      #
C  WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE    #
C  UNIVERSITY OF CALIFORNIA BE LIABLE FOR ANY SPECIAL, INDIRECT OR     #
C  CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM      #
C  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,     #
C  NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN           #
C  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.            #
C                                                                      #
C#######################################################################

C
c-----------------------------------------------------------------------
      subroutine amdate
c
c     --- prints out date onto unit 6: uses C funcs since
c         HP's at UCSF lack fdate()
c
      character*31 str
      integer ilen
c     external fdate
c
      call c_fdate(str, ilen)
      write(6,1) (str(i:i), i=1,ilen)
    1 format('|',40x,30a1)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine amflsh(lun)
c     wrapper for i/o buffer flushing routine
c     Author: George Seibel
c
c     INPUT:
c
      integer lun
c        ... logical unit number to flush
c
      j = 0
      return
      end
c
c-----------------------------------------------------------------------
c
      integer function i1mach(i)
c
c --- return number of characters stored in integer variable
c
      if (i.eq.6) then
        i1mach = 4
      else
        write(6,*) 'error in i1mach'
        call mexit(6, 1)
      end if
      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE SECOND(TIM)
c
c
c     use etime() for elapsed time from start of execution
c     use dtime() for delta time from last call to dtime()
c
#ifdef DPREC
      double precision tim
#endif
      integer*4 itim(4)
c
      call times(itim)
c
c      - the divisor is the value of the "clock tick" "CLK_TCK"
c        in /usr/include/sys/time.h - clk_tck.c generates the
c        value and makesys.csh plugs it a special -DCLK_TCK=xxx
c        when making sys.o.
c
      tim = float(itim(1)) / float(CLK_TCK)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine wall(isec)
      integer isec

      call time(isec)
      return
      end
c-----------------------------------------------------------------------
      subroutine getarg(iarg,arg)
      character*(*) arg
      call igetarg(iarg,arg,len(arg))
      return
      end
c-------------------------
c
c  --- routine to trap underflows:
c
      subroutine trapu(a)
      real a
      a = 0.e0
      return
      end

c
c  --- routine to trap double prec underflows:
c
      subroutine trapud(a)
      double precision a
      a = 0.d0
      return
      end

