c
c     COPYRIGHT 1994, Pennsylvania State University.
c                 All rights reserved.  
c
c     This software is covered by the AMBER license 
c     agreement which contains restrictions on its use, 
c     disclosure, and duplication!
c
c     Common block of scratch space necessary for the Cray
c     SHMEM routines.  
c
      integer T3E_BCSYNC_SZ, T3E_BARRSYNC_SZ, T3E_DATASYNC_SZ,
     .  T3E_CLSYNC_SZ, T3E_WRKDATA_SIZE, T3E_REDDATA_SIZE,
     .  T3E_BUF_SIZE, TOTAL_MPI_COMMUNICATORS

c     NOTE: wrkdata must be big enough to hold n/2+2 if 
c     reducing n items and MUST be a multiple of the
c     cache line size (4 for the T3E).
c
      parameter (T3E_WRKDATA_SIZE=500000)
      parameter (T3E_REDDATA_SIZE=72000)

      parameter (T3E_BCSYNC_SZ=4)
      parameter (T3E_BARRSYNC_SZ=4)
      parameter (T3E_CLSYNC_SZ=4)
      parameter (T3E_DATASYNC_SZ=4)
      parameter (T3E_BUF_SIZE=160000)
      parameter (TOTAL_MPI_COMMUNICATORS=3)
#ifndef MPI_MAX_PROCESSORS
#define MPI_MAX_PROCESSORS 512
#endif

c
c     Increase T3E_WRKDATA_SIZE if you receive an error...
c
#include <mpp/shmem.fh>
      integer wrkdata_size,bufsize
      parameter(wrkdata_size=T3E_WRKDATA_SIZE)
      parameter(bufsize=T3E_BUF_SIZE)
      common/wrkdat/wrkdata,
     $     datasync,
     $     bcastsync,
     $     barsync,
     $     collsync,
     $     nbuf,
     $     bcast_cnt, data_cnt, coll_cnt, bar_cnt

      integer nbuf(bufsize),wrkdata(wrkdata_size,T3E_DATASYNC_SZ),
     .     datasync(SHMEM_REDUCE_SYNC_SIZE,T3E_DATASYNC_SZ),
     .     barsync(SHMEM_BARRIER_SYNC_SIZE,T3E_BARRSYNC_SZ,
     .             TOTAL_MPI_COMMUNICATORS),
     .     bcastsync(SHMEM_BCAST_SYNC_SIZE,T3E_BCSYNC_SZ),
     .     collsync(SHMEM_COLLECT_SYNC_SIZE,T3E_CLSYNC_SZ)

      integer bar_cnt(TOTAL_MPI_COMMUNICATORS)
      integer bcast_cnt
      integer data_cnt
      integer coll_cnt

c---------------------------------------------------------------
c     mpes contains the group information
c        mpes(x,1)  specifies 1st pe of the group x
c        mpes(x,2)  specifies the number of members of group x
c---------------------------------------------------------------
      integer mpes(0:TOTAL_MPI_COMMUNICATORS,2)
      common /gp_barr_com0/mpes
c---------------------------------------------------------------

      integer mpi_numgp_active(0:TOTAL_MPI_COMMUNICATORS)
      integer mpi_ncomm_active(0:TOTAL_MPI_COMMUNICATORS)
      integer mpi_gpsize(0:TOTAL_MPI_COMMUNICATORS)
      integer mpi_gpranks(0:MPI_MAX_PROCESSORS,0:TOTAL_MPI_COMMUNICATORS)
      integer mpi_cmsize(0:TOTAL_MPI_COMMUNICATORS)
      integer mpi_cmrank0(0:TOTAL_MPI_COMMUNICATORS)
      integer mpi_gpcommnum(0:TOTAL_MPI_COMMUNICATORS)
      common/mpi_group_common/mpi_gpsize,mpi_gpranks,mpi_gpcommnum,
     $     mpi_numgp_active,mpi_ncomm_active,mpi_cmsize,mpi_cmrank0







