C
C************************************************************************
C                            AMBER                                     **
C                                                                      **
C Copyright (c) 1986, 1991 Regents of the University of California     **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C	system dependent routines for NEC SX-3
C
c-----------------------------------------------------------------------
      subroutine amdate
      character*8 dte
      call datim(dte,tim,4)
      write(6,1) dte
    1 format('|',56x,'Run on ',a8)
      return
      end
c-----------------------------------------------------------------------
      subroutine amflsh(lun)
c     wrapper for i/o buffer flushing routine
c     Author: George Seibel
c
c     INPUT:
c
      integer lun
c        ... logical unit number to flush
c
c     --- most Unix (BSD, Convex, Sun, Stellar, SGI Iris...) ---
c
      call flush(lun)
      return
      end
c-----------------------------------------------------------------------
      INTEGER FUNCTION I1MACH(I)
C
C  I/O UNIT NUMBERS.
C
C    I1MACH( 1) = THE STANDARD INPUT UNIT.
C
C    I1MACH( 2) = THE STANDARD OUTPUT UNIT.
C
C    I1MACH( 3) = THE STANDARD PUNCH UNIT.
C
C    I1MACH( 4) = THE STANDARD ERROR MESSAGE UNIT.
C
C  WORDS.
C
C    I1MACH( 5) = THE NUMBER OF BITS PER INTEGER STORAGE UNIT.
C
C    I1MACH( 6) = THE NUMBER OF CHARACTERS PER INTEGER STORAGE UNIT.
C
C  INTEGERS.
C
C    ASSUME INTEGERS ARE REPRESENTED IN THE S-DIGIT, BASE-A FORM
C
C               SIGN ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C
C               WHERE 0 .LE. X(I) .LT. A FOR I=0,...,S-1.
C
C    I1MACH( 7) = A, THE BASE.
C
C    I1MACH( 8) = S, THE NUMBER OF BASE-A DIGITS.
C
C    I1MACH( 9) = A**S - 1, THE LARGEST MAGNITUDE.
C
C  FLOATING-POINT NUMBERS.
C
C    ASSUME FLOATING-POINT NUMBERS ARE REPRESENTED IN THE T-DIGIT,
C    BASE-B FORM
C
C               SIGN (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C               WHERE 0 .LE. X(I) .LT. B FOR I=1,...,T,
C               0 .LT. X(1), AND EMIN .LE. E .LE. EMAX.
C
C    I1MACH(10) = B, THE BASE.
C
C  SINGLE-PRECISION
C
C    I1MACH(11) = T, THE NUMBER OF BASE-B DIGITS.
C
C    I1MACH(12) = EMIN, THE SMALLEST EXPONENT E.
C
C    I1MACH(13) = EMAX, THE LARGEST EXPONENT E.
C
C  DOUBLE-PRECISION
C
C    I1MACH(14) = T, THE NUMBER OF BASE-B DIGITS.
C
C    I1MACH(15) = EMIN, THE SMALLEST EXPONENT E.
C
C    I1MACH(16) = EMAX, THE LARGEST EXPONENT E.
C
C  TO ALTER THIS FUNCTION FOR A PARTICULAR ENVIRONMENT,
C  THE DESIRED SET OF DATA STATEMENTS SHOULD BE ACTIVATED BY
C  REMOVING THE C FROM COLUMN 1.  ALSO, THE VALUES OF
C  I1MACH(1) - I1MACH(4) SHOULD BE CHECKED FOR CONSISTENCY
C  WITH THE LOCAL OPERATING SYSTEM.
C
      INTEGER IMACH(16),OUTPUT
C
      EQUIVALENCE (IMACH(4),OUTPUT)
C
C
C     MACHINE CONSTANTS FOR THE Unicos Cray environment
C
      DATA IMACH( 1) /     5 /
      DATA IMACH( 2) /     6 /
      DATA IMACH( 3) /     7 /
      DATA IMACH( 4) /     6 /
      DATA IMACH( 5) /    64 /
      DATA IMACH( 6) /     8 /
      DATA IMACH( 7) /     2 /
      DATA IMACH( 8) /    63 /
      DATA IMACH( 9) /O"777777777777777777777"/
      DATA IMACH(10) /     2 /
      DATA IMACH(11) /    48 /
      DATA IMACH(12) / -8192 /
      DATA IMACH(13) /  8191 /
      DATA IMACH(14) /    96 /
      DATA IMACH(15) / -8192 /
      DATA IMACH(16) /  8191 /
C
      IF (I .LT. 1  .OR.  I .GT. 16) GO TO 10
C
      I1MACH=IMACH(I)
      RETURN
C
 10   WRITE(OUTPUT,9000)
 9000 FORMAT(39H1ERROR    1 IN I1MACH - I OUT OF BOUNDS)
C
c     CALL FDUMP
C
      call mexit(output, 1)
C
      END
c-----------------------------------------------------------------------
      SUBROUTINE SECOND(TIM)
      real*8 rtim
      call clock (rtim)
      tim = rtim
      return
      end
c-----------------------------------------------------------------------
      subroutine wall(isec)
      integer isec
c
c     unix f77 version - time in seconds local time since 1992
c
c     -- idate(): day, month, year
c     -- itime(): hour,minute,second
c
      integer itim(3),idat(3),i
c
      call itime(itim)
      call idate(idat)
c     write(6, *) idat(1), idat(2), idat(3), itim(1),itim(2),itim(3)
c
c     years to days
c
      isec = 0
      do 1 i=1992, idat(3)-1
        i2 = i / 4
        if (i2 * 4 .ne. i) then
          isec = isec + 365
        else
          isec = isec + 366
        endif
    1 continue
c
c     is this a leap year
c
      i2 = idat(3) / 4
      if (i2 * 4 .ne. idat(3)) then
        ifeb = 28
      else
        ifeb = 29
      endif
c
c     months to days
c
      if (idat(2) .eq. 2) then
        isec = isec + 31
      else if (idat(2) .eq. 3) then
        isec = isec + 31 + ifeb
      else if (idat(2) .eq. 4) then
        isec = isec + 31 + ifeb + 31
      else if (idat(2) .eq. 5) then
        isec = isec + 31 + ifeb + 31 + 30
      else if (idat(2) .eq. 6) then
        isec = isec + 31 + ifeb + 31 + 30 + 31
      else if (idat(2) .eq. 7) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30
      else if (idat(2) .eq. 8) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31
      else if (idat(2) .eq. 9) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31 + 31
      else if (idat(2) .eq. 10) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31 + 31 + 30
      else if (idat(2) .eq. 11) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31 + 31 + 30 + 31
      else if (idat(2) .eq. 12) then
        isec = isec + 31 + ifeb + 31 + 30 + 31 + 30 + 31 + 31 + 30 + 31
     .         + 30
      endif
      isec = isec + idat(1)
c
c     -- days to hours
c
      isec = isec * 24
      isec = isec + itim(1)
c
c     -- hours to minutes
c
      isec = isec * 60
      isec = isec + itim(2)
c
c     -- minutes to seconds
c
      isec = isec * 60
      isec = isec + itim(3)
c     write(6,*) isec
      return
      end
c-----------------------------------------------------------------------
      Subroutine pack(R,nbits,IA,N)
      Implicit Integer(A-Z)
C
C     Fast routine to pack N integers from IA into R.
C     This function requires N*nbit to be a multiple of 64
C
      Dimension IA(2,*), R(*)
C
      data NM32/X'00000000FFFFFFFF'/
      if (nbits .ne. 32) then
      write (6,*) 'Error in NECSX pack routine'
      stop
	endif
      Lim = (N)/2
      Do 10 I = 1, Lim
   10   R(I) = or(ils(IA(1,I),32),and(IA(2,I),NM32))
      Return
      End
c-----------------------------------------------------------------------
      subroutine unpack(R,nbits,IA,N)
      Implicit Integer(A-Z)
C
C     Fast routine to unpack N integers from R into IA.
C     This function requires N*nbit to be a multiple of 64
C
      Dimension R(*), IA(2,*)
C
      Data NM32/X'00000000FFFFFFFF'/
      if (nbits .ne. 32) then
      write (6,*) 'Error in NECSX unpack routine'
      stop
	endif
      npk  = (N)/2
      Do 20 I = 1, npk
        IA(1,I) = and(irl(R(I),32),NM32)
   20   IA(2,I) = and(R(I),NM32)
C
      Return
      End
