C
C#######################################################################
C                                                                      #
C                Copyright (c) 1986, 1991, 1995                        #
C           Regents of the University of California                    #
C                                                                      #
C                    All Rights Reserved                               #
C                                                                      #
C             Machine Dependency Handling System                       #
C                                                                      #
C                Bill Ross ross@cgl.ucsf.edu                           #
C            An extension of work of George Seibel                     #
C                                                                      #
C           Dependencies written by various authors.                   #
C                                                                      #
C  Permission to use, copy, modify, and distribute this software and   #
C  its documentation for any purpose and without fee is hereby         #
C  granted, provided that the above copyright notice appear in all     #
C  copies and that both that copyright notice and this permission      #
C  notice appear in supporting documentation, and that the name of     #
C  the University of California not be used in advertising or          #
C  publicity pertaining to distribution of the software without        #
C  specific, written prior permission.                                 #
C                                                                      #
C  THE REGENTS OF THE UNIVERSITY OF CALIFORNIA DISCLAIM ALL            #
C  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED      #
C  WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE    #
C  UNIVERSITY OF CALIFORNIA BE LIABLE FOR ANY SPECIAL, INDIRECT OR     #
C  CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM      #
C  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,     #
C  NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN           #
C  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.            #
C                                                                      #
C#######################################################################
c
c
      subroutine amdate
      integer*4 time
      character*26 string
      call ctime_ (string, time)
      write(6,1) str
    1 format('|',42x,'Run on ',a26)
      return
      end
c-----------------------------------------------------------------------
      subroutine amflsh(lun)
c     wrapper for i/o buffer flushing routine
c     Author: George Seibel
c
c     INPUT:
c
      integer lun
c        ... logical unit number to flush
c
c
c     --new for Version 2.3 of XLF; page 222 in the V2.3 Language Reference:
c     FLUSH_ call is needed for SP2
      CALL FLUSH_(LUN)
      return
      end
c-----------------------------------------------------------------------
      integer function i1mach(i)
c
c --- return number of characters stored in integer variable
c
      if (i.eq.6) then
        i1mach = 4
      else
        write(6,*) 'error in i1mach'
        call mexit(6, 1)
      end if
      return
      end
c-----------------------------------------------------------------------
      subroutine second(tim)
c     Wrapper for IBM RS6000 timer
c     G. Seibel, 29-May-90
c
      double precision tim
c        ... returned user+sys time from start of execution
      double precision cumusr
c        ... the process cpu time (accumulated from process startup time).
      double precision cumsys
c        ... the system cpu time expended on behalf of the user
c            process (accumulated from process startup time).
      double precision cumrel
c        ... the system wall clock time (accumulated from some arbitrary
c            reference time).
c
      call ctimer(cumusr,cumsys,cumrel)
      tim = cumusr + cumsys
      return
      end
c-----------------------------------------------------------------------
      subroutine wall(itim)
      integer itim
c
      double precision cumusr
c        ... the process cpu time (accumulated from process startup time).
      double precision cumsys
c        ... the system cpu time expended on behalf of the user
c            process (accumulated from process startup time).
      double precision cumrel
c        ... the system wall clock time (accumulated from some arbitrary
c            reference time).
      call ctimer(cumusr,cumsys,cumrel)
      itim = int(cumrel)
c
      return
      end
c-----------------------------------------------------------------------
      subroutine ctimer(cumusr,cumsys,cumrel)
c     Timer for IBM RS6000
c
c     OUTPUT:
c
      double precision cumusr
c        ... the process cpu time (accumulated from process startup time).
      double precision cumsys
c        ... the system cpu time expended on behalf of the user
c            process (accumulated from process startup time).
      double precision cumrel
c        ... the system wall clock time (accumulated from some arbitrary
c            reference time).
c
c     FUNCTIONS:
c
      integer times
c        ... timer function
c
c     INTERNAL:
c
      integer itime(4)
c        ... times array
      integer idum
c        ... function return value containing wallclock time
c
      idum   = times(itime)
      cumrel = dble(    idum)/100.0d0
      cumusr = dble(itime(1))/100.0d0
      cumsys = dble(itime(2))/100.0d0
c
      return
      end

#ifdef MPI
c     Emulated routines necessary for the MPI/AMBER interface...
#include "sp1.f"
#endif

