;   FAST call by value _SQRT  (replaces system call)
;   FAST SQRT for T3D
;   NOTE this version (dated) March 7 1994 now correctly handles the IEEE
;   inputs for which numerical output cannot be computed.
;   this version seems to require approx 134 clocks.
;   MUST be loaded with table_sqrt.f
;
        .ident   sqrt_ss
 	.external ABC
        .psect   sqrtss_code,code
_SQRT::
;;;;    ldq      r0,0(r16)           ; load X
        cmpeq    r31,0,r24           ; r24=1
        la       r6,tab              ; @tabl(1,0)
     stt    f16,1088(r6)
;    ldq    r0,1088(r6)
;    ldt    f0,1088(r6)
     fcmoveq   f31,f16,f30
     fcmoveq   f31,f16,f0
     ldq    r0,1088(r6)
        subq     r31,r24,r23         ; r23=-1
        ldt      f16,1072(r6)        ; p(6)
        srl      r0,52,r18           ; exponent field
        lda      r7,2047(r31)        ; 2047
        sll      r23,52,r22          ; r22=mask(12)
        ldt      f15,1064(r6)        ; p(5)
        subq     r18,r7,r18          ; exponent-2047
        sll      r24,61,r21          ; r21=shiftl(1,61)
        ldt      f14,1056(r6)        ; p(4)
        sll      r24,62,r20          ; r20=shiftl(1,62)
        ldt      f13,1048(r6)        ; p(3)
        srl      r23,11,r19          ; r19=mask(128-53) for mantissa
        ldt      f12,1040(r6)        ; p(2)
        srl      r0,1,r1             ; r1=shiftr(x,1)
        ldt      f11,1032(r6)        ; p(1)
        and      r1,r22,r1           ; r1=exponent of shiftr(x,1)
        ldt      f10,1024(r6)        ; p(0)
        addq     r1,r21,r1           ; jexp=
        ldt      f17,1080(r6)        ; 1.0
        and      r19,r0,r24          ; r24=and(ie,mnrm)
        lda      r23,1008(r31)       ; r23=1008
        addq     r24,r20,r24         ; ienrm
        srl      r24,43,r22
        and      r22,r23,r22        ; 16*iarg
        stq      r24,1088(r6)        ; pass(1)=ienrm
        addq     r22,r6,r22          ; @tabl(1,iarg)
        stq      r1,1096(r6)         ; pass(2)=jexp
        bge      r18,path            ; catch NEG & NaN & INF
        ldt      f18,0(r22)          ; t1
        ldt      f19,8(r22)          ; t2

        ldt      f20,1088(r6)        ; fenrm
        mult     f20,f19,f20         ; xf=t2*fenrm
        subt     f20,f17,f20         ; xa=xf-1.
        ldt      f21,1096(r6)        ; fexp
        mult     f21,f18,f21         ; sqt=t1*fexp
        mult     f20,f20,f22         ; xa**2

        mult     f20,f15,f25         ; p6(5)*xa
        mult     f22,f16,f26         ; p6(6)*xa**2
;       ldt      f30,0(r16)          ; reload X
;  addt f0,f31,f30

        addt     f14,f25,f25
        addt     f25,f26,f26         ; (p6(4)+xa*p6(5)) +xa**2*p6(6)

        mult     f20,f13,f25         ; p6(3)*xa
        mult     f22,f26,f26         ; xa**2*(p6(4)+...)
        fcmoveq  f30,f31,f21         ; set sqt=0 IF x=0
        addt     f12,f25,f25
        addt     f25,f26,f26         ; (p6(2)+xa*p6(3))+xa**2*(...

        mult     f20,f11,f25
        mult     f22,f26,f26
        addt     f25,f26,f26
        addt     f10,f26,f26         ; p=

        mult     f21,f26,f0          ; result=...

        ret      r31,(r26)

path:
        blt      r0,neg
;       Return x which is either Nan or +INF
;       ldt      f0,0(r16)
        ret      r31,(r26)

;       x<0 return NaN
neg:
         sll     r7,52,r7            ; 2047 (exponent)
         bis     r7,90,r7            ; Nan (90)
         stq     r7,1088(r6)
         ldt     f0,1088(r6)
         ret     r31,(r26)

        .endp
        .psect   TABSQRT,cache,common
tab:    .blkq    144
  ;     tabl(2,0:63),p6(0:6),1.0,pass(8)
        .end

