C
C#######################################################################
C                                                                      #
C                Copyright (c) 1986, 1991, 1995                        #
C           Regents of the University of California                    #
C                                                                      #
C                    All Rights Reserved                               #
C                                                                      #
C             Machine Dependency Handling System                       #
C                                                                      #
C                Bill Ross ross@cgl.ucsf.edu                           #
C            An extension of work of George Seibel                     #
C                                                                      #
C           Dependencies written by various authors.                   #
C                                                                      #
C  Permission to use, copy, modify, and distribute this software and   #
C  its documentation for any purpose and without fee is hereby         #
C  granted, provided that the above copyright notice appear in all     #
C  copies and that both that copyright notice and this permission      #
C  notice appear in supporting documentation, and that the name of     #
C  the University of California not be used in advertising or          #
C  publicity pertaining to distribution of the software without        #
C  specific, written prior permission.                                 #
C                                                                      #
C  THE REGENTS OF THE UNIVERSITY OF CALIFORNIA DISCLAIM ALL            #
C  WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED      #
C  WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE    #
C  UNIVERSITY OF CALIFORNIA BE LIABLE FOR ANY SPECIAL, INDIRECT OR     #
C  CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM      #
C  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,     #
C  NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN           #
C  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.            #
C                                                                      #
C#######################################################################
C
C	system dependent routines for Unicos
C
c-----------------------------------------------------------------------
      subroutine amdate
      character*8 dte
      call date(dte)
      write(6,1) dte
    1 format('|',57x,'Run on ',a8)
      return
      end
c-----------------------------------------------------------------------
      subroutine wall(itim)
      integer itim

      itim = int(secondr())
      return
      end
c-----------------------------------------------------------------------
      subroutine amflsh(lun)
c     wrapper for i/o buffer flushing routine
c     Author: George Seibel
c
c     INPUT:
c
      integer lun
c        ... logical unit number to flush
c
c   dac change 3/90: add c-library call to get flushes on Unicos;
c      this version flushes all buffers, not just unit "lun"
c   ross, 6/93: Cray has flush now, readded 'lun'
c
      call flush(lun)
      return
      end
c-----------------------------------------------------------------------
      INTEGER FUNCTION I1MACH(I)
C
C  I/O UNIT NUMBERS.
C
C    I1MACH( 1) = THE STANDARD INPUT UNIT.
C
C    I1MACH( 2) = THE STANDARD OUTPUT UNIT.
C
C    I1MACH( 3) = THE STANDARD PUNCH UNIT.
C
C    I1MACH( 4) = THE STANDARD ERROR MESSAGE UNIT.
C
C  WORDS.
C
C    I1MACH( 5) = THE NUMBER OF BITS PER INTEGER STORAGE UNIT.
C
C    I1MACH( 6) = THE NUMBER OF CHARACTERS PER INTEGER STORAGE UNIT.
C
C  INTEGERS.
C
C    ASSUME INTEGERS ARE REPRESENTED IN THE S-DIGIT, BASE-A FORM
C
C               SIGN ( X(S-1)*A**(S-1) + ... + X(1)*A + X(0) )
C
C               WHERE 0 .LE. X(I) .LT. A FOR I=0,...,S-1.
C
C    I1MACH( 7) = A, THE BASE.
C
C    I1MACH( 8) = S, THE NUMBER OF BASE-A DIGITS.
C
C    I1MACH( 9) = A**S - 1, THE LARGEST MAGNITUDE.
C
C  FLOATING-POINT NUMBERS.
C
C    ASSUME FLOATING-POINT NUMBERS ARE REPRESENTED IN THE T-DIGIT,
C    BASE-B FORM
C
C               SIGN (B**E)*( (X(1)/B) + ... + (X(T)/B**T) )
C
C               WHERE 0 .LE. X(I) .LT. B FOR I=1,...,T,
C               0 .LT. X(1), AND EMIN .LE. E .LE. EMAX.
C
C    I1MACH(10) = B, THE BASE.
C
C  SINGLE-PRECISION
C
C    I1MACH(11) = T, THE NUMBER OF BASE-B DIGITS.
C
C    I1MACH(12) = EMIN, THE SMALLEST EXPONENT E.
C
C    I1MACH(13) = EMAX, THE LARGEST EXPONENT E.
C
C  DOUBLE-PRECISION
C
C    I1MACH(14) = T, THE NUMBER OF BASE-B DIGITS.
C
C    I1MACH(15) = EMIN, THE SMALLEST EXPONENT E.
C
C    I1MACH(16) = EMAX, THE LARGEST EXPONENT E.
C
C  TO ALTER THIS FUNCTION FOR A PARTICULAR ENVIRONMENT,
C  THE DESIRED SET OF DATA STATEMENTS SHOULD BE ACTIVATED BY
C  REMOVING THE C FROM COLUMN 1.  ALSO, THE VALUES OF
C  I1MACH(1) - I1MACH(4) SHOULD BE CHECKED FOR CONSISTENCY
C  WITH THE LOCAL OPERATING SYSTEM.
C
      INTEGER IMACH(16),OUTPUT
C
      EQUIVALENCE (IMACH(4),OUTPUT)
C
C
C     MACHINE CONSTANTS FOR THE Unicos Cray environment
C
      DATA IMACH( 1) /     5 /
      DATA IMACH( 2) /     6 /
      DATA IMACH( 3) /     7 /
      DATA IMACH( 4) /     6 /
      DATA IMACH( 5) /    64 /
      DATA IMACH( 6) /     8 /
      DATA IMACH( 7) /     2 /
      DATA IMACH( 8) /    63 /
      DATA IMACH( 9) /  777777777777777777777B /
      DATA IMACH(10) /     2 /
      DATA IMACH(11) /    48 /
      DATA IMACH(12) / -8192 /
      DATA IMACH(13) /  8191 /
      DATA IMACH(14) /    96 /
      DATA IMACH(15) / -8192 /
      DATA IMACH(16) /  8191 /
C
      IF (I .LT. 1  .OR.  I .GT. 16) GO TO 10
C
      I1MACH=IMACH(I)
      RETURN
C
 10   WRITE(OUTPUT,9000)
 9000 FORMAT(39H1ERROR    1 IN I1MACH - I OUT OF BOUNDS)
C
c     CALL FDUMP
C
      call mexit(output, 1)
C
      END
c-----------------------------------------------------------------------
#ifdef PXF
      subroutine getarg (i,s)
      character*(*) s
      call pxfgetarg (i,s,idum1,idum2)
      return
      end
#endif
c-----------------------------------------------------------------------

#ifdef MPI
c     Emulated routines necessary for the MPI/AMBER interface...
#include "pvm.f"
#endif
#ifdef CRAY_MP
      function ncpu()
c
c     ...returns an integer value representing the value of the
c     environment variable NCPUS
c
      character*2 envalue
      character*5 name
      name = 'NCPUS'
c     ii=getenv('NCPUS'L,envalue,1)
      call pxfgetenv (name,5,envalue,idum1,idum2)
      if(envalue.eq.'  ')then
        ncpu=1
      else
        read(envalue,'(i2)')ncpu
      end if
      return
      end
#endif
