c-----------------------------------------------------------------------
      SUBROUTINE ADDHOH
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c     Reads water from a PDB file.   Atoms may be in any order, and
c     names can start in either col. 13 (for compatibility with old
c     Amber) or col. 14, which is correct PDB format.  Names MUST start
c     with 'O' or 'H'.   The file must NOT have any non-ATOM format
c     records. (TER, HEADER, etc) Topology of the added water is 3 bond,
c     no angle, as in the other solvation routines.
c     Bugfix: 13-jan-90 corrected count of added waters. -gls
C
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     +             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      COMMON/IOEDIT/IN2,IN3,IN4,IFN4,IN5,IOUTC,IOUTD,IDUMPR,IP1,IP2,IP3
#include "files.h"
      character*4 tmpnam, atnam
C
      DATA IOH,IHH,NAMO,NAMHA,NAMHB/4HOW  ,4HHW  ,4HO   ,4HH1  ,4HH2  /
      DATA IWATE /3HWAT/
      DATA IEND /1HE /
      DATA MAIN /1HM /
      DATA IXYZ /3HXYZ  /
      DATA IBLNK/4H     /
C
C     --- OPEN THE pseudo-PDB-Format water coordinate FILE ---
C
c     subr amopen(lun,   fname,fstat,fform,facc)
      call amopen(in5,  addfil, 'O',  'F',  'R')
C
C     ---- READ THE HYDROGEN CHARGE -----
C
      READ(IN,9008) QH,KH,KO
      IF(QH.LE.0.0E0) QH = 0.417
      IF(KH.EQ.IBLNK) KH = IHH
      IF(KO.EQ.IBLNK) KO = IOH
      QO = -(QH+QH)
      write(iout,'(/,5x,a,f6.4,a,f6.4)') 'Hydrogen Charge = ',qh,
     +       '  Oxygen Charge = ',qo
C
      nadded = 0
  100 CONTINUE
      LL = 1
C
      DO 5 K  =  1, 3
c
c     --- names can start in col 14 or 13 for compat. w/ old Amber ---
c
      READ(IN5,'(12x,a4,14x,3f8.3)',END = 74) atnam,XA,YA,ZA
      if (atnam(1:1) .eq. 'O' .or. atnam(1:2) .eq. ' O') go to 500
      if (atnam(1:1) .eq. 'H' .or. atnam(1:2) .eq. ' H') go to 510
C
C     ---- ERROR....ATOM TYPE NOT FOUND. ----
C
      GO TO 1010
  500 CONTINUE
      L = NTOTAT + 1
      GO TO 520
  510 CONTINUE
      LL = LL + 1
      L = NTOTAT + LL
  520 CONTINUE
      R(L) = XA
      THETA(L) = YA
      PHI(L) = ZA
    5 CONTINUE
C
      nadded = nadded + 1
      NTOT = NTOTAT
      NTOT1 = NTOTAT+1
      NTOT2 = NTOTAT+2
      NTOTAT = NTOTAT+3
      if (ntotat .gt. MAXATM) then
           write(iout,'(/,2x,a,i6,a)') 'addhoh: MAXATM =',MAXATM,
     +           ' exceeded'
           call mexit(iout, 1)
      endif
      JOIN(NTOT1) = NTOT-2
      JOIN(NTOT2) = NTOT1
      JOIN(NTOTAT) = NTOT1
      if (nbond+3 .gt. MAXBND) then
           write(iout,'(/,2x,a,i6,a)') 'addhoh: MAXBND =',MAXBND,
     +           ' exceeded'
           call mexit(iout, 1)
      endif
      IB(NBOND+1) = NTOT1
      JB(NBOND+1) = NTOT2
      IB(NBOND+2) = NTOT1
      JB(NBOND+2) = NTOTAT
      IB(NBOND+3) = NTOT2
      JB(NBOND+3) = NTOTAT
      NBOND = NBOND+3
      ISYMBL(NTOT1) = KO
      ISYMBL(NTOT2) = KH
      ISYMBL(NTOTAT) = KH
      IGRAPH(NTOT1) = NAMO
      IGRAPH(NTOT2) = NAMHA
      IGRAPH(NTOTAT) = NAMHB
      CHRG(NTOT1) = QO
      CHRG(NTOT2) = QH
      CHRG(NTOTAT) = QH
      ITREE(NTOT1) = MAIN
      ITREE(NTOT2) = IEND
      ITREE(NTOTAT) = IEND
      IROTAT(NTOT1) = NTOTAT
      IROTAT(NTOT2) = NTOT2
      IROTAT(NTOTAT) = NTOTAT
      NUMEX(NTOT1) = 2
      NUMEX(NTOT2) = 1
      NUMEX(NTOTAT) = 1
      NEXT1 = NEXT+1
      NEXT2 = NEXT+2
      NEXT3 = NEXT+3
      NEXT = NEXT+4
      if (next .gt. MAXEXC) then
           write(iout,'(/,2x,a,i6,a)') 'addhoh: MAXEXC =',MAXEXC,
     +           ' exceeded'
           call mexit(iout, 1)
      endif
      NATEX(NEXT1) = NTOT2
      NATEX(NEXT2) = NTOTAT
      NATEX(NEXT3) = NTOTAT
      NATEX(NEXT) = 0
C
C     --- MAKE EACH OF THESE WATERS AS A SINGLE RESIDUE. ----
C
      NTOTRS = NTOTRS+1
      if (ntotrs .ge. MAXRES) then
           write(iout,'(/,2x,a,i6,a)') 'addhoh: MAXRES =',MAXRES,
     +           ' exceeded'
           call mexit(iout, 1)
      endif
      LABRES(NTOTRS) = IWATE
      ITRES(NTOTRS) = IXYZ
      IBRES(NTOTRS+1) = NBOND+1
      IPRES(NTOTRS+1) = NTOTAT+1
      GO TO 100
   74 CONTINUE
      write(iout,'(/,5x,a,i5,a)') 'Added ',nadded,' waters'
C
      NMOL = NMOL+1
      if (nmol+1 .gt. MAXMOL) then
           write(iout,'(/,2x,a,i6,a)') 'addhoh: MAXMOL =',MAXMOL,
     +           ' exceeded'
           call mexit(iout, 1)
      endif
      NFRESM(NMOL+1) = NTOTRS+1
      NATML(NMOL) = NTOTAT
      MOLTYP(NMOL) = 4
      IBOND(NMOL+1) = NBOND+1
      ITHETA(NMOL+1) = NTHETA+1
      IPHI(NMOL+1) = NPHI+1
C
      CGTOT = 0.0E0
      DO 55 I = 1,NTOTAT
      IF(ISYMBL(I).EQ.ISYMDU) GO TO 55
      CGTOT = CGTOT+CHRG(I)
   55 CONTINUE
      WRITE(IOUT,270) CGTOT
C
C     ----- CLOSE THE INPUT FILE -----
C
      CALL CLOSC(IN5)
C
      RETURN
  270 FORMAT(1H ,5X,'TOTAL CHARGE ON MOLECULE  = ',F9.3,/)
 9008 FORMAT(F10.5,2A4)
 1010 CONTINUE
      WRITE (IOUT,1020)
 1020 FORMAT (/,2x,'ADD:  PDB atom names must start with O or H')
      call mexit(iout, 1)
      END
