c-----------------------------------------------------------------------
      SUBROUTINE ADDXRY(NFIRST,NLAST,IOPT)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c     Mods for Rev A by George Seibel:
c       Now using pdbrd() to read pdb files.  This actually lets us
c       read *REAL PDB FILES* for the first time in the history of
c       Amber!   Wow.
c       The matching algorithm was fixed so that if the PDB input
c       doesn't match the LINK topology sequence, the program will
c       stop with a message instead of happily generating garbage.
c       The old iopt = 1 handling was broken - it didn't always give
c       the same output as iopt = 0,2; and it was prone to mangling
c       the coordinates.  Rather than spend more time patching this
c       disaster, if the user asks for iopt=1, this routine will
c       be called once with iopt=0, then again with iopt=2.
c       - Now writes correctly formatted PDB records; thus these PDB
c         output files are not backwards compatible with 3.0.
c       - Added user warnings when general residue names are matched
c       to CYX/HIP/HIE/HID
c       - Cleaned up some format statements for more readable, concise
c       output.
c       - Removed commons INFOM, MISCL, CROSSL, BOND, ANGL, DIHED, NONBON.
c
      LOGICAL LASCRD,IATSUB
C
C     ----- READS IN OR WRITES OUT X-RAY COORDINATES FOR RESIDUES
C           NFIRST - NLAST -----
C
#include "sizes.h"
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     $            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     $            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     $             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      COMMON/IOEDIT/IN2,IN3,IN4,IFN4,IN5,IOUTC,IOUTD,IDUMPR,IP1,IP2,IP3
      COMMON/OPEDIT/IDBL,IDIREC,IOPTF
      COMMON/WORKA/MIXC(MAXATM),IWORK(MAXATM)
#include "files.h"
      character*4 tmpnam, atnam
      character*3 resnam
C
      DIMENSION LARR(50),ALDIH(50),ISTORE(100),NAB(100)
      dimension phioll(5),phiolk(5),phi0(MAXATM)
      DIMENSION IATSUB(MAXATM)
      EQUIVALENCE (IATSUB(1),MIXC(1))
C
      DATA IHID /4HHID  /
      DATA IHIE /4HHIE  /
      DATA IHIP /4HHIP  /
      DATA IHIS /4HHIS  /
      DATA LATOM /4HATOM /
      DATA ICYX /4HCYX  /
      DATA IFOR/3HFOR /
      DATA IBIN /3HBIN /
      DATA ICYS /4HCYS  /
      DATA IEND /4HEND /
C
C     ----- BRANCH DEPENDING ON THE VALUE OF IOPT -----
C
c     iopt = 0 :  read coords from unit 15
c     iopt = 1 :  read coords from unit 15, write coords to unit 18
c     iopt = 2 :  write coords to unit 18
c
      if (iopt .lt. 2) then
c          --- open PDB Input File ---
           call amopen(in3, pdbin, 'O',  'F',  'R')
      endif
      if (iopt .gt. 0) then
c          --- open the pdb output file ---
           call amopen(ioutc, pdbout, owrite,  'F',  'W')
      endif
C
      IF(IOPT.NE.2) GO TO 9
C
C     ----- ONLY OUTPUT THE COORDINATES -----
C
      DO 301 JRES = NFIRST,NLAST
      NF = IPRES(JRES)
      NS = IPRES(JRES+1)-1
C
C     ---- ADDED 8/1/83 FOR DOUBLE PRECISION OUTPUT OF COORDINATES. ----
C                                          
      DO 302 I = NF,NS
c
c  ---For output, assume that there are no two-character atom names
c     (like FE or CA).  Then, according to Brookhaven rules,
c     column 13 will be blank, and the name will be left-justified
c     starting in column 14.  UNLESS, the name is four characters
c     long!  In that case, wrap around the final character into
c     column 13.
c
           atnam = '    '
           write(tmpnam,'(a4)') igraph(i)
           atnam(2:4) = tmpnam(1:3)
           if (tmpnam(4:4) .ne. ' ') atnam(1:1) = tmpnam(4:4)
           write(resnam,'(a3)') labres(jres)
c
c   --- here are some more Brookhaven wraparounds:
c       This gives files that look very much like Brookhaven, EXCEPT
c       that they use "1" and "2" for beta-protons (for example)
c       whereas the standard Amber database (along with many in
c       the NMR field) use "2" and "3", i.e. we have 2HB and 3HB,
c       whereas Brookhaven files use 1HB and 2HB.
c
           if (atnam(1:2) .eq. ' H' .and. 
     .         (atnam(4:4) .eq. '1' .or. atnam(4:4).eq.'2' .or.
     .          atnam(4:4) .eq. '3') .and.
     .         (atnam(2:3) .eq. 'HB' .or. (resnam .ne. 'PHE'
     .              .and. resnam .ne. 'TYR' .and. resnam .ne. 'TRP'
     .              .and. resnam(1:2) .ne. 'HI'))) then
             atnam(1:1) = atnam(4:4)
             atnam(4:4) = ' '
           end if
           IF(IDBL.EQ.0) WRITE(IOUTC,303) I,atnam,LABRES(JRES),JRES,
     $                               R(I),THETA(I),PHI(I),CHRG(I)
           IF(IDBL.NE.0) WRITE(IOUTC,310) I,atnam,LABRES(JRES),JRES,
     $                               R(I),THETA(I),PHI(I),CHRG(I)
  302 CONTINUE
  301 CONTINUE
C
      GO TO 900
C
C     ----- REPLACE AND OUTPUT THE COORDINATES -----
C
    9 CONTINUE
C
*     CALL FOPEN(IN3,0,0,1)
C
      WRITE(IOUT,10) NFIRST,NLAST
      NF = IPRES(NFIRST)
      NS = IPRES(NLAST+1)-1
      NT = NS-NF+1
      DO 20 I = 1,NT
      IATSUB(I) = .FALSE.
   20 CONTINUE
      NFF = NF
      NF = NFIRST
      JPRE = -999
C
C     ----- READ THE COORDINATES -----
C
c              first, save the original phi angles:
c
      do 320 i=1,NTOTAT
        phi0(i) = phi(i)
  320 continue
      LASCRD = .FALSE.
      DO 30 I = 1, 99999
           call pdbrd(in3,iout,iatnum,jgraph,jresna,jresnu,x1,y1,z1,
     $                 lascrd)
           IF (LASCRD) GO TO 500
           IF (JRESNU .EQ. JPRE) GO TO 43
           IF (NF.GT.NLAST) GO TO 34
C
C          --- New behavior for Rev A:  If LINK topology res name doesn't
c              match the PDB residue name, we stop. ---
C
           LABEL = LABRES(nf)
           IF (LABEL .EQ. JRESNA) GO TO 32
C
C          ----- MATCH SPECIFIC LABELS TO GENERAL RESIDUE NAME -----
C
           IF (LABEL .EQ. ICYX) then
                write(iout,'(2x,a,a4,i5,a,a4)') 'PDB Residue ',jresna,
     $          nf,' taken to be ',label
                LABEL = ICYS
           endif
           IF (LABEL .EQ. IHID) then
                write(iout,'(2x,a,a4,i5,a,a4)') 'PDB Residue ',jresna,
     $          nf,' taken to be ',label
                LABEL = IHIS
           endif
           IF (LABEL .EQ. IHIP) then
                write(iout,'(2x,a,a4,i5,a,a4)') 'PDB Residue ',jresna,
     $          nf,' taken to be ',label
                LABEL = IHIS
           endif
           IF (LABEL .EQ. IHIE) then
                write(iout,'(2x,a,a4,i5,a,a4)') 'PDB Residue ',jresna,
     $          nf,' taken to be ',label
                LABEL = IHIS
           endif
           IF (LABEL .EQ. JRESNA) GO TO 32
c
c          --- The LINK topology didn't match the PDB sequence ---
c
           write(iout,'(/,2x,a,i5,a,a4,a,a4)')
     $           'FATAL: At Res number',nf,' LINK residue ',
     $           LABRES(NF),' does not match PDB res ',JRESNA
           call mexit(iout, 1)
c
   32      continue
           NST = IPRES(nf)         
           NFI = IPRES(nf+1)-1
           nf = nf + 1
           JPRE = JRESNU
   43      CONTINUE
C
C          ----- SEARCH OVER ATOMS OF RESIDUE FOR MATCH -----
C
           DO 33 J = NST, NFI
             IF (IGRAPH(J) .EQ. JGRAPH) GO TO 35
   33      CONTINUE
   34      continue
           WRITE(IOUT,100) I,JGRAPH,JRESNA,JRESNU,X1,Y1,Z1
           GO TO 30
   35      CONTINUE
           INUMA = J-NFF+1
           IATSUB(INUMA) = .TRUE.
           IF (IOPT .EQ. 0) GO TO 59
C          this code should never be reached - see above.
C          WRITE(IOUTC,303) I,JGRAPH,JRESNA,JRESNU,R(J),THETA(J),
           GO TO 61
   59      CONTINUE
           R(J) = X1
           THETA(J) = Y1
           PHI(J) = Z1
   61      CONTINUE
   30 CONTINUE
  500 CONTINUE
C
      IF(IOPT .EQ. 1) GO TO 900
C
C     ----------------------------------------------------------------
C
C                         WARNING
C
C       IF MORE THAN 1 MOLECULE DONE AT SAME TIME - THIS SECTION
C       MAY INCORRECTLY PLACE ATOMS AT THE BEGINNING OF A MOLECULE THAT
C       ARE MISSING IN THE PROTEIN DATA BANK FILE - THE USER MUST PAY
C       CLOSE ATTENTION TO ATOMS AT THE BEGINNING OF MOLECULES *****
C       TO CORRECT THIS - THIS SECTION MUST KNOW WHETHER A JOIN VALUE
C       REFERS TO A BONDED ATOM - THIS COULD POSSIBLY BE DONE WITH
C       "-" JOIN VALUES FOR THIS CASE
C       OR THIS SECTION COULD FIGURE OUT IF THE ATOM IS AT THE
C       BEGINNING OF  MOLECULE
C       FOR NOW  ASSUME THE CHECK IS DONE ELSEWHERE
C
C     ----------------------------------------------------------------
C
      NBGIN = IPRES(NFIRST)
      DO 50 I = NFIRST,NLAST
      NF = IPRES(I)
      NL = IPRES(I+1)-1
      IC = 0
      DO 51 J = NF,NL
      INUMA = J-NFF+1
      IF(IATSUB(INUMA)) GO TO 51
      J1 = JOIN(J)
      IF(J1.LT.NBGIN) GO TO 52
      INUMA = J1-NFF+1
      IF(.NOT.IATSUB(INUMA)) GO TO 52
      J2 = JOIN(J1)
      IF(J2.LT.NBGIN) GO TO 52
      INUMA = J2-NFF+1
      IF(.NOT.IATSUB(INUMA)) GO TO 52
      J3 = JOIN(J2)
      IF(J3.LT.NBGIN) GO TO 52
      INUMA = J3-NFF+1
      IF(.NOT.IATSUB(INUMA)) GO TO 52
C
C     ----- FIND OTHER ATOMS ATTACHED TO ATOM J1 -----
C
C           CALCULATE DIHEDRAL ANGLES OF THESE TO DETERMINE WHAT
C           DIHEDRAL ANGLE OF ATOM J SHOULD BE
C           LOOP CLOSINGS WILL NOT BE CAUGHT UNLESS BOND ARRAY IS
C           USED
C
      LN = 0
      KN = 0
      CALL FINDBA(J1,J2,NATBND,NAB)
      IF(NATBND.EQ.0) GO TO 920
      DO 170 LLL = 1,NATBND
        L = NAB(LLL)
        INUMA = L-NFF+1
        IF(IATSUB(INUMA)) THEN
C
C     ----- CALCULATE KNOWN TORSIONANGLES -----
C
          KN = KN+1
          LL = L
          CALL TORS(LL,J1,J2,J3,R,THETA,PHI,ALDIH(KN))
          phiolk(kn) = phi0(l)
        ELSE
          LN = LN+1
          LARR(LN) = L
          phioll(ln) = phi0(l)
        END IF
  170 CONTINUE
C
C     ----- IF MORE THAN 1 DIHEDRAL ANGLE ABOUT AN ATOM HAS BEEN
C           ASSIGNED USE THIS INFO TO ASSIGN REMAINING ATOMS -----
C
      NBTOT = LN+KN
C
C     ----- BRANCH FOR SP2 AND SP3 ATOMS. -----
C
      IF(NBTOT .EQ. 3) GO TO 800
      IF(NBTOT .EQ. 2) GO TO 810
      IF(NBTOT.GT.3) THEN
        WRITE(IOUT,205) J1
        GO TO 130
      END IF
      IF(KN.LT.2) GO TO 130
C
C     ----- ASSIGN REMAINING DIHEDRAL ANGLES -----
C
      IF(KN.NE.2.AND.LN.NE.1) WRITE(IOUT,157) KN,LN,
     $                         (LARR(III),III = 1,LN)
      P1 = ALDIH(1)+120.
      IF(P1.GT.360.) P1 = P1-360.
      DIFF = ABS(P1-ALDIH(2))
      IF(DIFF.LT.60.) P1 = ALDIH(1)-120.
      IF(P1.LT.0.) P1 = 360.+P1
      PHI(J) = P1
      GO TO 130
C
C     ----- ARRIVE HERE FOR SP3 ATOMS. -----
C
  800 CONTINUE
      IF (LN .EQ. 0 .OR. LN .EQ. 3) GO TO 130
      IF (LN .EQ. 2) THEN
        IS = LARR(1)
        TORS1 = ALDIH(1)
c
c   ---- code through AMBER 4.0 arbitrarily added 120. to the torsion
c          for the first atom, and subtracted 120. for the second atom.
c
c   ---- 4.1 code obtains stereochemistry from the original phi angles
c
c       TORS2 = TORS1 + 120.0
        tors2 = tors1 + phioll(1) - phiolk(1)
        IF (TORS2 .GT. 360.0) TORS2 = TORS2 - 360.0
        IF (TORS2 .LT.   0.0) TORS2 = TORS2 + 360.0
c       write(6,*) is,tors1,phioll(1),phiolk(1),tors2
        PHI(IS) = TORS2
        IS = LARR(2)
c       TORS2 = TORS1 - 120.0
        tors2 = tors1 + phioll(2) - phiolk(1)
        IF (TORS2 .GT. 360.0) TORS2 = TORS2 - 360.0
        IF (TORS2 .LT.   0.0) TORS2 = TORS2 + 360.0
c       write(6,*) is,tors1,phioll(2),phiolk(1),tors2
        PHI(IS) = TORS2
      ELSE
        IS = LARR(1)
        TORS1 = ALDIH(1)
        TORS2 = ALDIH(2)
        CIRCLE = ABS(TORS1 - TORS2)
        C1 = CIRCLE / 2.0
        C2 = (360.0 - CIRCLE) / 2.0
        CIRCLE = MAX(C1, C2)
        TORS3 = TORS1 + CIRCLE
        IF (TORS3 .GT. 360.0) TORS3 = TORS3 - 360.0
        TORS4 = TORS1 - CIRCLE
        IF (TORS4 .LT. 0.0) TORS4 = TORS4 + 360.0
        ADIF = ABS(TORS2 - TORS3)
        BDIF = ABS(TORS2 - TORS4)
        IF (BDIF .GT. ADIF) TORS3 = TORS4
        PHI(IS) = TORS3
      END IF
      GO TO 130
c
c     ---- Arrive here for sp2 atoms. ----
c
  810 CONTINUE
      IF (LN .EQ. 0 .OR. LN .EQ. 2) GO TO 130
      IS = LARR(1)
      TORS1 = ALDIH(1)
      TORS2 = TORS1 + 180.0E0
      IF (TORS2 .GT. 360.0E0) TORS2 = TORS2 - 360.0E0
      PHI(IS) = TORS2
c
  130 CONTINUE
      DO 78 L = 1,LN
        INUM = LARR(L)
C
C     ----- INTERNAL COORDINATES ONLY DEFINED FOR PATH TO ROOT OF TREE
C
        IF(JOIN(INUM).NE.J1) GO TO 78
C
        INUMA = INUM-NFF+1
        IC = IC+1
        ISTORE(IC) = IGRAPH(INUM)
        IATSUB(INUMA) = .TRUE.
        R1 = R(INUM)
        T1 = THETA(INUM)
        P1 = PHI(INUM)
        IF(NBTOT .EQ. 3) P1 = 360.0 - P1
        P2 = P1
C       IF(KN.EQ.1) P1 = P1-DDIFF
C       P2 = 360.-P1
        CALL COORD(IDUM,J3,J2,J1,INUM,R,THETA,PHI,R1,T1,P2)
   78 CONTINUE
      GO TO 51
   52 CONTINUE
      WRITE(IOUT,103) IGRAPH(J),J,I
   51 CONTINUE
      IF(IC.EQ.0) GO TO 50
      WRITE(IOUT,104) I,(ISTORE(J),J = 1,IC)
  104 FORMAT(2x,'Residue',i4,2x,'no pdb input for atoms: ',30(a4,1x))
   50 CONTINUE
  900 CONTINUE
      IF(IOPT.LE.1) CALL CLOSC(IN3)
      IF(IOPT.GT.0) CALL CLOSC(IOUTC)
      RETURN
  920 WRITE(IOUT,554)
  554 FORMAT(t2,'EDIT-F-NOJOIN, no atom attached to ',i5)
      call mexit(iout, 1)
  303 FORMAT('ATOM',2X,I5,1X,A4,1X,A3,2X,I4,4X,3F8.3,1X,F6.3)
  310 FORMAT('ATOM',2X,I5,1X,A4,1X,A3,2X,I4,4X,3F10.5,1X,F6.3)
   10 FORMAT(5X,'MATCHING OF RESIDUES STARTS WITH RESIDUE',I4,
     $       ' AND ENDS WITH RESIDUE',I4,/)
  100 FORMAT(2x,'Extra atom in xray input:',
     $       i5,1x,a4,1x, a4,1x,i5,2x,3f8.3)
  205 FORMAT(t2,'EDIT-W-4ATOMS, more than 4 atoms attached ',
     $       'to atom',i5,/)
  157 FORMAT(5X,'PROBLEMS WITH KN  = ',I5,2X,'LN  = ',
     $       I5,2X,20I4,/)                                           
  103 FORMAT(/,' WARNING: Cannot fix coordinates of',
     $        1x,a4,2x,'atom',i5,2x,'in residue',i5,/)
      END
