c    bugfixes installed:
c
c      .42  7/16/92
c
      SUBROUTINE BSOL4
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO IMMERSE THE SOLUTE MOLECULE INTO A BATH
C           OF 4 point WATER AND PUT A BOX AROUND IT -----
C
#include "sizes.h"
      COMMON/BOXPAR/IFBOX,IPTRES,NSPM,NSPSOL,BETA,BOX(3),NSP(MAXRES)
      COMMON/CORSOL/OXY(MAXWAT,3),HYDA(MAXWAT,3),HYDB(MAXWAT,3),
     $  cp(maxwat,3)
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     +             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/x(MAXATM),y(MAXATM),z(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
C
#include "files.h"
C
      DIMENSION CO(4,3),ITY(6)
      DIMENSION XC(3)
C
      DATA ITY/4HOW  ,4HHW  ,4HH1  ,4HH2  ,4HO   ,4HEP   /
      DATA KEP/4HEP  / 
      DATA IBLANK/4H     / 
      DATA LABWAT/3HTP4/ 
      DATA IEND/1HE/ 
      DATA MAIN/1HM/
      DATA IXYZ/3HXYZ/,KCION/4HCIO /
C
      WRITE(IOUT,1110)
      WRITE(IOUT,1100)
      WRITE(IOUT,1110)
C
      if (ilink.eq.1) then
        write(6,*)' *** need solute from link (ILINK needs to be 0)'
        call mexit(6,1)
      endif
      NMOLW = NMOL+1
      IFBOX = 1
      if (ioct.eq.1) then
          ifbox=2
          write(6, '(/5x," (Trimming diagonals per OCT option)",/)')
      endif
C
C     ----- PUT EACH MOLECULE DEFINED BY LINK AS ONE SUB-MOLECULE -----
C
      NSPM = 0
      JFIN = 1
      DO 140 I = 1,NMOL
      JRES = NFRESM(I+1)-NFRESM(I)
      JEND = JFIN+JRES-1
      NSPM = NSPM+1
      NSP(NSPM) = IPRES(JEND+1)-IPRES(JFIN)
      JFIN = JEND+1
  140 CONTINUE
      IPTRES = NFRESM(NMOL+1)-1
C
C     ----- DEFINE ALL THE SOLVENT MOLECULES AND THE COUNTER ION
C           IF ANY FOR GATHERING INTO THE BOX -----
C
      NSPSOL = 0
      DO 160 I = 1,NMOL
      JRES = NFRESM(I)
      IF(LABRES(JRES).EQ.KCION) GO TO 180
      NSPSOL = NSPSOL+1
  160 CONTINUE
  180 CONTINUE
      NSPSOL = NSPSOL+1
C
C     ----- DISO = DISTANCE ABOUT WATER OXYGEN THAT CONTACT WITH SOLUTE
C                  IS CHECKED
C           DISH = DISTANCE ABOUT WATER HYDROGEN THAT CONTACT WITH SOLUT
C                  IS CHECKED
C           QH   = CHARGE ON EACH HYDROGEN
C
      READ(IN,9108) KH,KO,NCUBE
      READ(IN,9118) QH,DISO,DISH
      IF(KH.EQ.IBLANK) KH = ITY(2)
      IF(KO.EQ.IBLANK) KO = ITY(1)
      IF(NCUBE.LE.0) NCUBE = 3
      QO  = 0.0 
      Qep = -2.0E0*QH
      WRITE (IOUT,1070) DISO
      WRITE (IOUT,1080) DISH
      WRITE (IOUT,1090) QH, QO, qep
      WRITE(IOUT,1180) KH,KO
      WRITE(IOUT,1190) NCUBE
      DISO = DISO * DISO
      DISH = DISH * DISH
C
      IWAT = 0
      XC(1) = 0.0
      XC(2) = 0.0
      XC(3) = 0.0
      AWT = 0.0
C
      READ(IN,9118) CUTX,CUTY,CUTZ,CUTD
      if (ioct.eq.1) then
          WRITE(IOUT,1051) CUTX,CUTY,CUTZ,CUTD
      else
          WRITE(IOUT,1050) CUTX,CUTY,CUTZ
      endif
      NORIGT = NTOTAT
C
C     ----- ORIENT THE SOLUTE ALONG THE PRINCIPAL AXES -----
C
      CALL MOVECM(NORIGT,x,y,z,1)
C
C     ----- READ IN THE SOLVENT COORDINATES FROM A MONTE CARLO
C           SIMULATION. -----
C
      IN6 = 35
c
c     subroutine amopen(lun,fname,fstat,fform,facc)
      call amopen(IN6, boxfil, 'O', 'F', 'R')
      CALL MCPDB4(NWATER,IN6,NCUBE,BOXL,IOUT)
      CALL CLOSC(IN6)
      WRITE (IOUT,1010) NWATER
C
C     ----- GET THE MAXIMA AND MINIMA OF THE COORDINATES -----
C
      XMIN = GCMIN(NORIGT,x)-CUTX
      YMIN = GCMIN(NORIGT,y)-CUTY
      ZMIN = GCMIN(NORIGT,z)-CUTZ
      XMAX = GCMAX(NORIGT,x)+CUTX
      YMAX = GCMAX(NORIGT,y)+CUTY
      ZMAX = GCMAX(NORIGT,z)+CUTZ
C
      BOX(1) = XMAX-XMIN
      BOX(2) = YMAX-YMIN
      BOX(3) = ZMAX-ZMIN
      BETA = 90.0E0
      if (ioct.eq.1) then
          call octcheck(norigt, r, theta, phi, box,           
     +                  xmin,ymin,zmin,      
     +                  xmax,ymax,zmax,cutd) 
      endif
c
      ierr = 0
      IF (BOX(1).GT.BOXL) then
          write(iout,1052) "X", box(1), boxl
          ierr = 1
      endif
      IF (BOX(2).GT.BOXL) then
          write(iout,1052) "Y", box(2), boxl
          ierr = 1
      endif
      IF (BOX(3).GT.BOXL) then
          write(iout,1052) "X", box(3), boxl
          ierr = 1
      endif
      if (ierr.eq.1) then
          write(6,*) '-- Increase NCUBE or decrease CUT/XYZD'
          call mexit(6,1)
      endif
C
C     ----- CALCULATE THE CENTER OF MASS OF THE SOLVENT. -----
C
      ox = 0.0
      oy = 0.0
      oz = 0.0
      DO 120 I = 1, NWATER
        OX = OX + OXY(I,1)
        OY = OY + OXY(I,2)
        OZ = OZ + OXY(I,3)
  120 CONTINUE
      DUM = FLOAT(NWATER)
      OX = OX/DUM
      OY = OY/DUM
      OZ = OZ/DUM
      XC(1) = XC(1) - OX
      XC(2) = XC(2) - OY
      XC(3) = XC(3) - OZ
C
C     ---- MAIN DO LOOP. ----
C
      DO 74 I = 1, NWATER
C
        DO 100 JATOM = 1, 3
          CO(1,JATOM) = OXY(I,JATOM) + XC(JATOM)
          CO(2,JATOM) = HYDA(I,JATOM) + XC(JATOM)
          CO(3,JATOM) = HYDB(I,JATOM) + XC(JATOM)
          CO(4,JATOM) = cp(I,JATOM) + XC(JATOM)
  100   CONTINUE
C
C       ----- SKIP THE WATER MOLECULE IF IT IS OUTSIDE -----
C
c       ----- first, the rectilinear clip -----
c
        IF((CO(1,1).GT.XMAX .OR. CO(1,1).LT.XMIN) .OR. (CO(2,1).GT.XMAX
     +    .OR. CO(2,1).LT.XMIN) .OR. (CO(3,1).GT.XMAX .OR. CO(3,1)
     +    .LT.XMIN)) GO TO 74
C
        IF((CO(1,2).GT.YMAX .OR. CO(1,2).LT.YMIN) .OR. (CO(2,2).GT.YMAX
     +    .OR. CO(2,2).LT.YMIN) .OR. (CO(3,2).GT.YMAX .OR. CO(3,2)
     +    .LT.YMIN)) GO TO 74
C
        IF((CO(1,3).GT.ZMAX .OR. CO(1,3).LT.ZMIN) .OR. (CO(2,3).GT.ZMAX
     +    .OR. CO(2,3).LT.ZMIN) .OR. (CO(3,3).GT.ZMAX .OR. CO(3,3)
     +    .LT.ZMIN)) GO TO 74
c
c       ----- additional boundaries if truncated octahedron -----
c
        if (ioct.eq.1) then
          IF((ABS((CO(1,1)-XMIN)/(XMAX-XMIN)-0.5)+
     .       ABS((CO(1,2)-YMIN)/(YMAX-YMIN)-0.5)+
     .       ABS((CO(1,3)-ZMIN)/(ZMAX-ZMIN)-0.5)) .gt. 0.75 ) GO TO 74
          IF((ABS((CO(2,1)-XMIN)/(XMAX-XMIN)-0.5)+
     .       ABS((CO(2,2)-YMIN)/(YMAX-YMIN)-0.5)+
     .       ABS((CO(2,3)-ZMIN)/(ZMAX-ZMIN)-0.5)) .gt. 0.75 ) GO TO 74
          IF((ABS((CO(3,1)-XMIN)/(XMAX-XMIN)-0.5)+
     .       ABS((CO(3,2)-YMIN)/(YMAX-YMIN)-0.5)+
     .       ABS((CO(3,3)-ZMIN)/(ZMAX-ZMIN)-0.5)) .gt. 0.75 ) GO TO 74
        endif
C
C       ----- SKIP THE WATER IF IT IS BUMPING INTO THE SOLUTE -----
C
        DDO = 9999.0
        DDH = 9999.0
C
C       ----- CHECK DISTANCE ABOUT OXYGEN AND BOTH HYDROGENS. -----
C
        DO 4 J = 1,NORIGT
C
          RSQ = (CO(1,1)-y(J))**2+(CO(1,2)-y(J))**2+
     +         (CO(1,3)-z(J))**2
          IF(RSQ .LT. DDO) DDO = RSQ
C
C         ----- IF DISH IS SMALL SKIP THIS CRITERION -----
C
          IF(DISH.gt.1.0E-03) then
            D = (CO(2,1)-x(J))**2+(CO(2,2)-y(J))**2+(CO(2,3)-z(J))**2
            IF(D .LT. DDH) DDH = D
            D = (CO(3,1)-x(J))**2+(CO(3,2)-y(J))**2+(CO(3,3)-z(J))**2
            IF(D .LT. DDH) DDH = D
          endif
    4   CONTINUE
C
        IF(DDO .LT. DISO) GO TO 74
        IF(DDH .LT. DISH) GO TO 74
C
C       ----- THE WATER IS THE RIGHT STUFF -----
C
        IWAT = IWAT + 1
C
        DO 5 K = 1,4
          x(NTOTAT+K) = CO(K,1)
          y(NTOTAT+K) = CO(K,2)
          z(NTOTAT+K) = CO(K,3)
    5   CONTINUE
        NTOT = NTOTAT
        NTOT1 = NTOTAT+1
        NTOT2 = NTOTAT+2
        NTOT3 = NTOTAT+3
        NTOTAT = NTOTAT+4
c
        JOIN(NTOT1) = NTOT-3
        JOIN(NTOT2) = NTOT1
        JOIN(NTOT3) = NTOT1
        JOIN(NTOTAT) = NTOT1
c
        IB(NBOND+1) = NTOT1
        JB(NBOND+1) = NTOT2
c
        IB(NBOND+2) = NTOT1
        JB(NBOND+2) = NTOT3 
c
        IB(NBOND+3) = NTOT1
        JB(NBOND+3) = NTOTAT
c
        IB(NBOND+4) = NTOT2
        JB(NBOND+4) = NTOT3 

        IB(NBOND+5) = NTOT2
        JB(NBOND+5) = NTOTAT
c
        IB(NBOND+6) = NTOT3
        JB(NBOND+6) = NTOTAT
c
        NBOND = NBOND + 6
c
        isymbl(ntot1) = ko
        ISYMBL(NTOT2) = KH
        ISYMBL(NTOT3) = KH
        isymbl(ntotat) = kep
c
        IGRAPH(NTOT1) = ITY(5)
        IGRAPH(NTOT2) = ITY(3)
        IGRAPH(NTOT3) = ITY(4)
        IGRAPH(NTOTAT) = ITY(6)
    
c
        CHRG(NTOT1) = QO
        CHRG(NTOT2) = QH
        CHRG(NTOT3) = QH
        CHRG(NTOTAT) = QEP
c
        ITREE(NTOT1) = MAIN
        ITREE(NTOT2) = IEND
        ITREE(NTOT3) = IEND
        ITREE(NTOTAT) = IEND
c
        IROTAT(NTOT1) = NTOTAT
        IROTAT(NTOT2) = NTOT2
        IROTAT(NTOT3) = NTOT3
        IROTAT(NTOTAT) = NTOTAT
c
        NUMEX(NTOT1) = 3
        NUMEX(NTOT2) = 2
        NUMEX(NTOT3) = 1
        NUMEX(NTOTAT) = 1
c
        NEXT1 = NEXT+1
        NEXT2 = NEXT+2
        NEXT3 = NEXT+3
        NEXT4 = NEXT+4
        NEXT5 = NEXT+5
        NEXT6 = NEXT+6
        NEXT = NEXT+7
c
        NATEX(NEXT1) = NTOT2
        NATEX(NEXT2) = NTOT3
        NATEX(NEXT3) = NTOTAT
        NATEX(NEXT4) = NTOT3 
        NATEX(NEXT5) = NTOTAT
        NATEX(NEXT6) = NTOTAT
        NATEX(NEXT) = 0
C
C       ----- MAKE EACH OF THESE WATERS A SINGLE RESIDUE -----
C
        NTOTRS = NTOTRS+1
        IF(NTOTRS.GE.MAXRES) GO TO 900
        LABRES(NTOTRS) = LABWAT
        ITRES(NTOTRS) = IXYZ
        IBRES(NTOTRS+1) = NBOND+1
        IPRES(NTOTRS+1) = NTOTAT+1
        NSPM = NSPM+1
        NSP(NSPM) = 4
   74 CONTINUE
c
c     -- end loop over waters
C
C     ----- UPDATE THE MOLECULE INFORMATION ARRAY -----
C
      NFRESM(NMOLW+1) = NTOTRS+1
      IBOND(NMOLW+1) = NBOND+1
      ITHETA(NMOLW+1) = NTHETA+1
      IPHI(NMOLW+1) = NPHI+1
      NATML(NMOLW) = NTOTAT
      MOLTYP(NMOLW) = 4
      NMOL = NMOL+1
C
C     ----- PUT THE BOX IN THE POSITIVE QUADRANT -----
c     - add some clearance to prevent boundary overlaps -
C                
      XMIN = GCMIN(NTOTAT,x)
      YMIN = GCMIN(NTOTAT,y)
      ZMIN = GCMIN(NTOTAT,z)
      DO 82 I = 1,NTOTAT
        x(I) = x(I)-XMIN + 0.2e0
        y(I) = y(I)-YMIN + 0.2e0
        z(I) = z(I)-ZMIN + 0.2e0
   82 CONTINUE
      box(1) = box(1) + 0.4e0
      box(2) = box(2) + 0.4e0
      box(3) = box(3) + 0.4e0
C
      CGTOT = 0.
      DO 55 I = 1,NTOTAT
        IF(ISYMBL(I).EQ.ISYMDU) GO TO 55
        CGTOT = CGTOT+CHRG(I)
   55 CONTINUE
      WRITE (IOUT,1120) IWAT
      WRITE(IOUT,270) CGTOT                             
      WRITE(IOUT,9438) BOX(1),BOX(2),BOX(3)
      WRITE(IOUT,9448) NSPM
C     WRITE(IOUT,9458) (NSP(I),I=1,NSPM)
      WRITE(IOUT,9468) IPTRES,NSPSOL
      RETURN
  900 CONTINUE
      WRITE(IOUT,9508) NTOTRS
      call mexit(iout, 1)
  270 FORMAT(/,t2,'TOTAL CHARGE ON MOLECULE  = ',F9.3,/)
 1010 FORMAT (/,t2,i6,' WATER MOLECULES ARE INITIALLY CONSIDERED')
 1040 FORMAT(3I5)
 1050 FORMAT(/,T2,'CUTOFF CRITERION FOR DISCARDING THE WATER',
     +       /,T2,'CUTX =',F10.4,2X,'CUTY =',F10.4,2X,'CUTZ =',F10.4,/)
 1051 FORMAT(/,5X,'CUTOFF CRITERION FOR DISCARDING THE WATER:',
     +       /,5X,'CUTX =',F10.4,2X,'CUTY =',F10.4,2X,'CUTZ =',F10.4,
     +        2X,'CUTD =',F10.4,/)
 1052 FORMAT(/,1x,'** SOLUTE + ',a,' CLEARANCE = ',f8.3,
     +          ': EXCEEDS TOTAL BOX DIMENSION: ', f8.3)
 1070 FORMAT (/,t2,'ANY WATER WITH AN OXYGEN DISTANCE LESS THAN ',F6.2,
     +        ' ANGSTROMS',/,t2,'FROM THE SOLUTE WILL BE DISCARDED')
 1080 FORMAT (/,t2,'ANY WATER WITH A HYDROGEN DISTANCE LESS THAN ',
     +       F6.2,' ANGSTROMS',/,t2,'FROM THE SOLUTE WILL BE DISCARDED')
 1090 FORMAT (/,t2,'Q(H) = ',F5.3,5X,' Q(O) = ',
     +        F5.3,'Q(EP) = ',f6.3)
 1100 FORMAT (t2,'IMMERSING THE SOLUTE INTO A WATER BATH')
 1110 FORMAT (t2,'--------------------------------------')
 1120 FORMAT (/,t2,I4,' WATER MOLECULES ARE SOLVATING THE SOLUTE')
 1130 FORMAT (/,t2,I4,' SOLUTE ATOMS FOUND FOR CENTER OF MASS ',
     +        'CALCULATION')
 1140 FORMAT (/,t2,'NUMBER OF WATER MOLECULES CONSIDERED FROM CENTER',
     +        ' OF MASS ROUTINE = ',I4)
 1150 FORMAT (/,t2,'RESIDUES FOUND FOR COM CALCULATION:',/ /,
     +        (6X,10(1X,I4)))
 1180 FORMAT(/t2,'ATOM TYPE FOR HYDROGEN = ',A4,2X,'AND FOR OXYGEN = ',
     +        A4,/)
 1190 format(/t2,'Number of molecule water cubes to be generated ='
     +       ,I2)
 9108 FORMAT(A4,1X,A4,1X,I5)
 9118 FORMAT(5F10.5)
 9438 format(/t2,'box X =',F10.2,' box Y =',F10.2,' box Z =',F10.2)
 9448 FORMAT(/T2,'NUMBER OF SUB-MOLECULES FOR DYNAMICS =',I5,
     +       /T2,'AND THE POINTERS FOR THE SOLUTE IS',/)
 9458 FORMAT(T2,10I5)
 9468 FORMAT(/T2,'SOLUTE RESIDUE POINTER FOR SKIPPING THE BC =',I5,
     $        '(iptres)',
     +       /T2,'SUBMOLECULE INDEX FOR THE SOLVENT MOLECULE =',I5
     $       ,'(nspsol)')
 9508 FORMAT(t2,'%EDIT-F-TOOMANY, number of residues exceeded',i7)
      end
