c-----------------------------------------------------------------------
      SUBROUTINE CALINT(IF,IL)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- CONVERTS ATOMS IF TO IL FROM CARTESIAN TO INTERNAL
C           COORDINATES. DO NOT USE ROUTINE UNLESS ALL COORDINATES ARE
C           CARTESIAN. IF DO NOT CONVERT ENTIRE MOLECULE IN ONE STEP,
C           CONVERT FROM END TO BEGINNING RESIDUE -----
C
#include "sizes.h"
      COMMON/ZMAT/X(MAXATM),y(MAXATM),z(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      COMMON/IOEDIT/IN2,IN3,IN4,IFN4,IN5,IOUTC,IOUTD,IDUMPR,IP1,IP2,IP3
      COMMON/WORKA/MIXC(MAXATM),IWORK(MAXATM)
C
C     ----- THE BINARY EDIT OUTPUT FILE IS USED AS A SCRATCH FOR
C           STORING INTERNAL COORDINATES -----
C
      CALL IWIND(IOUTB)
C
      IONE = 1
      ITWO = 2
      ZERO = 0.
C
      IFF = IF
      IF(IF.GT.3) GO TO 12
      IF(IF.GT.1) GO TO 10
      IF(IDUMPR.EQ.1) GO TO 12
      WRITE(IOUTB) ZERO,ZERO,ZERO
      IFF = IFF+1
      IF(IL.LT.IFF) GO TO 50
   10 IF(IDUMPR.EQ.1) GO TO 12
      IF(IF.GT.2) GO TO 11
      CALL DIST(IONE,ITWO,X,Y,Z,R)
      WRITE(IOUTB) R,ZERO,ZERO
      IFF = IFF+1
      IF(IL.LT.IFF) GO TO 50
   11 IF(IDUMPR.EQ.1) GO TO 12
      CALL DIST(IONE,ITWO,X,Y,Z,R)
      CALL BANGLE(1,2,3,X,Y,Z,TH,IONE)
      WRITE(IOUTB) R,TH,ZERO
      IFF = IFF+1
   12 IF(IL.LT.IFF) GO TO 50
      DO 40 I = IFF,IL
      J = JOIN(I)
      IF(J.LE.0) J = IP3
      K = JOIN(J)
      IF(K.LE.0) K = IP3
      L = JOIN(K)
      IF(L.LE.0) L = IP3
      CALL DIST(I,J,X,Y,Z,R)
      CALL BANGLE(I,J,K,X,Y,Z,TH,IONE)
      CALL TORS(I,J,K,L,X,Y,Z,PH)
      WRITE(IOUTB) R,TH,PH
   40 CONTINUE
   50 CONTINUE
C
C     ----- READ BACK THE STORED VALUES -----
C
      CALL IWIND(IOUTB)
C
      DO 60 I = IF,IL
      READ(IOUTB) X(I),Y(I),Z(I)
   60 CONTINUE
      CALL IWIND(IOUTB)
      RETURN
      END
