c-----------------------------------------------------------------------
      SUBROUTINE CALXYZ(IF,IL,IFLAG)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- CONVERTS ATOMS IF TO IL FROM INTERNAL TO CARTESIAN
C           COORDINATES. ATOM 3 MUST BE CONNECTED TO ATOM 2, WHICH MUST
C           CONNECTED TO ATOM 1 -----
C
C           IFLAG = 0 TO AVOID CHECKING IF ATOMS ARE IN MIXED MODE
C           MIXC = 0 IF ATOMS COORD. ARE INTERNAL
C                = 1 IF ATOMS COORD. ARE CARTESIAN
C
#include "sizes.h"
      COMMON/CONST/PI,CONV,CONVV
      COMMON/ZMAT/X(MAXATM),Y(MAXATM),Z(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      COMMON/IOEDIT/IN2,IN3,IN4,IFN4,IN5,IOUTC,IOUTD,IDUMPR,IP1,IP2,IP3
      COMMON/WORKA/MIXC(MAXATM),IWORK(MAXATM)
C
      IONE = 1
      IFF = IF
      IF(IF.GT.3) GO TO 12
      IF(IF.GT.1) GO TO 10
      IF(IDUMPR.EQ.1) GO TO 12
      IF(IFLAG.EQ.1.AND.MIXC(1).EQ.1) GO TO 9
      X(1) = 0.
      Y(1) = 0.
      Z(1) = 0.
    9 CONTINUE
      IFF = IFF+1
      IF(IL.LT.IFF) GO TO 50
   10 IF(IDUMPR.EQ.1) GO TO 12
      IF(IF.GT.2) GO TO 11
      IF(IFLAG.EQ.1.AND.MIXC(2).EQ.1) GO TO 110
C
      Y(2) = 0.
      Z(2) = 0.
  110 CONTINUE
      IFF = IFF+1
      IF(IL.LT.IFF) GO TO 50
   11 IF(IDUMPR.EQ.1) GO TO 12
      IF(IFLAG.EQ.1.AND.MIXC(3).EQ.1) GO TO 120
      R1 = X(3)
      TH = (180.-Y(3))*CONV
      X(3) =  R1*COS(TH)+X(2)
      Y(3) = R1*SIN(TH)
      Z(3) = 0.
  120 CONTINUE
      IFF = IFF+1
   12 CONTINUE
      IF(IL.LT.IFF) GO TO 50
      DO 40 I = IFF,IL
      IF(IFLAG.EQ.1.AND.MIXC(I).EQ.1) GO TO 40
      NNC = JOIN(I)
      IF(NNC.LE.0) NNC = IP3
      NNB = JOIN(NNC)
      IF(NNB.LE.0) NNB = IP3
      NNA = JOIN(NNB)
      IF(NNA.LE.0) NNA = IP3
      R = X(I)
      TH = Y(I)
      PHI = Z(I)
      P2 = 360.-PHI
      CALL COORD(IDUM,NNA,NNB,NNC,I,X,Y,Z,R,TH,P2)
   40 CONTINUE
   50 CONTINUE
      RETURN
      END
