c-----------------------------------------------------------------------
      SUBROUTINE CONCOR(IFORM,IRES1,IRES2)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- CHECKS IF COORDINATE TRANSFORM NEEDED FOR RESIDUES IRES1 TO
C           IRES2. FOR TRANSFORMS NOT INVOLVING RESIDUES, THIS ROUTINE
C           CAN BE BYPASSED AND CALINT AND CALXYZ CALLED DIRECTLY
C
#include "sizes.h"
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     $             IBRES(MAXRES),IPRES(MAXRES)
C
      DATA IXYZ /3HXYZ /
      DATA IINT /3HINT /
      DATA IMIX /3HMIX /
C
      DO 30 I = IRES1,IRES2
      IF(ITRES(I).NE.IFORM) GO TO 31
   30 CONTINUE
C
C     ----- NO TRANSFORMATION NEEDED -----
C
      GO TO 500
   31 CONTINUE
      IRESF = 1
C
C     ----- IF INTERNAL COORDINATES ARE WANTED - MUST CONVERT EVERYTHING
C           BEFORE TO CARTESIAN COORDINATES SINCE THESE COORDINATES ARE
C           NEEDED FOR TRANSFORMATION -----
C
C           CONVERT TO CARTESIAN COORDINATES
C           EVERY RESIDUE BEFORE ONE CONVERTING MUST BE CONVERTED INTO
C           CARTESIAN COORDINATES ALSO
C           IF CONVERTING A MOLECULE THAT IS ONLY ATTACHED TO DUMMY
C           ATOMS OF MOLECULE 1 , THIS ROUTINE CAN BE MODIFIED TO AVOID
C           CONVERTING ALL OF MOLECULE 1
C
      IF = IPRES(IRESF)
      DO 41 I = IRESF,IRES2
      IL = IPRES(I+1)-1
      IF(ITRES(I).EQ.IXYZ) GO TO 42
      IFLAG = 0
      IF(ITRES(I).EQ.IMIX) IFLAG = 1
      CALL CALXYZ(IF,IL,IFLAG)
      ITRES(I) = IXYZ
   42 IF = IL+1
   41 CONTINUE
      IF(IFORM.EQ.IXYZ) GO TO 500
      JONE = IPRES(IRES1)
      NLAST = IPRES(IRES2+1)-1
      CALL CALINT(JONE,NLAST)
      DO 419 I = IRES1,IRES2
      ITRES(I) = IINT
  419 CONTINUE
  500 CONTINUE
      RETURN
      END
