c-----------------------------------------------------------------------
      SUBROUTINE COORD(NAT,NA,NB,NC,ND,XX,YY,ZZ,R,SANG,SDIH)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
      COMMON/CONST/PI,CONV,CONVV
      DIMENSION XX(*),YY(*),ZZ(*)
C
      ANG = SANG*CONV
      DIHANG = SDIH*CONV
      PHABCD = DIHANG
      RCD = R
      THBCD = ANG
C
C     ----- MOVE ATOM C TO ORIGIN -----
C
      XA = XX(NA)-XX(NC)
      YA = YY(NA)-YY(NC)
      ZA = ZZ(NA)-ZZ(NC)
      XB = XX(NB)-XX(NC)
      YB = YY(NB)-YY(NC)
      ZB = ZZ(NB)-ZZ(NC)
C
C     ----- ROTATE ABOUT Z-AXIS TO MAKE YB = 0, XB POSITIVE. IF XYB IS
C           TOO SMALL, ROTATE FIRST 90 DEGREES ABOUT THE Y AXIS -----
C
      XYB = SQRT(XB**2+YB**2)
      K = 1
      IF(XYB-0.1) 9,10,10
    9 K = 0
      XPA = ZA
      ZPA = -XA
      XA = XPA
      ZA = ZPA
      XPB = ZB
      ZPB = -XB
      XB = XPB
      ZB = ZPB
      XYB = SQRT(XB**2+YB**2)
   10 COSTH = XB/XYB
      SINTH = YB/XYB
      XPA = XA*COSTH+YA*SINTH
      YPA = YA*COSTH-XA*SINTH
C
C     ----- ROTATE ABOUT THE Y AXIS TO MAKE ZB VANISH -----
C
      RBC = SQRT(XB**2+YB**2+ZB**2)
      SINPH = ZB/RBC
      COSPH = SQRT(1.0-SINPH**2)
      XQA = XPA*COSPH+ZA*SINPH
      ZQA = ZA*COSPH-XPA*SINPH
C
C     ----- ROTATE ABOUT X-AXIS TO MAKE ZA = 0,YA POSITIVE -----
C
      YZA = SQRT(YPA**2+ZQA**2)
      COSKH = YPA/YZA
      SINKH = ZQA/YZA
C
C     ----- THE COORDINATES OF A,B, AND C ARE =  (XQA,YZA,0),(RBC,0,0)
C           AND (0,0,0), RESPECTIVELY. THE COORDINATES OF D ARE NOW
C           CALCULATED IN THE NEW FRAME -----
C
      SINA = SIN(THBCD)
      COSA = COS(THBCD)
      SIND = SIN(PHABCD)
      COSD = COS(PHABCD)
      XD = RCD*COSA
      YD = RCD*SINA*COSD
      ZD = RCD*SINA*SIND
C
C     ----- TRANSFORM COORDINATES OF D BACK TO ORIGINAL SYSTEM -----
C
      YPD = YD*COSKH-ZD*SINKH
      ZPD = ZD*COSKH+YD*SINKH
      XPD = XD*COSPH-ZPD*SINPH
      ZQD = ZPD*COSPH + XD*SINPH
      XQD = XPD*COSTH-YPD*SINTH
      YQD = YPD*COSTH+XPD*SINTH
      IF(K-1) 31,32,31
   31 XRD = -ZQD
      ZRD = XQD
      XQD = XRD
      ZQD = ZRD
   32 XX(ND) = XQD+XX(NC)
      YY(ND) = YQD+YY(NC)
      ZZ(ND) = ZQD+ZZ(NC)
      RETURN
      END
