c-----------------------------------------------------------------------
      SUBROUTINE EDITDU
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- REMOVES ALL DUMMY ATOMS FROM MOLECULE
C           THIS ROUTINE SHOULD ONLY BE USED IF XYZ COORDINATES ARE TO
C           BE  MINIMIZED
C           ASSUMES ALL RESIDUES PRESENT HAVE AT LEAST 1 REAL ATOM
C           IF THIS IS NOT TRUE,SEVERAL OTHER ARRAYS SUCH AS ICROS MUST
C           BE CHANGED -----
C
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     $            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     $            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     $             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
C
      DATA MAIN /1HM/
C
      IA = 0
      IACT = 0
      INEXT = 0
      DO 11 I = 1,NTOTAT
      NATN(I) = -99
      NT = NUMEX(I)
      IF(ISYMBL(I).EQ.ISYMDU) GO TO 10
      IA = IA+1
      NATN(I) = IA
      R(IA) = R(I)
      THETA(IA) = THETA(I)
      PHI(IA) = PHI(I)
      CHRG(IA) = CHRG(I)
      JOIN(IA) = JOIN(I)
      IROTAT(IA) = IROTAT(I)
      IGRAPH(IA) = IGRAPH(I)
      ISYMBL(IA) = ISYMBL(I)
      ITREE(IA) = ITREE(I)
      NUMEX(IA) = NT
      NACT = IACT
      DO 20 J = 1,NT
      INEXT = INEXT+1
      NACT = NACT+1
      NATEX(INEXT) = NATEX(NACT)
   20 CONTINUE
   10 IACT = IACT+NT
   11 CONTINUE
      NTOTAT = IA
      NEXT = INEXT
C
      CALL CHNG(IB,NATN,NBOND)
      CALL CHNG(JB,NATN,NBOND)
      CALL CHNG(IT,NATN,NTHETA)
      CALL CHNG(JT,NATN,NTHETA)
      CALL CHNG(KT,NATN,NTHETA)
      CALL CHNG(IP,NATN,NPHI)
      CALL CHNG(JP,NATN,NPHI)
      CALL CHNG(KP,NATN,NPHI)
      CALL CHNG(LP,NATN,NPHI)
      CALL CHNG(JOIN,NATN,NTOTAT)
      CALL CHNG(NATEX,NATN,NEXT)
C
      DO 60 I = 1,NMOL
      JJ = NATML(I)
      JSTART = 1
      IF(I.GT.1) JSTART = NATML(I-1)+1
   61 CONTINUE
      KK = NATN(JJ)
      IF(KK.GT.0) GO TO 70
      JJ = JJ-1
      IF(JJ.GE.JSTART) GO TO 61
      WRITE(IOUT,99) I
      GO TO 500
   70 CONTINUE
      NATML(I) = KK
C
   60 CONTINUE
      DO 80 I = 1,NTOTRS
      JJ = IPRES(I)
      JPP = IPRES(I+1)
   82 KK = NATN(JJ)
      IF(KK.GT.0) GO TO 81
      JJ = JJ+1
      IF(JJ.LT.JPP) GO TO 82
      WRITE(IOUT,84) I
      GO TO 500
   81 IPRES(I) = KK
   80 CONTINUE
      IPRES(NTOTRS+1) = NTOTAT+1
      DO 90 I = 1,NTOTAT
      JJ = IROTAT(I)
   92 KK = NATN(JJ)
      IF(KK.GT.0) GO TO 91
      JJ = JJ-1
      IF(JJ.GT.0) GO TO 92
      WRITE(IOUT,95) I,JJ
      GO TO 500
   91 CONTINUE
      IROTAT(I) = KK
   90 CONTINUE
      RETURN
  500 CONTINUE
      call mexit(iout, 1)
   99 FORMAT(t2,'EDIT-F-NOATOMS, no real atoms found',
     $      ' in molecule ',i5)
   84 FORMAT(t2,'EDIT-F-NOREAL, no real atoms in residue')
   95 FORMAT(t2,'EDIT-F-CONFUSED, problems with atom',i5,
     $       ' with irotat  = ',i5)
      END
