c-----------------------------------------------------------------------
      subroutine edtfil
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c     Author: George Seibel
*     implicit none
c
c     OUTPUT: (to common)
c
#include "files.h"
c
c        EDIT files as described in amber v 3.0 Rev A documentation
c
c     INTERNAL:
c
      character*80 arg
c        ... temp for each of the whitespace delimited command line words
      integer iarg, narg
c        ... arg pointer, final number of arguments
c
c     --- default file names ---
c
      input  = 'input'
      output = 'output'
      lnkbin = 'lnkbin'
      edtbin = 'edtbin'
      pdbin  = 'pdbin'
      pdbout = 'pdbout'
      addfil = 'addfil'
      boxfil = 'boxfil'
      zmat   = 'zmat'
      solv   = 'solv'
c
c     --- default status for output: new
c
      owrite = 'N'

#ifndef NOGETARG
c
c     --- get com line arguments ---
c
# ifdef HITACHI_GETARG
      iarg = 1
# else
      iarg = 0
# endif
      indx = iargc()
   10 continue
           iarg = iarg + 1
           call getarg(iarg,arg)
           if (arg .eq. '-i') then
                iarg = iarg + 1
                call getarg(iarg,input)
           elseif (arg .eq. '-o') then
                iarg = iarg + 1
                call getarg(iarg,output)
           elseif (arg .eq. '-l' .or. arg .eq. '-t') then
                iarg = iarg + 1
                call getarg(iarg,lnkbin)
           elseif (arg .eq. '-e' .or. arg .eq. '-p') then
                iarg = iarg + 1
                call getarg(iarg,edtbin)
           elseif (arg .eq. '-pi' .or. arg .eq. '-x') then
                iarg = iarg + 1
                call getarg(iarg,pdbin)
           elseif (arg .eq. '-po' .or. arg .eq. '-q') then
                iarg = iarg + 1
                call getarg(iarg,pdbout)
           elseif (arg .eq. '-a') then
                iarg = iarg + 1
                call getarg(iarg,addfil)
           elseif (arg .eq. '-b') then
                iarg = iarg + 1
                call getarg(iarg,boxfil)
           elseif (arg .eq. '-z') then
                iarg = iarg + 1
                call getarg(iarg,zmat)
           elseif (arg .eq. '-s') then
                iarg = iarg + 1
                call getarg(iarg,solv)
           elseif (arg .eq. '-O') then
                owrite = 'U'
           else
                if (arg .eq. ' ') go to 20
                write(6,'(/,5x,a,a)') 'unknown flag: ',arg
                write(6,9000)
                call mexit(6, 1)
           endif
      if (iarg .lt. indx) go to 10
c
   20 continue
      narg = iarg - 1
      if (narg .lt. 2) then
           write(6,9000)
           call mexit(6, 1)
      endif
c
#endif
      return
 9000 format(
     $    /2x,'usage: edit  [-O] -i input -o output -l lnkbin -e edtbin',
     $    /14x,'[-pi pdbin -po pdbout -a addwat -b boxfil -z zmat '
     $                ,'-s solv]')
      end
