c-----------------------------------------------------------------------
      subroutine expand(nsolvat,nsolvres,solvs,boxx,boxy,boxz,scale)
      dimension solvs(3,*)
      dimension s0(3,100),r0(3,100)

c expand one molecule into a crystal

      dmax = 2.0
        do jn = 1,nsolvat-1
           do kn = jn+1, nsolvat
              dist = sqrt((solvs(1,jn)-solvs(1,kn))**2+
     $                    (solvs(2,jn)-solvs(2,kn))**2+
     $                    (solvs(3,jn)-solvs(3,kn))**2)
              if(dist .gt. dmax) dmax = dist
           enddo
        enddo
        dmax = scale * dmax
        write(6,'(t5,a,f10.3)')'in expand: dmax = ',dmax

c  move the proto solvent to the origin

        xc = 0.0
        yc = 0.0
        zc = 0.0
        do jn = 1,nsolvat
           xc = xc + solvs(1,jn) 
           yc = yc + solvs(2,jn) 
           zc = zc + solvs(3,jn) 
        enddo
        xc = xc/nsolvat
        yc = yc/nsolvat
        zc = zc/nsolvat

        do jn = 1,nsolvat
            r0(1,jn) = solvs(1,jn)  - xc
            r0(2,jn) = solvs(2,jn)  - yc   
            r0(3,jn) = solvs(3,jn)  - zc  
        enddo

        molx = int(boxx/dmax)
        moly = int(boxy/dmax)
        molz = int(boxz/dmax)
c       write(6,'(t5,a,3i10)')'in expand: molx,moly,molz:',
c    $                           molx,moly,molz

        nsolvres = 0
        nats = 0
        dij =  boxx/2.d0 -dmax/2.0
        dik =  boxy/2.d0 -dmax/2.0
        dil =  boxz/2.d0 -dmax/2.0

        xjj = 0
        do jj = 1,molx
           xkk = 0
           do kk = 1,moly
              xll = 0
              do ll = 1,molz

c randomly spin the reference molecule
c put the 1st solvent in the "corner"

                 nsolvres = nsolvres + 1
c                write(6,'(t5,''solvent #:'',i5)')nsolvres
                 call reorient(nsolvat,r0,s0)
c                print *,'after reorient'
                 do jn = 1,nsolvat
                    s0(1,jn) = s0(1,jn)  - dij
                    s0(2,jn) = s0(2,jn)  - dik   
                    s0(3,jn) = s0(3,jn)  - dil  
                 enddo
                 do mm = 1,nsolvat
                    nats = nats + 1
                    solvs(1,nats) = s0(1,mm) + xjj
                    solvs(2,nats) = s0(2,mm) + xkk
                    solvs(3,nats) = s0(3,mm) + xll
                 enddo
                 xll = xll + (boxz/molz)
              enddo
              xkk = xkk + (boxy/moly)
          enddo
          xjj = xjj + (boxx/molx)
        enddo
        return
        end
