c
c------------------------------------------------------------------------
c
      SUBROUTINE floppy
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C -----routine to build pure water for md*********flexible water!!!
C
#include "sizes.h"
      COMMON/BOXPAR/IFBOX,IPTRES,NSPM,NSPSOL,BETA,BOX(3),NSP(MAXRES)
      COMMON/CORSOL/OXY(MAXWAT,3),HYDA(MAXWAT,3),HYDB(MAXWAT,3),
     $  cp(maxwat,3)
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     +             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/x(MAXATM),y(MAXATM),z(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
c
#include "files.h"
C
      DIMENSION CO(3,3),ITY(5)
C
      DATA ITY/4HOW  ,4HHW  ,4HH1  ,4HH2  ,4HO   /
      DATA IBLANK/4H     /
      DATA LABWAT/3HWAT /
      DATA IEND/1HE  /
      DATA MAIN/1HM /
      DATA IXYZ/3HXYZ  /,KCION/4HCIO /
C
      if (ioct.eq.1) then
        write(6,*) ' *** pure water - OCT not implemented'
        call mexit(6,1)
      endif
      if (ilink.ne.1) then
        write(6,*)' *** solute from link present (ILINK needs to be 1)'
        call mexit(6,1)
      endif
      NMOLW = NMOL+1      
      IFBOX = 1
      NFRESM(NMOLW) = NTOTRS+1
      IBOND(NMOLW) = NBOND+1
      ITHETA(NMOLW) = NTHETA+1
      IPHI(NMOLW) = NPHI+1
      ipres(nmolw) = 1
C
C     ----- PUT EACH MOLECULE DEFINED BY LINK AS ONE SUB-MOLECULE -----
C
      NSPM = 0
      JFIN = 1
      DO 140 I = 1,NMOL
      JRES = NFRESM(I+1)-NFRESM(I)
      JEND = JFIN+JRES-1
      NSPM = NSPM+1
      NSP(NSPM) = IPRES(JEND+1)-IPRES(JFIN)
      JFIN = JEND+1
  140 CONTINUE
      IPTRES = NFRESM(NMOL+1)-1
C
C     ----- DEFINE ALL THE SOLVENT MOLECULES AND THE COUNTER ION
C           IF ANY FOR GATHERING INTO THE BOX -----
C
      NSPSOL = 0
      DO 160 I = 1,NMOL
      JRES = NFRESM(I)
      IF(LABRES(JRES).EQ.KCION) GO TO 180
      NSPSOL = NSPSOL+1
  160 CONTINUE
  180 CONTINUE
      NSPSOL = NSPSOL+1
C
      WRITE(6,1110)
      WRITE(6,1100)
      WRITE(6,1110)
      READ(IN,9108) KH,KO,NCUBE
      READ(IN,9118) QH
      IF(KH.EQ.IBLANK) KH = ITY(2)
      IF(KO.EQ.IBLANK) KO = ITY(1)
      IF(NCUBE.LE.0) NCUBE = 3
      QO = -2.0E0*QH
      WRITE (6,1090) QH, QO
      WRITE(6,1180) KH,KO
      WRITE(6,1190) NCUBE
C
      IN6 = 35
      IWAT = 0
C
C     ----- READ IN THE SOLVENT COORDINATES FROM A MONTE CARLO
C           SIMULATION. -----
C                       
c     subroutine amopen(lun,fname,fstat,fform,facc)
      call amopen(IN6, boxfil, 'O', 'F', 'R')
      CALL MCPDB(MAXWAT,IN6,NWATER,NCUBE,BOXL,OXY,HYDA,HYDB,6)
      CALL CLOSC(IN6)
      WRITE (6,1010) NWATER
C
C     ----- GET THE MAXIMA AND MINMA OF THE COORDINATES -----
C
C
      BETA = 90.0E0
      box(1) = boxl
      box(2) = boxl
      box(3) = boxl
      NTOTAT = 0
C
C     ---- MAIN DO LOOP. ----
C
      DO 74 I = 1, NWATER
C
        DO 100 JATOM = 1, 3
          CO(1,JATOM) = OXY(I,JATOM) 
          CO(2,JATOM) = HYDA(I,JATOM)
          CO(3,JATOM) = HYDB(I,JATOM)
  100   CONTINUE
        IWAT = IWAT + 1
C
C     ----- THE WATER IS THE RIGHT STUFF -----
C
        DO 5 K = 1,3
          X(NTOTAT+K) = CO(K,1)
          Y(NTOTAT+K) = CO(K,2)
          Z(NTOTAT+K) = CO(K,3)
    5   CONTINUE
        NTOT = NTOTAT
        NTOT1 = NTOTAT+1
        NTOT2 = NTOTAT+2
        NTOTAT = NTOTAT+3
        JOIN(NTOT1) = NTOT-2
        JOIN(NTOT2) = NTOT1
        JOIN(NTOTAT) = NTOT1
c
        IB(NBOND+1) = NTOT1
        JB(NBOND+1) = NTOT2
c
        IB(NBOND+2) = NTOT1
        JB(NBOND+2) = NTOTAT
c
        NBOND = NBOND+2
c
        IT(NTHETA+1) = NTOT2
        JT(NTHETA+1) = NTOT1
        KT(NTHETA+1) = NTOTAT
C
        NTHETA = NTHETA + 1
c
        ISYMBL(NTOT1) = KO
        ISYMBL(NTOT2) = KH
        ISYMBL(NTOTAT) = KH
c
        IGRAPH(NTOT1) = ITY(5)
        IGRAPH(NTOT2) = ITY(3)
        IGRAPH(NTOTAT) = ITY(4)
c
        CHRG(NTOT1) = QO
        CHRG(NTOT2) = QH
        CHRG(NTOTAT) = QH
c
        ITREE(NTOT1) = MAIN
        ITREE(NTOT2) = IEND
        ITREE(NTOTAT) = IEND
c
        IROTAT(NTOT1) = NTOTAT
        IROTAT(NTOT2) = NTOT2
        IROTAT(NTOTAT) = NTOTAT
c
        NUMEX(NTOT1) = 2
        NUMEX(NTOT2) = 1
        NUMEX(NTOTAT) = 1
c
        NEXT1 = NEXT+1
        NEXT2 = NEXT+2
        NEXT3 = NEXT+3
        NEXT = NEXT+4
c
        NATEX(NEXT1) = NTOT2
        NATEX(NEXT2) = NTOTAT
        NATEX(NEXT3) = NTOTAT
        NATEX(NEXT) = 0
C
C       ----- MAKE EACH OF THESE WATERS A SINGLE RESIDUE -----
C           
        NTOTRS = NTOTRS+1
        IF(NTOTRS.GE.MAXRES) GO TO 900
        LABRES(NTOTRS) = LABWAT
        ITRES(NTOTRS) = IXYZ
        IBRES(NTOTRS+1) = NBOND+1
        IPRES(NTOTRS+1) = NTOTAT+1
        NSPM = NSPM+1
        NSP(NSPM) = 3
   74 CONTINUE
C
C     ----- UPDATE THE MOLECULE INFORMATION ARRAY -----
C
      NFRESM(NMOLW+1) = NTOTRS+1
      IBOND(NMOLW+1) = NBOND+1
      ITHETA(NMOLW+1) = NTHETA+1
      IPHI(NMOLW+1) = NPHI+1
      NATML(NMOLW) = NTOTAT
      MOLTYP(NMOLW) = 4
      NMOL = NMOL+1
C
C     ----- PUT THE BOX IN THE POSITIVE QUADRANT -----
c     - add some clearance to prevent boundary overlaps -
C                
      XMIN = GCMIN(NTOTAT,X)
      YMIN = GCMIN(NTOTAT,Y)
      ZMIN = GCMIN(NTOTAT,Z)
      DO 82 I = 1,NTOTAT
        x(I) = x(I)-XMIN + 0.2e0
        y(I) = y(I)-YMIN + 0.2e0
        z(I) = z(I)-ZMIN + 0.2e0
   82 CONTINUE
      box(1) = box(1) + 0.4e0
      box(2) = box(2) + 0.4e0
      box(3) = box(3) + 0.4e0
C
      CGTOT = 0.
      DO 55 I = 1,NTOTAT
      IF(ISYMBL(I).EQ.ISYMDU) GO TO 55
      CGTOT = CGTOT+CHRG(I)
   55 CONTINUE
      WRITE (6,1120) IWAT
      WRITE(6,270) CGTOT
      WRITE(6,9438) BOX(1),BOX(2),BOX(3)
      WRITE(6,9448) NSPM
      WRITE(6,9468) IPTRES,NSPSOL
      RETURN
  900 CONTINUE
      WRITE(6,9508) NTOTRS
      call mexit(6, 1)
  270 FORMAT(/,t2,'TOTAL CHARGE ON MOLECULE  = ',F9.3,/)
 1010 FORMAT (/,t2,i6,' WATER MOLECULES ARE INITIALLY CONSIDERED')
 1090 FORMAT (/,t2,'HYDROGEN CHARGE = ',F5.3,5X,' OXYGEN CHARGE = ',
     +        F5.3)
 1100 FORMAT (t2,'Generating a liquid',
     $       /T2,'of Floppy waters')
 1110 FORMAT (t2,'___________________')
 1120 FORMAT (/,t2,i6,' Water molecules comprise the liquid')
 1180 FORMAT(/t2,'ATOM TYPE FOR HYDROGEN = ',A4,2X,'AND FOR OXYGEN = ',
     +        A4,/)
 1190 format(/t2,'Number of 216 molecule water cubes to be generated ='
     +       ,I2)
 9108 FORMAT(A4,1X,A4,1X,I5)
 9118 FORMAT(5F10.5)
 9438 format(/t2,'box X =',F10.2,' box Y =',F10.2,' box Z =',F10.2)
 9448 FORMAT(/T2,'NUMBER OF SUB-MOLECULES FOR DYNAMICS =',I5,
     +       /T2,'AND THE POINTERS FOR THE SOLUTE IS',/)
 9468 FORMAT(/T2,'THE SOLUTE RESIDUE POINTER FOR SKIPPING THE BC =',I5,
     +       /T2,'THE SUBMOLECULE INDEX FOR THE SOLVENT MOLECULE =',I5)
 9508 FORMAT(t2,'%EDIT-F-TOOMANY, number of residues exceeded',i7)
      END
