c-----------------------------------------------------------------------
      SUBROUTINE GENATM(A,B,C,D,RCD,THBCD,PHABCD)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- GENERATE COORDINATES OF ATOM D; ANGLES IN RADIANS.
C           DIHEDRAL ANGLE PHABCD IS DEFINED CLOCKWISE FROM A
C           WITH A BEHIND D -----
C
      DIMENSION A(3),B(3),C(3),D(3),XP(3),YP(3),ZP(3),VCA(3),VCB(3)
C
C     ----- DETERMINE COORDINATES IN LOCAL (PRIMED) SYSTEM -----
C
      ST = SIN(THBCD)
      XPD = RCD*ST*COS(PHABCD)
      YPD = -RCD*ST*SIN(PHABCD)
      ZPD = -RCD*COS(THBCD)
C
C     ----- DETERMINE TRANSFORMATION (DIRECTION COSINE) MATRIX -----
C
      DO 10 I = 1,3
      VCA(I) = A(I)-C(I)
      VCB(I) = B(I)-C(I)
   10 CONTINUE
      CALL ACROSB(VCA,VCB,YP)
      CALL ACROSB(VCB,YP,XP)
      CALL ACROSB(XP,YP,ZP)
C
C     ----- TRANSFORM TO ORIGINAL SYSTEM CENTERED ON C AND
C           RECENTER RELATIVE TO THE ORIGIN -----
C
      D(1) = XP(1)*XPD+YP(1)*YPD+ZP(1)*ZPD+C(1)
      D(2) = XP(2)*XPD+YP(2)*YPD+ZP(2)*ZPD+C(2)
      D(3) = XP(3)*XPD+YP(3)*YPD+ZP(3)*ZPD+C(3)
      RETURN
      END
