      SUBROUTINE gensol 
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO IMMERSE THE SOLUTE MOLECULE INTO A BATH
C           OF specified solvent AND PUT A BOX AROUND IT -----
C
c
#include "sizes.h"
#include "files.h"
c
      COMMON/EXDAT/CHG(150),RTP(3,150),ITYP(3,150),MB(2,300),MT(3,350),
     $  MP(4,400),NC(150),MUMEX(150),MATEX(600),IROT(150),JPLOT(2,400),
     $  MAMRES,jTYPCO,nsolvat,jBOND,jTHETA,jPHI,jIC,jNEXT

      COMMON/BOXPAR/IFBOX,IPTRES,NSPM,NSPSOL,BETA,BOX(3),NSP(MAXRES)
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     +             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/X(MAXATM),Y(MAXATM),Z(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)

      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
 
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      dimension solvs(3,MAXATM)
c     common/bax/boxx,boxy,boxz
C
      DIMENSION CO(3,100)
      DIMENSION XC(3)
      data ixyz/4HXYZ / kcion/4HCIO /
C
      write(6,'(t5,''GENERAL solvent module'')')
      iseed = 2394823
      call amrset(iseed)
      NMOLW = NMOL+1
      IFBOX = 1
C
C     ----- PUT EACH MOLECULE DEFINED BY LINK AS ONE SUB-MOLECULE -----
C
      NSPM = 0
      JFIN = 1
      DO 140 I = 1,NMOL
      JRES = NFRESM(I+1)-NFRESM(I)
      JEND = JFIN+JRES-1
      NSPM = NSPM+1
      NSP(NSPM) = IPRES(JEND+1)-IPRES(JFIN)
      JFIN = JEND+1
  140 CONTINUE
      IPTRES = NFRESM(NMOL+1)-1
C
C     ----- DEFINE ALL THE SOLVENT MOLECULES AND THE COUNTER ION
C           IF ANY FOR GATHERING INTO THE BOX -----
C
      NSPSOL = 0
      DO 160 I = 1,NMOL
      JRES = NFRESM(I)
      IF(LABRES(JRES).EQ.KCION) GO TO 180
      NSPSOL = NSPSOL+1
  160 CONTINUE
  180 CONTINUE
      NSPSOL = NSPSOL+1
C
C
C     ----- DISS = DISTANCE ABOUT Solute THAT CONTACT WITH SOLUTE
C                  IS CHECKED
C
      kform = 0
      diss = 2.0
      scale = 1.0
      READ(IN,9119) DISS, scale,kform
 9119 FORMAT(2F10.5,i5)
      if(scale .lt.0.01) scale = 1.d0
      if(diss .lt.0.01) diss = 2.d0
      WRITE (6,1070) DISS,scale,kform
 1070 FORMAT(/,t5,'any solvent nearer THAN ',F10.5, ' ANGS ',
     $       'from the solute will be discarded'
     $       /,t5,'Solute will be expanded using ',f10.5
     $          ,' as the scale factor'
     $       /,t5,'format for solvent topology file =',i5)
      DISS = DISS * DISS
C
      IN6 = 35
      XC(1) = 0.0
      XC(2) = 0.0
      XC(3) = 0.0
C
      READ(IN,9118) CUTX,CUTY,CUTZ,ifil
      WRITE(6,1050) CUTX,CUTY,CUTZ
      if(ifil .eq. 0) then 
        write(6,'(5x,a,/)') '** form a crystalline solvent' 
      else
        write(6,'(5x,a,/)') '** read in a box of solvent molecules'
      endif

      NSolute = Ntotat
C
C     ----- ORIENT THE SOLUTE ALONG THE PRINCIPAL AXES -----
C
      call movecm(NSolute,X,Y,Z,1)
c
c  get the total size of the box based on the specified cutoffs
c
      call sizeit(nsolute,x,y,z,cutx,cuty,cutz,boxx,boxy,boxz)
C
C     ----- READ IN THE SOLVENT COORDINATES 
C
      call amopen(55,solv,'O','F','R')
      call readrs(55,kform) 
      close (unit=55)

      call amopen(54,boxfil,'O','F','R')
      call getpdb(54,solvs,nsolvat)
      if(ifil.eq.0) then
c
c       --- generate the solvent box
c
        call expand(nsolvat,nsolvres,solvs,boxx,boxy,boxz,scale)
        write (6,'(/t5,i5,a)') nsolvres,
     $      ' Solvent molecules have been generated'
      else
        write(6,'(/t5,a)') 'reading box of solvent'
        call read_equil(solvs,nsolvres,nsolvat,boxx,boxy,boxz,scale)
      endif
      close(unit=54)
c
C

C     ---- MAIN DO LOOP. ----
C
      ireject = 0
      kk = 1
      do 74 I = 1, nsolvres
C
      do  J = 1, nsolvat
         do k = 1,3
            co(k,j) = solvs(k,kk) 
         enddo
         kk = kk + 1
      enddo

C     ----- SKIP THE solvent IF IT IS BUMPING INTO THE SOLUTE -----
 
      do  J = 1,nsolute
         do k = 1,nsolvat
           rsq = (co(1,K)-x(j))**2+(co(2,K)-y(j))**2+(co(3,K)-z(j))**2
           if(rsq .lt.diss ) then
              ireject = ireject + 1
c             print *,'reject this one '
              go to 74
           endif
         enddo
      enddo

C
      isolvent = isolvent + 1
 
      if (ntotat+nsolvat .gt. MAXATM) then
           write(6,'(/,5x,a,i6,a)') 'bsol: MAXATM =',MAXATM,
     +           ' exceeded'
           call mexit(6, 1)
      endif
       
      do j = 1,nsolvat
         x(ntotat+j) = CO(1,j)
         y(ntotat+j) = CO(2,j)
         z(ntotat+j) = CO(3,j)
      enddo

      NTOT = NTOTAT
      ntotat = ntotat + nsolvat
      do jn = 1,jbond
      ipt = nbond + jn
         IB(ipt) = ntot+ mb(1,jn)
         JB(ipt) = ntot+ mb(2,jn)
      enddo
      nbond = nbond+jbond
      if(nbond.gt.MAXBND) then
         print *,'gensol: nbond= ',nbond ,' exceeds MAXBND=',MAXBND
         call mexit(6,1)
      endif

      do jn = 1,jtheta
         IT(NTHETA+jn) = ntot+ mt(1,jn)
         JT(NTHETA+jn) = ntot+ mt(2,jn)
         kT(NTHETA+jn) = ntot+ mt(3,jn)
      enddo
      ntheta = ntheta+jtheta 
      if(ntheta.gt.MAXANG) then
         print *,'gensol: ntheta= ',ntheta ,' exceeds MAXANG=',MAXANG
         call mexit(6,1)
      endif

      do jn = 1,jphi
         Ip(Nphi+jn) = (mp(1,jn)/iabs(mp(1,jn)))*(ntot+ iabs(mp(1,jn)))
         jp(Nphi+jn) = (mp(2,jn)/iabs(mp(2,jn)))*(ntot+ iabs(mp(2,jn)))
         kp(Nphi+jn) = (mp(3,jn)/iabs(mp(3,jn)))*(ntot+ iabs(mp(3,jn)))
         lp(Nphi+jn) = (mp(4,jn)/iabs(mp(4,jn)))*(ntot+ iabs(mp(4,jn)))
      enddo
      nphi = nphi+jphi
      if(nphi.gt.MAXDIH) then
         print *,'gensol: nphi = ',nphi,' exceeds MAXDIH=',MAXDIH
         call mexit(6,1)
      endif

      do jn = 1,nsolvat
       itree(ntot+jn) = ityp(1,jn)
       isymbl(ntot+jn) = ityp(2,jn)
       igraph(ntot+jn) = ityp(3,jn)
       chrg(ntot+jn) = chg(jn)
       irotat(ntot+jn) = irot(jn)
       numex(ntot+jn) = mumex(jn)
      enddo

      do jn = 1,jnext-1
      natex(next+jn) =  matex(jn)+ntot     
      enddo
      natex(next+jnext) = 0
      next = next + jnext
      if(next.gt.MAXEXC) then
         print *,'gensol: next = ',next,' exceeds MAXEXC=',MAXEXC
         call mexit(6,1)
      endif
C
C     ----- MAKE EACH OF THESE solvents A SINGLE RESIDUE -----
C
      NTOTRS = NTOTRS+1
      if (ntotrs .ge. MAXRES) then
           write(6,'(/,5x,a,i6,a)') 'gensol: MAXRES =',MAXRES,
     +           ' exceeded'
           call mexit(6, 1)
      endif
      LABRES(NTOTRS) = MAMres
      ITRES(NTOTRS) = IXYZ
      IBRES(NTOTRS+1) = NBOND+1
      IPRES(NTOTRS+1) = NTOTAT+1
      NSPM = NSPM+1
      NSP(NSPM) = nsolvat
   74 CONTINUE
      write(6,'(t5,i5,'' solvent molecules discarded'')')ireject
C
C     ----- UPDATE THE MOLECULE INFORMATION ARRAY -----
C
      if (nmol+1 .gt. MAXMOL) then
           write(6,'(/,5x,a,i6,a)') 'gensol: MAXMOL =',MAXMOL,
     +           ' exceeded'
           call mexit(6, 1)
      endif
      NFRESM(NMOLW+1) = NTOTRS+1
      IBOND(NMOLW+1) = NBOND+1
      ITHETA(NMOLW+1) = NTHETA+1
      IPHI(NMOLW+1) = NPHI+1
      NATML(NMOLW) = NTOTAT
      MOLTYP(NMOLW) = 4
      NMOL = NMOL+1
C
C     ----- PUT THE BOX IN THE POSITIVE QUADRANT -----
C
      XMIN = GCMIN(NTOTAT,X)
      YMIN = GCMIN(NTOTAT,Y)
      ZMIN = GCMIN(NTOTAT,Z)
      DO 82 I = 1,NTOTAT
         X(I) = X(I)-XMIN
         Y(I) = Y(I)-YMIN
         Z(I) = Z(I)-ZMIN
   82 CONTINUE
 
      CGTOT = 0.
      DO 55 I = 1,NTOTAT
      IF(ISYMBL(I).EQ.ISYMDU) GO TO 55
      CGTOT = CGTOT+CHRG(I)
   55 CONTINUE
      box(1) = boxx
      box(2) = boxy
      box(3) = boxz
      beta = 90.0d0
      WRITE(6,270) cgtot
      WRITE(6,9438) beta,box(1),box(2),box(3)
      WRITE(6,9448) nspm
      WRITE(6,9468) iptres,nspsol

      RETURN
  270 FORMAT(/,5X,'Total charge on molecule  = ',F9.3,/)
 1050 FORMAT(/,5X,'cutoff criterion for discarding the solvent:',
     $       /,5X,'cutx =',f10.4,2x,'cuty =',f10.4,2x,'cutz =',f10.4,/)
 9108 FORMAT(A4,1X,A4,1X,I5)
 9118 FORMAT(3F10.5,i5)
 9438 FORMAT(/,5X,'beta ',f8.4,'  boxx =',f8.4,'  boxy =',f8.4
     $                     ,'  boxz =',f8.4)
 9448 FORMAT(/,5X,'Number of sub-molecules for dynamics =',I5)
 9468 FORMAT(/,5X,'The solute residue pointer for skipping the bc =',I5,
     +       /,5X,'The submolecule index for the solvent molecule =',I5)
      END
