c-----------------------------------------------------------------------
      subroutine getlow(n,r,low)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c     returns pointer to lowest value in r.  Assumes n is positive,
c     within bounds for r(), and that search starts at 1.
c     Author:  George Seibel
c
*     implicit none
c
c     INPUT:
c
      integer n
c        ... number of elements in r()
      real r(*)
c        ... real array to be searched
c
c     OUTPUT:
c
      integer low
c        ... pointer to lowest value in r()
c
c     INTERNAL:
c
      real rlow
c        ... working storage for lowest value in r()
      real eps
c        ... a sensible epsilon, sufficient for all machines
      integer i
c        ... loop index
c
      data eps /1.0e-5/
c
      low = 1
      rlow = r(1)
      do 100 i = 2, n
           if (rlow - r(i) .gt. eps) then
                rlow = r(i)
                low = i
           endif
  100 continue
      return
      end
