c-----------------------------------------------------------------------
      SUBROUTINE MCPDB(MAXWAT,NF,JWAT,NCUBE,BOXL,OXY,HYDA,HYDB,IOUT)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO GROW A WATER BOX OF ANY DIMENSION BASED ON THE
C           216 WATER CUBE. THAT IS, YOU WILL GROW A N**3 BOX OF 216WAT 
C           BOXES -----
C
c     Mods for Rev A by G. Seibel:
c      - add MAXWAT to arg list, overwrite protection, code cleanup.
c
      DIMENSION OXY(MAXWAT,3),HYDA(MAXWAT,3),HYDB(MAXWAT,3)
      DIMENSION XO(216,3),XH1(216,3),XH2(216,3)
C
C     ----- READ THE 216 WATER FIRST -----
C
      READ(NF,'(I5,F15.7)') KWAT,BOX
      JWAT = KWAT*NCUBE**3
      BOXL = BOX*NCUBE
c
      if (kwat .gt. 216) then
           write(iout,'(/,2x,a)')
     .        'Input water cube too big.  216 wat max'
           call mexit(iout, 1)
      endif
      if (jwat .gt. MAXWAT) then
           write(iout,'(/,2x,a,i6)')
     +      'Requested water cube size exceeds MAXWAT =',MAXWAT
           call mexit(iout, 1)
      endif
C
      READ(NF,9028) ((XO(I,J),I = 1,KWAT),J = 1,3)
      READ(NF,9028) ((XH1(I,J),I = 1,KWAT),J = 1,3)
      READ(NF,9028) ((XH2(I,J),I = 1,KWAT),J = 1,3)
C
C     ----- NOW GENERATE THE BIG CUBE -----
C
      LWAT = 1
      DO 100 I = 1,NCUBE
      DO 120 K = 1,NCUBE
      DO 140 J = 1,NCUBE
      BOXI = BOX*(I-1)
      BOXK = BOX*(K-1)
      BOXJ = BOX*(J-1)
      DO 160 M = 1,KWAT
      OXY(LWAT,1) = XO(M,1)+BOXI
      OXY(LWAT,2) = XO(M,2)+BOXK
      OXY(LWAT,3) = XO(M,3)+BOXJ
      HYDA(LWAT,1) = XH1(M,1)+BOXI
      HYDA(LWAT,2) = XH1(M,2)+BOXK
      HYDA(LWAT,3) = XH1(M,3)+BOXJ
      HYDB(LWAT,1) = XH2(M,1)+BOXI
      HYDB(LWAT,2) = XH2(M,2)+BOXK
      HYDB(LWAT,3) = XH2(M,3)+BOXJ
      LWAT=LWAT+1
  160 CONTINUE
  140 CONTINUE
  120 CONTINUE
  100 CONTINUE
      RETURN
C
 9028 FORMAT(6F13.8)
      END
