c
c------------------------------------------------------------------------
c note the vars in mcpdb4 are different from mcpdb!
c
      SUBROUTINE MCPDB4(JWAT,NF,NCUBE,BOXL,IOUT)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO GROW A WATER BOX OF ANY DIMENSION BASED ON THE
C           WATER CUBE. THAT IS, YOU WILL GROW A N**3 BOX OF WAT 
C           BOXES -----
#include "sizes.h"
      COMMON/CORSOL/OXY(MAXWAT,3),HYDA(MAXWAT,3),HYDB(MAXWAT,3),
     $  cp(maxwat,3)
      DIMENSION XO(512,3),XH1(512,3),XH2(512,3),XCP(512,3)
C
C     ----- READ THE WATER FIRST -----
C
      rewind(nf)
      READ(NF,'(I5,F15.7)') KWAT,BOX
      write(6,8018) KWAT,BOX
 8018 FORMAT(t2,'Waters read: ',I5,'  Box dimension: ',F15.7)
      JWAT = KWAT*NCUBE**3
      BOXL = BOX*NCUBE
      IF(JWAT.LE.maxwat .AND. KWAT.LE.512) THEN
C
      READ(NF,9028) ((XO(I,J),I = 1,KWAT),J = 1,3)
      READ(NF,9028) ((XH1(I,J),I = 1,KWAT),J = 1,3)
      READ(NF,9028) ((XH2(I,J),I = 1,KWAT),J = 1,3)
      READ(NF,9028) ((XCP(I,J),I = 1,KWAT),J = 1,3)
C
C     ----- NOW GENERATE THE BIG CUBE -----
C
      LWAT = 1
      DO 100 I = 1,NCUBE
         DO 120 K = 1,NCUBE
            DO 140 J = 1,NCUBE
               BOXI = BOX*(I-1)
               BOXK = BOX*(K-1)
               BOXJ = BOX*(J-1)
               DO 160 M = 1,KWAT
                  OXY(LWAT,1)  = XO(M,1)+BOXI
                  OXY(LWAT,2)  = XO(M,2)+BOXK
                  OXY(LWAT,3)  = XO(M,3)+BOXJ
                  HYDA(LWAT,1) = XH1(M,1)+BOXI
                  HYDA(LWAT,2) = XH1(M,2)+BOXK
                  HYDA(LWAT,3) = XH1(M,3)+BOXJ
                  HYDB(LWAT,1) = XH2(M,1)+BOXI
                  HYDB(LWAT,2) = XH2(M,2)+BOXK
                  HYDB(LWAT,3) = XH2(M,3)+BOXJ
                  CP(LWAT,1)   = XCP(M,1)+BOXI
                  CP(LWAT,2)   = XCP(M,2)+BOXK
                  CP(LWAT,3)   = XCP(M,3)+BOXJ
                  LWAT=LWAT+1
  160          CONTINUE
  140       CONTINUE
  120    CONTINUE
  100 CONTINUE
      RETURN
C
      ELSE
         WRITE(IOUT,9008) JWAT
         CALL mexit(iout, 1)
      END IF
C
 9028 FORMAT(6F13.8)
 9008 FORMAT(t2,'%EDIT-F-TOOBIG, requested cube is too big ',
     +/,t2,'number of waters =',I6,' reduce KWAT')
      CALL mexit(iout, 1)
      END
