c-----------------------------------------------------------------------
      SUBROUTINE MOVECM(NAT,CX,CY,CZ,INDEX)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO ORIENT THE MOLECULE ALONG THE PRINCIPAL
C           AXIS -----
C
      DIMENSION T(6),VEC(9),EIG(3),IA(10)
      DIMENSION CX(*),CY(*),CZ(*)
C
      DATA ZERO/0.0E+00/,ONE/1.0E+00/
C
C
C     ----- MATRIX POINTER ARRAY -----
C
      DO 50 I = 1,4
      IA(I) = I*(I-1)/2
   50 CONTINUE
      SUMX = ZERO
      SUMY = ZERO
      SUMZ = ZERO
      FNAT = FLOAT(NAT)
      DO 100 I =1,NAT
      SUMX = SUMX+CX(I)
      SUMY = SUMY+CY(I)
      SUMZ = SUMZ+CZ(I)
  100 CONTINUE
      XC = SUMX/FNAT
      YC = SUMY/FNAT
      ZC = SUMZ/FNAT
      DO 120 I = 1,NAT
      CX(I) = CX(I)-XC
      CY(I) = CY(I)-YC
      CZ(I) = CZ(I)-ZC
  120 CONTINUE
      WRITE(6,9008) XC,YC,ZC
C
C     ----- NOW REORIENT THE MOLECULE ALONG THE PRINCIPAL AXES -----
C
      IF(INDEX.LE.0) GO TO 200
      WRITE(6,9018)
      SXX = ZERO
      SYY = ZERO
      SZZ = ZERO
      SXY = ZERO
      SXZ = ZERO
      SYZ = ZERO
      DO 140 I = 1,NAT
      X = CX(I)
      Y = CY(I)
      Z = CZ(I)
      XX = X*X
      YY = Y*Y
      ZZ = Z*Z
      XY = X*Y
      YZ = Y*Z
      XZ = X*Z
      SXX = SXX+(YY+ZZ)
      SYY = SYY+(XX+ZZ)
      SZZ = SZZ+(XX+YY)
      SXY = SXY+XY
      SXZ = SXZ+XZ
      SYZ = SYZ+YZ
  140 CONTINUE
C
      T(1) = SXX
      T(2) = -SXY
      T(3) = SYY
      T(4) = -SXZ
      T(5) = -SYZ
      T(6) = SZZ
C
C     ----- CALCULATE PRINCIPAL AXES OF INERTIA -----
C
      CALL LIGENB(T,VEC,EIG,IA,3,3)
C
C     ----- CHANGE THE SIGN IF THE DETERMINANT OF THE EIGEN VECTOR
C           IS NEGATIVE -----
C
      DET = VEC(1)*(VEC(5)*VEC(9)-VEC(8)*VEC(6))-
     +      VEC(4)*(VEC(2)*VEC(9)-VEC(3)*VEC(8))+
     +      VEC(7)*(VEC(2)*VEC(6)-VEC(3)*VEC(5))
      I3 = 0
      DO 160 I = 1,NAT
      X = CX(I)
      Y = CY(I)
      Z = CZ(I)
      XT = VEC(1)*X+VEC(2)*Y+VEC(3)*Z
      YT = VEC(4)*X+VEC(5)*Y+VEC(6)*Z
      ZT = VEC(7)*X+VEC(8)*Y+VEC(9)*Z
      CX(I) = XT
      CY(I) = YT
      CZ(I) = ZT
  160 CONTINUE
C
C     ----- IF DET IS NEGATIVE CHANGE THE HANDEDNESS OF THE
C           COORDINATES -----
C
      IF(DET.GT.0.0E0) GO TO 200
      DO 180 I = 1,NAT
      CX(I) = -CX(I)
      CY(I) = -CY(I)
      CZ(I) = -CZ(I)
  180 CONTINUE
  200 CONTINUE
      RETURN
 9008 FORMAT(5X,'CENTER OF MASS:',3F10.4)
 9018 FORMAT(/,5X,'MOLECULE IS REORIENTED ALONG THE PRINCIPAL AXES')
      END
