      subroutine movecx(nat,cc,index)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           **
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
 
 
c     ----- routine to orient the molecule along the principal axis -----
 
      dimension t(6),vec(9),eig(3),ia(10)
      dimension cc(3,*)
 
 
      do 50 i = 1,4
         ia(i) = i*(i-1)/2
   50 continue
      sumx = 0.0
      sumy = 0.0
      sumz = 0.0

      do 100 jn =1,nat
         sumx = sumx + cc(1,jn)
         sumy = sumy + cc(2,jn)
         sumz = sumz + cc(3,jn)
  100 continue


      xc = sumx/nat
      yc = sumy/nat
      zc = sumz/nat

      write(6,'(t5,a,3f10.4)') 'center of mass: ',xc,yc,zc

      do 120 i = 1,nat
         cc(1,i) = cc(1,i)-xc
         cc(2,i) = cc(2,i)-yc
         cc(3,i) = cc(3,i)-zc
  120 continue
 
c     ----- now reorient the molecule along the principal axes -----
 
      if(index.le.0) go to 200
      write(6,'(/,5X,A)')
     $   'molecule will be reoriented along the principal axes'

      sxx = 0.0
      syy = 0.0
      szz = 0.0
      sxy = 0.0
      sxz = 0.0
      syz = 0.0
      do 140 i = 1,nat
         x = cc(1,i)
         y = cc(2,i)
         z = cc(3,i)

         xx = x*x
         yy = y*y
         zz = z*z
         xy = x*y
         yz = y*z
         xz = x*z

         sxx = sxx+(yy+zz)
         syy = syy+(xx+zz)
         szz = szz+(xx+yy)
         sxy = sxy+xy
         sxz = sxz+xz
         syz = syz+yz
  140 continue
 
      t(1) = sxx
      t(2) = -sxy
      t(3) = syy
      t(4) = -sxz
      t(5) = -syz
      t(6) = szz
 
C     ----- CALCULATE PRINCIPAL AXES OF INERTIA -----
 
      call ligenb(t,vec,eig,ia,3,3)
 
C     ----- CHANGE THE SIGN IF THE DETERMINANT OF THE EIGEN VECTOR
C           IS NEGATIVE -----
 
      det = vec(1)*(vec(5)*vec(9)-vec(8)*vec(6))-
     $      vec(4)*(vec(2)*vec(9)-vec(3)*vec(8))+
     $      vec(7)*(vec(2)*vec(6)-vec(3)*vec(5))
      i3 = 0
      do 160 i = 1,nat
         x = cc(1,i)
         y = cc(2,i)
         z = cc(3,i)
         xt = vec(1)*x+vec(2)*y+vec(3)*z
         yt = vec(4)*x+vec(5)*y+vec(6)*z
         zt = vec(7)*x+vec(8)*y+vec(9)*z
         cc(1,i) = xt
         cc(2,i) = yt
         cc(3,i) = zt
  160 continue
C
C     ----- IF DET IS NEGATIVE CHANGE THE HANDEDNESS OF THE
C           COORDINATES -----
C
      if(det.gt.0.0d0) go to 200
         do 180 i = 1,nat
            cc(i,1) = -cc(i,1)
            cc(i,2) = -cc(i,2)
            cc(i,3) = -cc(i,3)
  180    continue
  200 continue
      return
      end
