c-----------------------------------------------------------------------
      SUBROUTINE NEWPUC
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- CALCULATES A NEW PUCKER FOR ANY 5 MEMBERED RING
C           THE POSITION OF THE ATOM NEAREST THE ROOT OF THE TREE
C           AND THE ATOMS ON EITHER SIDE ARE HELD FIXED
C           THIS IS NECESSARY IN ORDER NOT TO HAVE TO RECALCULATE
C           THE POSITIONS OF PREVIOUS ATOMS
C           ONCE ALL POSITIONS HAVE BEEN CORRECTLY CALCULATED
C           THE STRUCTURE MAY BE SUPERIMPOSED TO KEEP THE
C           MEAN PLANE OF THE RING IN A FIXED POSITION -----
C
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     $            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     $            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     $             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/ZMAT/X(MAXATM),Y(MAXATM),Z(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      COMMON/IOEDIT/IN2,IN3,IN4,IFN4,IN5,IOUTC,IOUTD,IDUMPR,IP1,IP2,IP3
      COMMON/OPEDIT/IDBL,IDIREC,IOPTF
      COMMON/WORKA/MIXC(MAXATM),IWORK(MAXATM)
      COMMON/RUNHED/ITITL(20),ITITL1(20)
C
      DIMENSION IRINGA(5),JRINGA(5),IATTCH(5,4),JATTCH(5,4)
      DIMENSION R1(2),R2(2),IJ(2)
      DIMENSION JORDER(5),TAU(5)
      DIMENSION KRANAM(5),NAB(6)
      DIMENSION XTMP(50),YTMP(50),ZTMP(50),JTMP(50)
      DIMENSION XTMP1(50),YTMP1(50),ZTMP1(50),JTMP1(50)
C
      DATA IXYZ /3HXYZ /
      DATA IINT /3HINT /
C
C     ----- IRINGA(I) = ORIGINAL NUMBERS OF RING ATOMS
C           JRINGA(I) = NEW NUMBERS OF RING ATOMS
C           IATTCH(I,J) = ORIGINAL NUMBERS OF SUBSTITUENTS OF RING
C                         ATOM I (OTHER RING ATOMS EXCLUDED)
C           JATTCH(I,J) = NEW NUMBERS OF SUBSTITUENTS OF RING ATOM I
C           JORDER(I) = ORDER OF ORIGINAL RING ATOMS AROUND RING IN NEW
C                       SYSTEM
C
      IBUFF = 50
      IZERO = 0
      IONE = 1
      PI = 4.0*ATAN(1.0)
C
C     ----- START OUT BY CONVERTING ALL COORDINATES TO CARTESIAN -----
C
      CALL CONCOR(IXYZ,IONE,NTOTRS)
      IDUMST = IDUMPR
      IDUMPR = 1
      READ(IN,10) ITITL1
      WRITE(IOUT,11) ITITL1
      READ(IN,12) TMAX,PHASE
      WRITE(IOUT,13) TMAX,PHASE
      READ(IN,14) (KRANAM(I),I = 1,5)
      WRITE(IOUT,15) (KRANAM(I),I = 1,5)
C
C     ----- COMPUTE SUGAR PUCKER ANGLES FROM ANALYTIC FORMULA -----
C
      DO 6 I = 1,5
      IM = I-1
      ANG = PHASE+FLOAT(IM)*144.-288.
      ANG = ANG*PI/180.
      TAU(I) = TMAX*COS(ANG)
    6 CONTINUE
C
      DO 500 I = 1, MAXRES
C
C     ----- READ RESIDUES TO CHANGE
C           END INPUT WITH A BLANK CARD -----
C
      READ(IN,16) IRES
      IF(IRES.LE.0) GO TO 501
      WRITE(IOUT,17) IRES,LABRES(IRES)
C
C     ----- LOCATE ALL RING ATOMS IN RESIDUE -----
C
C           IN GENERAL CASE,THIS SECTION COULD BE SKIPPED AND ATOM
C           NUMBERS READ DIRECTLY IN -----
C
      NF = IPRES(IRES)
      NL = IPRES(IRES+1)-1
      DO 100 II = 1,5
      KRNM = KRANAM(II)
      DO 101 JJ = NF,NL
      IF(IGRAPH(JJ).EQ.KRNM) GO TO 102
  101 CONTINUE
      WRITE(IOUT,20) KRNM
      GO TO 500
  102 CONTINUE
      IRINGA(II) = JJ
  100 CONTINUE
C
C     ----- LOCATE ALL SUBSTITUENTS ON RING ATOMS WITH THE EXCEPTION
C           OF OTHER RING ATOMS -----
C
      DO 106 II = 1,5
      III = IRINGA(II)
      CALL FINDBA(III,IZERO,NATBND,NAB)
      NSUMP = 1
      IF(NATBND.EQ.0) GO TO 105
      DO 103 JJ = 1,NATBND
      JJJ = NAB(JJ)
      DO 104 KK = 1,5
      IF(JJJ.EQ.IRINGA(KK)) GO TO 103
  104 CONTINUE
      IATTCH(II,NSUMP) = JJJ
      NSUMP = NSUMP+1
  103 CONTINUE
  105 IATTCH(II,NSUMP) = 0
  106 CONTINUE
C
C     ----- LOCATE ATOM WHICH IS ATTACHED NEAREST TO ROOT OF TREE -----
C
      IMIN = 1
      IR = IRINGA(1)
      JMIN = JOIN(IR)
      DO 110 II = 2,5
      IR = IRINGA(II)
      IF(JOIN(IR).GE.JMIN) GO TO 110
      IMIN = II
      JMIN = JOIN(IR)
  110 CONTINUE
C
C     ----- STORE RING AND SUBSTITUENTS AT BEGINNING OF SYSTEM
C           IGNORE SUBSTITUENTS ON ATOM CLOSEST TO ROOT -----
C
      IATTCH(IMIN,1) = 0
      IS = 0
      NUM = IMIN-1
      NUMPRE = 0
      DO 26 II = 1,5
C
C     ----- STORE COORDINATES OF RING ATOM -----
C
      NUM = NUM+1
      IF(NUM.GT.5) NUM = 1
      IR = IRINGA(NUM)
      JORDER(II) = NUM
      IS = IS+1
      JRINGA(NUM) = IS
      IJ(1) = NUMPRE
      NUMPRE = IS
      CALL STORE(X(IR),Y(IR),Z(IR),IJ,XTMP1(IS),YTMP1(IS),
     $           ZTMP1(IS),JTMP1(IS),IONE)
C
C     ----- STORE COORD. OF SUBSTITUENTS -----
C
      IJ(1) = IS
      DO 27 JJ = 1,10
      IRS = IATTCH(NUM,JJ)
      IF(IRS.LE.0) GO TO 28
      IS = IS+1
      JATTCH(NUM,JJ) = IS
      CALL STORE(X(IRS),Y(IRS),Z(IRS),IJ,XTMP1(IS),YTMP1(IS),
     $           ZTMP1(IS),JTMP1(IS),IONE)
   27 CONTINUE
   28 CONTINUE
   26 CONTINUE
C
C     ----- STORE AN ATOM AT END WITH SAME COORD. AS INITIAL ATOM -----
C
      IR = IRINGA(IMIN)
      IS = IS+1
      CALL STORE(X(IR),Y(IR),Z(IR),IJ,XTMP1(IS),YTMP1(IS),
     $           ZTMP1(IS),JTMP1(IS),IONE)
      IF(IS.GT.IBUFF) then
         WRITE(IOUT,115) IS
  115    FORMAT(t2,'EDIT-F-RINGPROB, number of atoms of ring and',
     $         ' substituents  = ',i4,' is too large')
         call mexit(iout, 1)
      endif
C
C     ----- STORE COORDINATES AT BEGINNING OF MOLECULE -----
C
      CALL STORE(X,Y,Z,JOIN,XTMP,YTMP,ZTMP,JTMP,IS)
C
C     ----- PUT RING COORDINATES AT BEGINNING OF COORD. ARRAY -----
C
      CALL STORE(XTMP1,YTMP1,ZTMP1,JTMP1,X,Y,Z,JOIN,IS)
C
C     ----- CONVERT RING COORD. TO INTERNAL AND STORE -----
C
      CALL CALINT(IONE,IS)
      CALL STORE(X,Y,Z,JOIN,XTMP1,YTMP1,ZTMP1,JTMP1,IS)
C
C     ----- CONVERT TO CARTESIAN COORDINATES AND MODIFY RING COORDINATES
C
      IFLAG = 0
      CALL CALXYZ(IONE,IS,IFLAG)
C
C     ----- CHANGE DIHEDRAL ANGLES OF ATOMS ACROSS FROM STARTING ATOM
C           STORE THESE IN REVERSE ORDER SINCE ATOMS ARE IN COMMON ----
C
      IP = JORDER(4)+1
      IF(IP.GT.5) IP = 1
      IJ(1) = IP
      IP = JORDER(3)+1
      IF(IP.GT.5) IP = 1
      IJ(2) = IP
      DO 800 III = 1,2
      DO 80 II = 1,2
      J1 = IJ(II)-1
      IF(J1.LE.0) J1 = 5
      J2 = J1+1
      IF(J2.GT.5) J2 = 1
      J3 = J2+1
      IF(J3.GT.5) J3 = 1
      J4 = J3+1
      IF(J4.GT.5) J4 = 1
      J1 = JRINGA(J1)
      J2 = JRINGA(J2)
      J3 = JRINGA(J3)
      J4 = JRINGA(J4)
      IF(III.EQ.2) GO TO 79
C                                                    
C     ----- STORE INTERNAL COORD. BASED ON ORIG. COORD. -----
C
      CALL DIST(J1,J2,X,Y,Z,R1(II))
      CALL BANGLE(J1,J2,J3,X,Y,Z,R2(II),IONE)
      GO TO 80
   79 CONTINUE
      ITAU = IJ(II)
      P3 = 360.-TAU(ITAU)
      CALL COORD(IDUM,J4,J3,J2,J1,X,Y,Z,R1(II),R2(II),P3)
   80 CONTINUE
  800 CONTINUE
C
C     ----- CALCULATE NEW DIHEDRALS FOR RING ATOMS - OTHER INTERNAL
C           COORD. FOR SUBSTITUENTS ARE MEANINGLESS -----
C
      CALL CALINT(IONE,IS)
C
C     ----- NOW USE DIFFERENCES OF RING DIHEDRALS TO GET NEW INTERNAL
C           COORD. OF SUBSTITUENTS -----
C
      IP2 = IS
      DO 70 II = 1,1000
        IP1 = IP2
        IF(IP1.LE.1) GO TO 72
        IP2 = JOIN(IP1)
        IF(IP2.LE.0) GO TO 72
        DDIFF = ZTMP1(IP1)-Z(IP1)
        XTMP1(IP1) = X(IP1)
        YTMP1(IP1) = Y(IP1)
        ZTMP1(IP1) = Z(IP1)
        JSTART = IP2+1
        JFIN = IP1-1
        IF(JFIN.LT.JSTART) GO TO 70
        DO 71 JJ = JSTART,JFIN
          ZTMP1(JJ) = ZTMP1(JJ)-DDIFF
   71   CONTINUE
   70 CONTINUE
   72 CONTINUE
C
C      ----- READ INTERNAL COORDINATES BACK IN AND CONVERT TO CARTESIAN
C
      CALL STORE(XTMP1,YTMP1,ZTMP1,JTMP1,X,Y,Z,JOIN,IS)
      CALL CALXYZ(IONE,IS,IFLAG)
C
C     ----- PUT RING ATOMS BACK INTO ARRAY AND CONVERT ALL COORDINATES
C           TO CARTESIAN -----
C
      DO 40 II = 1,NTOTAT
   40 MIXC(II) = 0
C
C     ----- STORE NEW COORD. IN TEMP. ARRAY -----
C
      CALL STORE(X,Y,Z,JOIN,XTMP1,YTMP1,ZTMP1,JTMP1,IS)
C
C     ----- MOVE ORIGINAL COORD. BACK -----
C
      CALL STORE(XTMP,YTMP,ZTMP,JTMP,X,Y,Z,JOIN,IS)
      IDUMPR = IDUMST
C
C     ----- CONVERT ORIGINAL COORINATES TO INTERNAL -----
C
      CALL CONCOR(IINT,IONE,NTOTRS)
C
C     ----- ADD CARTESIAN COORD. OF RING ATOMS BACK TO ORIGINAL ARRAY
C
      DO 41 II = 1,5
      IR = IRINGA(II)
      JR = JRINGA(II)
      CALL STORE(XTMP1(JR),YTMP1(JR),ZTMP1(JR),JTMP1(JR),
     $           X(IR),Y(IR),Z(IR),JTMP1(JR),IONE)
      MIXC(IR) = 1
      DO 42 JJ = 1,10
      IRS = IATTCH(II,JJ)
      IF(IRS.EQ.0) GO TO 43
      JRS = JATTCH(II,JJ)
      CALL STORE(XTMP1(JRS),YTMP1(JRS),ZTMP1(JRS),JTMP1(JRS),
     $           X(IRS),Y(IRS),Z(IRS),JTMP1(JRS),IONE)
      MIXC(IRS) = 1
   42 CONTINUE
   43 CONTINUE
   41 CONTINUE
C
C     ----- CONVERT ALL COORDINATES TO CARTESIAN -----
C
      IFLAG = 1
      CALL CALXYZ(IONE,NTOTAT,IFLAG)
      IFLAG = 0
      DO 61 II = 1,NTOTRS
      ITRES(II) = IXYZ
   61 CONTINUE
      IDUMPR = 1
  500 CONTINUE
  501 CONTINUE
      IDUMPR = IDUMST
      RETURN
   10 FORMAT(20A4)
   11 FORMAT(/ / /,1H ,15X,20A4,/)
   12 FORMAT(2F10.2)
   13 FORMAT(1H ,5X,'TMAX  = ',F12.2,4X,'PHASE  = ',F12.2,/)
   14 FORMAT(5(A4,1X))
   15 FORMAT(1H ,5X,'NAMES OF RING ATOMS  = ',5(A4,1X),/)
   16 FORMAT(I5)
   17 FORMAT(1H ,5X,'SUGAR PUCKER CHANGED FOR RESIDUE',I5,3X,A4,/)
   20 FORMAT(1H ,5X,'ATOM',2X,A4,3X,'COULD NOT BE LOCATED',/)
      END
