c-----------------------------------------------------------------------
      subroutine octcheck(nat, x, y, z, box,
     +                    xmin,ymin,zmin,
     +                    xmax,ymax,zmax,cutd)
      real x(*), y(*), z(*), box(3)
c
      real boxold(3)
      
      boxold(1)=box(1)
      boxold(2)=box(2)
      boxold(3)=box(3)
      boxhx = box(1) * 0.5
      boxhy = box(2) * 0.5
      boxhz = box(3) * 0.5
c
c     -- find unit vector of diagonal
c
      vecx = boxhy * boxhz
      vecy = boxhx * boxhz
      vecz = boxhx * boxhy
c
      dum = 1 / sqrt(vecx*vecx + vecy*vecy + vecz*vecz)
      vecxu = vecx * dum
      vecyu = vecy * dum
      veczu = vecz * dum
c
c     -- find max atom distance from origin along the diagonal
c
      dmax = 0.0
      do 1 i=1,nat
          d = abs(x(i)) * vecxu  
     +      + abs(y(i)) * vecyu  
     +      + abs(z(i)) * veczu
          if (d.gt.dmax) dmax = d
c         write(6,*) ' atom ', i, ' d ', d
    1 continue
c
c     -- calc distance of diagonal face from origin
c
      bmax = 0.5 * sqrt(boxhx*boxhx + boxhy*boxhy + boxhz*boxhz)
c
c     -- see if diagonal clearance is satisfied
c
      dum = (dmax + cutd)
      write(6,*) ' atom ', dum, ' box ', bmax, ' hboxx ', boxhx
      if (dum.le.bmax) then
          if (cutd.eq.0.0) write(6,'(/,5x,a,f8.3,a)') 
     +        '(OCT CLEARANCE TO CLOSEST ATOM: ', dmax,' )'
          return
      endif
c
c     -- not satisfied: scale up box
c
      dum = dum / bmax
      write(6,'(/,5x,a,f8.3,/,5x,a)')
     +    '** SCALING UP EACH BOX DIMENSION BY A FACTOR OF: ', dum,
     +    '   TO MEET OCT CUTD CRITERION'
      box(1) = box(1) * dum
      box(2) = box(2) * dum
      box(3) = box(3) * dum
      xmin=xmin-(box(1)-boxold(1))/2
      ymin=ymin-(box(2)-boxold(2))/2
      zmin=zmin-(box(3)-boxold(3))/2
      xmax=xmax+(box(1)-boxold(1))/2
      ymax=ymax+(box(2)-boxold(2))/2
      zmax=zmax+(box(3)-boxold(3))/2
      return
      end
