c-----------------------------------------------------------------------
      SUBROUTINE PCI
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C     Counterion placement routine.  Use at your own risk.
c     (this doesn't work very well for proteins)
c     Rev A: Removed commons INFOM, CROSSL, BOND, ANGL, DIHED, IOEDIT.
c            Added array bounds protection.
c            Changed original check on iexc() bound to match 3.0 dimension.
C
#include "sizes.h"
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     $            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     $            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     $             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     $       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
C
      DIMENSION JRESN(50),JATN(50),CION(50),DISTI(50),IEXC(400)
C
      DATA IBLANK /4H     /
      DATA IEND /1HE /
      DATA MAIN /1HM /
      DATA KSYMM /2HIM /
      DATA KSYMP /2HIP /
      DATA KGRAM /4HCL-  /
      DATA KGRAP /4HNA+  /
      DATA ICION /4HCIO  /
      DATA IXYZ /3HXYZ  /
C
C     ----- CMIN = MINIMUM CHARGE IN SPHERE OF RADIUS SDIST ABOUT
C           SPECIFIED ATOM FOR COUNTER ION TO BE INCLUDED
C           DISCK = DISTANCE ABOUT COUNTER ION THAT CONTACT WITH
C           ANOTHER ATOM IS CHECKED
C           CUTSB = MINIMUM SALT BRIDGE DISTANCE -----
C
      READ(IN,10) CMIN,SDIST,DISCK,CUTSB
      WRITE(IOUT,11)
C
C     ----- MAIN LOOP FOR PLACING THE CION -----
C
      DO 30 I = 1,1000
C
C     ----- JRESN = RESIDUE NAME
C           JATN = GRAPH NAME OF ATOM
C           CION = CHARGE OF COUNTER ION
C           DISTII = MINIMUM DISTANCE OF COUNTER ION FROM OTHER ATOMS
C
      READ(IN,12) JRESN(I),JATN(I),CION(I),DISTII
      IF(JRESN(I).EQ.IBLANK) GO TO 31
      WRITE(IOUT,13) I,JRESN(I),JATN(I),CION(I),DISTII
      DISTI(I) = DISTII
   30 CONTINUE
   31 NREST = I-1
      WRITE(IOUT,100) SDIST,CMIN
      IF(DISCK.GT.0.05) WRITE(IOUT,234) DISCK
      IF(CUTSB.GT.0.05) WRITE(IOUT,145) CUTSB
      CUTSB = CUTSB*CUTSB
      WRITE(IOUT,182)
      DISCK = DISCK*DISCK
      SDIST = SDIST*SDIST
      NORIGT = NTOTAT
      IEXCN = 0
      IF(CUTSB.LT.0.1) GO TO 132
      NLIM = NTOTRS-1
      DO 70 I = 1,NLIM
      NAMRS = LABRES(I)
      DO 72 J = 1,NREST
      IF(NAMRS.EQ.JRESN(J)) GO TO 82
   72 CONTINUE
      GO TO 70
   82 NF = IPRES(I)
      NS = IPRES(I+1)-1
      JGN = JATN(J)
      CIONII = CION(J)
      DO 73 KK = NF,NS
      IF(IGRAPH(KK).EQ.JGN) GO TO 74
   73 CONTINUE
      GO TO 70
   74 I1 = KK
      IPL = I+1
      DO 83 II = IPL,NTOTRS
      MAMRES = LABRES(II)
      DO 75 JJ = 1,NREST
      XSIGN = CION(JJ)*CIONII
      IF(XSIGN.GT.0.) GO TO 75
      IF(MAMRES.EQ.JRESN(JJ)) GO TO 84
   75 CONTINUE
      GO TO 83
   84 NF = IPRES(II)
      NS = IPRES(II+1)-1
      JGN = JATN(JJ)
      DO 76 KK = NF,NS
      IF(IGRAPH(KK).EQ.JGN) GO TO 77
   76 CONTINUE
      GO TO 83
   77 I2 = KK
      XD = R(I1)-R(I2)
      YD = THETA(I1)-THETA(I2)
      ZD = PHI(I1)-PHI(I2)
      BI = XD*XD+YD*YD+ZD*ZD
      IF(BI.GT.CUTSB) GO TO 83
      SQ = SQRT(BI)
      WRITE(IOUT,243) I,NAMRS,SQ,II,MAMRES
      IEXCN = IEXCN+1
      IEXC(IEXCN) = I
      DO 78 JJ = 1,IEXCN
      IF(I2.EQ.IEXC(JJ)) GO TO 79
   78 CONTINUE
      IEXCN = IEXCN+1
      IEXC(IEXCN) = II
   79 CONTINUE
   83 CONTINUE
   70 CONTINUE
  132 CONTINUE
      IF(IEXCN.GT.200) WRITE(IOUT,420) IEXCN
      NLIM = NTOTRS
      DO 32 I = 1,NLIM
      IF(IEXCN.EQ.0) GO TO 91
      DO 92 J = 1,IEXCN
      IF(I.EQ.IEXC(J)) GO TO 32
   92 CONTINUE
   91 CONTINUE
      NAMRS = LABRES(I)
      DO 33 J = 1,NREST
      IF(NAMRS.NE.JRESN(J)) GO TO 33
      NF = IPRES(I)
      NS = IPRES(I+1)-1
      JGN = JATN(J)
      DO 34 K = NF,NS
      IF(IGRAPH(K).NE.JGN) GO TO 34
      CGTOT = CHRG(K)
      XV = 0.
      YV = 0.
      ZV = 0.
      RI = R(K)
      THETAI = THETA(K)
      PHII = PHI(K)
      DISTCI = DISTI(J)
      DO 35 L = 1,NORIGT
      IF(L.EQ.K) GO TO 35
      IF(ISYMBL(L).EQ.ISYMDU) GO TO 35
      XD = R(L)-RI
      YD = THETA(L)-THETAI
      ZD = PHI(L)-PHII
      BI = XD*XD+YD*YD+ZD*ZD
      IF(BI.GT.SDIST) GO TO 35
      CGTOT = CGTOT+CHRG(L)
      IF(JOIN(L).NE.K.AND.JOIN(K).NE.L) GO TO 35
C
C     ----- USE ALL ATOMS EXCEPT END ATOMS TO PLACE COUNTER ION
C           EXCLUDE END ATOMS -----
C
      IF(ITREE(L).EQ.IEND) GO TO 35
C
C     ----- ADD NORMALIZED POSITION VECTOR -----
C
      BI = 1.0/SQRT(BI)
      XV = XV-XD*BI
      YV = YV-YD*BI
      ZV = ZV-ZD*BI
   35 CONTINUE
      CGREM = ABS(CGTOT)
      IF(CGREM.LT.CMIN) WRITE(IOUT,203) I,NAMRS,CGTOT
      IF(CGREM.LT.CMIN) GO TO 32
      WRITE(IOUT,25) I,NAMRS,CGTOT
C
C     ----- ADD NORMALIZED VECTOR TO ORIGINAL VECTOR AND MAKE CORRECT
C           LENGTH -----
C
      XNORM = SQRT(XV*XV+YV*YV+ZV*ZV)
      X1 = (XV/XNORM)*DISTCI+RI
      Y1 = (YV/XNORM)*DISTCI+THETAI
      Z1 = (ZV/XNORM)*DISTCI+PHII
      IF(DISCK.LT.0.05) GO TO 90
C
C     ----- CHECK DISTANCE OF COUNTER ION FROM OTHER ATOMS -----
C
      DO 52 L = 1,NORIGT
      IF(ISYMBL(L).EQ.ISYMDU) GO TO 52
      XD = R(L)-X1
      YD = THETA(L)-Y1
      ZD = PHI(L)-Z1
      S = XD*XD+YD*YD+ZD*ZD
      IF(S.GT.DISCK) GO TO 52
      SQ = SQRT(S)
      WRITE(IOUT,157) L,SQ
      GO TO 32
   52 CONTINUE
   90 CONTINUE
      NTOTAT = NTOTAT+1
      if (ntotat .gt. MAXATM) then
           write(iout,2000) 'Atoms', ntotat, 'MAXATM', MAXATM
           call mexit(iout, 1)
      endif   
      R(NTOTAT) = X1
      THETA(NTOTAT) = Y1
      PHI(NTOTAT) = Z1
      NUMEX(NTOTAT) = 1
      NEXT = NEXT+1
      if (next .gt. MAXEXC) then
           write(iout,2000) 'Excluded Atoms', next, 'MAXEXC', MAXEXC
           call mexit(iout, 1)
      endif   
      NATEX(NEXT) = 0
      ITREE(NTOTAT) = MAIN
      IROTAT(NTOTAT) = NTOTAT
      XCG = CION(J)
      CHRG(NTOTAT) = XCG
      JOIN(NTOTAT) = 0
      IF(XCG.GE.0.0) ISYMBL(NTOTAT) = KSYMP
      IF(XCG.GE.0.0) IGRAPH(NTOTAT) = KGRAP
      IF(XCG.LT.0.0) ISYMBL(NTOTAT) = KSYMM
      IF(XCG.LT.0.0) IGRAPH(NTOTAT) = KGRAM
C
C     ----- PUT EACH COUNTER ION AS A SEPARATE RESIDUE -----
C
      NTOTRS = NTOTRS+1
      if (ntotrs .gt. MAXRES) then
           write(iout,2000) 'Residues', ntotrs, 'MAXRES', MAXRES
           call mexit(iout, 1)
      endif   
      LABRES(NTOTRS) = ICION
      ITRES(NTOTRS) = IXYZ
      IBRES(NTOTRS+1) = IBRES(NTOTRS)
      IPRES(NTOTRS+1) = NTOTAT+1
C
C     ----- PUT COUNTER IONS IN A SEPERATE MOLECULE -----
C
      NMOL = NMOL+1
      if (nmol .gt. MAXMOL) then
           write(iout,2000) 'Molecules', nmol, 'MAXMOL', MAXMOL
           call mexit(iout, 1)
      endif   
      NFRESM(NMOL+1) = NTOTRS+1
      NATML(NMOL) = NTOTAT
      MOLTYP(NMOL) = 5
      IBOND(NMOL+1) = IBOND(NMOL)
      ITHETA(NMOL+1) = ITHETA(NMOL)
      IPHI(NMOL+1) = IPHI(NMOL)
      GO TO 32
C
   34 CONTINUE
   33 CONTINUE
   32 CONTINUE
      CGTOT = 0.
      DO 55 I = 1,NTOTAT
      IF(ISYMBL(I).EQ.ISYMDU) GO TO 55
      CGTOT = CGTOT+CHRG(I)
   55 CONTINUE
      WRITE(IOUT,270) CGTOT
      RETURN
   10 FORMAT(8F10.3)
   11 FORMAT(5X,'COUNTER IONS WILL BE PLACED ON FOLLOWING ',
     $        'RESIDUES',/)
   12 FORMAT(A4,1X,A4,1X,2F10.3)
   13 FORMAT(5X,I5,2X,'RES = ',A4,2X,'ATOM = ',A4,2X,
     $      'COUNTER ION CHARGE  = ',F8.2,3X,'DISTANCE AWAY  = ',F8.2,/)
  100 FORMAT(5X,'MINIMUM ABS. VALUE OF CHARGE IN SPHERE OF '
     $      ,'RADIUS  = ',F8.2,2X,'A',1X,' = ',F8.2,/)
  234 FORMAT(5X,'COUNTER ION WILL NOT BE PLACED IF ANOTHER ATOM',
     $       ' IS CLOSER THAN ',F8.2,1X,'A',/)
  145 FORMAT(5X,'ASSUMES SALT BRIDGE IF DISTANCE BETWEEN ATOMS  = '
     $          ,F8.2,/)
  182 FORMAT('**********************************************',/)
  243 FORMAT(5X,'RES',I5,2X,A4,2X,'IS',F8.2,1X,'A',2X,
     $      'FROM RES',I5,2X,A4,/)
  420 FORMAT('****** IEXCN  = ',I5,2X,'IS TOO BIG IN PCI ****',/)
  203 FORMAT(5X,'RESIDUE ',I4,2X,A4,2X,'HAS CHARGE IN SPHERE  = ',
     $          F8.2,2X,'AND WILL NOT HAVE COUNTER ION',/)
   25 FORMAT(5X,'COUNTER ION ADDED TO RESIDUE',I4,2X,A4,4X,
     $         'CHARGE IN SPHERE  = ',F8.2,/)
  157 FORMAT(5X,'ATOM',I5,2X,'IS',F10.2,1X,'A',2X,
     $       'FROM COUNTER ION',/)
  270 FORMAT(5X,'TOTAL CHARGE ON MOLECULE  = ',F9.3,/)
 2000 format(/,5x,'Number of ',a,' =',i6,' exceeds ',a,' =',i6)
      END
