c-----------------------------------------------------------------------
      SUBROUTINE RCHAR
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- SUBSTITUTES NEW CHARGES FOR SPECIFIED ATOMS IN SELECTED
C           RESIDUES -----
C
#include "sizes.h"
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     +             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      COMMON/IOEDIT/IN2,IN3,IN4,IFN4,IN5,IOUTC,IOUTD,IDUMPR,IP1,IP2,IP3
C
      DIMENSION KRESNM(100),KRESP(100),KATNM(300),ATCHG(300)
      DIMENSION KRESFN(100),KRETFN(100)
      DIMENSION IM1(20),IM2(20),IR1(100),IR2(100)
C
      DATA KEND,KMOL,KRES/4HEND ,4HMOL ,4HRES /
      DATA IBLANK /4H     /
      DATA MALL /4H****  /
      DATA KUP /4HUP   /
      DATA KDOWN /4HDOWN/
C
C     ----- EXPLANATION SOME VARIABLES -----
C
C           NMOLI = NUMBER OF MOLECULE INTERVALS
C           NRESI = NUMBER OF RESIDUE INTERVALS
C           IREADC = 1 IF LAST CARD READ WAS A RESIDUE CARD
C                  = 0 IF LAST CARD READ WAS A MOLECULE CARD
C           IM1(I) = START OF MOLECULE INTERVAL I
C           IM2(I) = END OF MOLECULE INTERVAL I
C           IR1(I) = START OF RESIDUE INTERVAL I
C           IR2(I) = END OF RESIDUE INTERVAL I
C
C           IPRIN = 1 PRINT OUT NEW CHARGES TO BE SUBSTITUTED
C           IPRINM  = 1 PRINT ALL MATCHES
C
      READ(IN,9) IPRIN,IPRINM
C
C     ----- GRAND LOOP FOR READING THE CHARGES -----
C
      IRES = 0
      IATOM = 0
C
C     ----- READ IN RESIDUE NAME
C           END INPUT WITH A BLANK CARD -----
C
  200 CONTINUE
      READ(IN5,13) KTEMP
      IF(KTEMP.EQ.IBLANK) GO TO 400
      IRES = IRES+1
C
C     ----- KRESNM = RESIDUE NAME
C           KRESP = POINTER TO 1ST ATOM IN EACH RESIDUE -----
C
      KRESNM(IRES) = KTEMP
      KRESP(IRES) = IATOM+1
      IF(IPRIN.EQ.1) WRITE(IOUT,201) IRES,KTEMP
C
C     ----- READ IN ATOM GRAPH NAMES AND CHARGES
C           END INPUT WITH A BLANK CARD AND THEN READ IN ANOTHER RESIDUE
C           NAME OR A BLANK CARD TO END ALL INPUT FOR THIS SECTION -----
C
  300 CONTINUE
      READ(IN5,14) KTEMP,TCHRG
      IF(KTEMP.EQ.IBLANK) GO TO 200
      IATOM = IATOM+1
      KATNM(IATOM) = KTEMP
      ATCHG(IATOM) = TCHRG
      IF(IPRIN.EQ.1) WRITE(IOUT,301) IATOM,KTEMP,TCHRG
      GO TO 300
C
  400 CONTINUE
      IF(IRES.EQ.0) WRITE(IOUT,401)
      IF(IRES.EQ.0) GO TO 800
      KRESP(IRES+1) = IATOM+1
      ITOTAL = IRES
      WRITE(IOUT,404)
      WRITE(IOUT,402) ITOTAL,IATOM
      IF(.NOT. (ITOTAL.GT.100.OR.IATOM.GT.300)) GO TO 420
      WRITE(IOUT,403)
      GO TO 1000
  420 CONTINUE
C
      NMOLI = 0
      NRESI = 0
      IREADC = -1
      WRITE(IOUT,536)
  500 CONTINUE
C
C     ----- READ IN 'MOL' AND 'RES' CARDS IN ANY ORDER
C           THESE CARDS DESCRIBE THE RANGE OF THE SEARCH
C           READ IN NUMBER OF RESIDUES TO BE MATCHED AGAINST NAMES IN
C           DATA FILE
C           ALL RESIDUES FROM I1-I2 WILL BE SEARCHED
C           IF SECOND RESIDUE IS BLANK, ONLY 1 RESIDUE WILL BE SOUGHT
C           'MOL' CARDS WORK THE SAME WAY -----
C
C           ALL RESIDUE NUMBERS ARE RELATIVE TO THE BEGINNING
C           OF EACH MOLECULE ON THE 'MOL' CARDS
C           IMMEDIATELY ABOVE THE 'RES' CARDS 
C
C           THE RANGE OF RESIDUES WILL BE APPLIED TO ALL MOLECULES
C           ON ALL 'MOL' CARDS ABOVE THE 'RES' CARDS
C           THUS :
C                          MOL  1  999
C                          RES  2
C
C           WILL SEARCH FOR RESIDUE 2 IN EACH MOLECULE
C           DEFAULT TYPE OF A CARD IS 'RES'
C           IF THE FIRST CARD IS A 'RES' CARD, 'MOL  1 9999' WILL BE
C           ASSUMED 
C
C           END INPUT WITH AN 'END'
C
      READ(IN,501) KTYPE,I1,I2
      IF(KTYPE.EQ. kend .AND.IREADC.EQ.1) GO TO 502
C
C     ----- IF LAST CARD READ WAS A MOL CARD -- THEN SEARCH ALL RESIDUES
C           OF THESE MOLECULES -----
C
      IF(.NOT.(KTYPE.EQ.KEND.AND.IREADC.EQ.0)) GO TO 520
      I1 = 1
      I2 = 9999
      IF(NMOLI.LE.0) GO TO 502
      DO 540 J = 1,NMOLI
      M1 = IM1(J)
      M2 = IM2(J)
      DO 550 M = M1,M2
      J1 = I1
      J2 = I2
      CALL FIXR(J1,J2,M,IERR)
      IF(IERR.EQ.1) GO TO 502
      NRESI = NRESI+1
      IR1(NRESI) = J1
      IR2(NRESI) = J2
      WRITE(IOUT,533) NRESI,M,J1,J2
  550 CONTINUE
  540 CONTINUE
      GO TO 502
  520 CONTINUE
      IF(KTYPE.NE.KMOL) GO TO 560
C
C     ----- RESET INTERVALS IF LAST CARD READ WAS A RES CARD ----
C
      IF(IREADC.EQ.1) NMOLI = 0
      IREADC = 0
      CALL FIXM(I1,I2,NMOL,IERR)
      IF(IERR.EQ.1) GO TO 500
      NMOLI = NMOLI+1
      IM1(NMOLI) = I1
      IM2(NMOLI) = I2
      GO TO 500
  560 CONTINUE
C
      IF(.NOT.(KTYPE.EQ.KRES.OR.KTYPE.EQ.IBLANK)) GO TO 700
C
C     ----- DEFAULT IS ALL MOLECULES -----
C
      IF(IREADC.NE.-1) GO TO 720
      NMOLI = 1
      IM1(1) = 1
      IM2(1) = NMOL
  720 CONTINUE
      IREADC = 1
C
C     ----- READ PAST THESE CARDS IF PROBLEMS WITH MOL CARD -----
C
      IF(NMOLI.LE.0) GO TO 500
C
C     ----- IF ALL RESIDUES OF ALL MOLECULES ARE SEARCHED --- DONT
C           COMBINE INTO 1 INTERVAL SINCE 'UP' AND 'DOWN'
C           WILL NOT WORK ON SEPARATE MOLECULES -----
C
C           ACTUALLY FIGURE OUT INTERVALS FOR THESE RESIDUES
C
      DO 530 J = 1,NMOLI
      M1 = IM1(J)
      M2 = IM2(J)
      DO 531 M = M1,M2
      J1 = I1
      J2 = I2
      CALL FIXR(J1,J2,M,IERR)
      IF(IERR.EQ.1) GO TO 500
      NRESI = NRESI+1
      IR1(NRESI) = J1
      IR2(NRESI) = J2
      WRITE(IOUT,533) NRESI,M,J1,J2
  531 CONTINUE
  530 CONTINUE
      GO TO 500
  700 CONTINUE
C
      WRITE(IOUT,580) KTYPE
      GO TO 500
C
  502 CONTINUE
      WRITE(IOUT,563)
      IF(NRESI.GT.100) GO TO 1020
C
C     ----- LOOP OVER ALL RESIDUE INTERVALS -----
C
      NMATCH = 0
      DO 33 I = 1,ITOTAL
      KRETFN(I) = 0
   33 CONTINUE
      IF(NRESI.LE.0) GO TO 800
      DO 590 L = 1,NRESI
      I1 = IR1(L)
      I2 = IR2(L)
      DO 591 LL = 1,ITOTAL
  591 KRESFN(LL) = 0
      IF(IPRINM.EQ.1) WRITE(IOUT,592) L,I1,I2
      DO 600 I = I1,I2
      DO 601 J = 1,ITOTAL
      IINC = 1
C
C     ----- IF KRESNM = **** EVERYTHING MATCHED
C           CAUTION --- PROGRAM MATCHES 1ST THING IT FINDS
C           TO BE SAVE PUT ALL **** RESIDUES IN A SEPARATE
C           DATA FILE
C
C           IF KRESNM = UP   -- ALL RESIDUES BETWEEN I1 AND J1 WILL BE
C           SEARCHED AND ONLY THE 1ST MATCHING ATOM FOUND
C           WILL BE CHANGED
C
C                     = DOWN -- SAME AS FOR UP, BUT RESIDUES WILL BE
C                     SEARCHED FROM BOTTOM TO TOP WITH ONLY THE FIRST
C                     ATOM FOUND BEING MATCHED
C
C           REMINDER ---- 1ST RESIDUE FOUND WILL BE MATCHED, SO PUT
C                         THESE IN A SEPARATE FILE TO AVOID PROBLEMS
C
      IF(KRESNM(J).EQ.MALL) GO TO 602
      IF(LABRES(I).EQ.KRESNM(J)) GO TO 602
      IF(KRESNM(J).NE.KDOWN) GO TO 740
      IF(KRESFN(J).GT.0) GOTO 601
      ISTART = IPRES(I1)
      IEND = IPRES(I2+1)-1
      GO TO 608
  740 CONTINUE
C
      IF(KRESNM(J).NE.KUP) GO TO 760
      IF(KRESFN(J).GT.0) GO TO 601
      ISTART = IPRES(I2+1)-1
      IEND = IPRES(I1)
      IINC = -1
      GO TO 608
  760 CONTINUE
C
  601 CONTINUE
      GO TO 600
C
C     ----- MATCH MADE -----
C
  602 CONTINUE
C
C     ----- SEARCH FOR SPECIFIC ATOMS IN RESIDUE I -----
C
      ISTART = IPRES(I)
      IEND = IPRES(I+1)-1
  608 CONTINUE
      NMATCH = NMATCH+1
      KRESFN(J) = KRESFN(J)+1
      JSTART = KRESP(J)
      JEND = KRESP(J+1)-1
      DO 603 JJ = JSTART,JEND
      KTEMP = KATNM(JJ)
      DO 604 II = ISTART,IEND,IINC
      IF(IGRAPH(II).NE.KTEMP) GO TO 604
      CHRG(II) = ATCHG(JJ)
      IF(IPRINM.NE.1) GO TO 603
      IF(.NOT.(KRESNM(J).NE.KUP.AND.KRESNM(J).NE.KDOWN)) GO TO 780
      WRITE(IOUT,610) IGRAPH(II),I,LABRES(I)
  780 CONTINUE
      WRITE(IOUT,620) IGRAPH(II),II,KRESNM(J)
      GO TO 603
  604 CONTINUE
C
      IF(.NOT.(KRESNM(J).NE.KUP.AND.KRESNM(J).NE.KDOWN)) GO TO 790
      WRITE(IOUT,605) KATNM(JJ),I,LABRES(I)
  790 CONTINUE
      WRITE(IOUT,612) KATNM(JJ),KRESNM(J)
C                                
  603 CONTINUE
  600 CONTINUE
      DO 621 LL = 1,ITOTAL
      KRETFN(LL) = KRETFN(LL)+KRESFN(LL)
  621 CONTINUE
  590 CONTINUE
      WRITE(IOUT,644)
      WRITE(IOUT,645) (LL,KRESNM(LL),KRETFN(LL),LL = 1,ITOTAL)
      WRITE(IOUT,606) NMATCH
  800 CONTINUE
      RETURN
 1000 CONTINUE
      WRITE(IOUT,'(/,2x,a)') 'You call this SCIENCE?'
      call mexit(iout, 1)
 1020 CONTINUE
      WRITE(IOUT,570) NRESI
  570 FORMAT(t2,'EDIT-F-TOOBIG, nresi  = ',i5,' is too big')
      call mexit(iout, 1)
    9 FORMAT(3I5)
   13 FORMAT(A4)
  201 FORMAT(t2,'RESIDUE ',I4,2X,' =  ',A4,/)
   14 FORMAT(A4,F15.4)
  301 FORMAT(t2,9X,I5,'. ',A4,3X,F12.4)
  401 FORMAT(t2,'EDIT-W-NONE, no residues found')
  404 FORMAT(t2,'IN INPUT DATA FILE :',/)
  402 FORMAT(1H ,9X,'NUMBER OF RESIDUES  = ',I5,5X,
     +        'NUMBER OF ATOMS  = ',I5,/ / /)
  403 FORMAT(t2,'EDIT-F-TOOBIG, too big - make 2 data files ')
  536 FORMAT(/ / /,1H ,10X,'SEARCHING INTERVALS ',/ /)
  501 FORMAT(A4,1X,2I5)
  533 FORMAT(1H ,5X,I5,'.',3X,'MOL ',I4,5X,'RES ',I4,' - ',I4)
  580 FORMAT(t2,' EDIT-W-UNKNOWN, unknown ktype card ',A4)
  563 FORMAT(/ / /)
  592 FORMAT(/ / /,1H ,5X,'SEARCHING INTERVAL ',I4,5X,'RES ',I4,' - ',
     +            I4,/)
  610 FORMAT(1H ,5X,'MATCH FOUND - ',A4,3X,'RES ',I4,2X,A4,/)
  620 FORMAT(1H ,5X,'MATCH FOUND - ',A4,3X,'ATOM',I4,2X,'SEARCHING',A4/)
  605 FORMAT(t2,'EDIT-W-NOMATCH, no match found for atom ',a4,
     +       ' in res ',i4,2x,a4)
  612 FORMAT(t2,'EDIT-W-NOMATCH, no match found for atom ',a4,
     +        2x,'searching ',a4)
  644 FORMAT(/ / /,1H ,5X,'RESIDUES IN INPUT DATA FILE AND NUMBER OF',
     +            ' MATCHES ',/)
  645 FORMAT(1H ,5X,I5,'.',2X,A4,3X,I5,/)
  606 FORMAT(/ /,1H ,5X,'NUMBER OF RESIDUE MATCHED  = ',I5,/ / /)
      END
