c-----------------------------------------------------------------------
      SUBROUTINE TORS(I,J,K,L,X,Y,Z,VAL)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO CALCULATE THE TORSION -----
C
      DIMENSION X(*),Y(*),Z(*)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
C
      DATA CONVV/57.295779E0/
C
      VAL = 0.0E0
      XIJ = X(I)-X(J)
      YIJ = Y(I)-Y(J)
      ZIJ = Z(I)-Z(J)
      XKJ = X(K)-X(J)
      YKJ = Y(K)-Y(J)
      ZKJ = Z(K)-Z(J)
      XKL = X(K)-X(L)
      YKL = Y(K)-Y(L)
      ZKL = Z(K)-Z(L)
C
      DX = YIJ*ZKJ-ZIJ*YKJ
      DY = ZIJ*XKJ-XIJ*ZKJ
      DZ = XIJ*YKJ-YIJ*XKJ
      GX = ZKJ*YKL-YKJ*ZKL
      GY = XKJ*ZKL-ZKJ*XKL
      GZ = YKJ*XKL-XKJ*YKL
C
      BI = DX*DX+DY*DY+DZ*DZ
      BK = GX*GX+GY*GY+GZ*GZ
      CT = DX*GX+DY*GY+DZ*GZ
C
C     ----- BRANCH IF LINEAR DIHEDRAL -----
C
      IF(BK.LT.0.01.OR.BI.LT.0.01) GO TO 120
C
      CT = CT/SQRT(BI*BK)
      IF(CT.GT.  1.0E0 ) CT = 1.0E0
      IF(CT.LT.(-1.0E0)) CT = -1.0E0
C
C      ----- CT = -COSPHI  CHANGE ITS SIGN -----
C
      CT = -CT
      CT = ACOS(CT)*CONVV
      SIG = XIJ*GX+YIJ*GY+ZIJ*GZ
      IF(SIG.GT.0.E0) CT  = 3.60E+02-CT
      VAL = CT
      RETURN
  120 CONTINUE
      WRITE(IOUT,9008) I,J,K,L
      RETURN
 9008 FORMAT(5X,'WARNING ... LINEAR DIHEDRAL ',4I5,/)
      END
