c
c-----------------------------------------------------------------------
c
      SUBROUTINE WAT
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C -----routine to build pure "tip3p" Water for md
C
#include "sizes.h"

      COMMON/BOXPAR/IFBOX,IPTRES,NSPM,NSPSOL,BETA,BOX(3),NSP(MAXRES)
      COMMON/CORSOL/OXY(MAXWAT,3),HYDA(MAXWAT,3),HYDB(MAXWAT,3),
     $      cp(maxwat,3)
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     +             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/x(MAXATM),y(MAXATM),z(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
C
#include "files.h"
C
      DIMENSION CO(3,3),ITY(5)
C
      DATA ITY/4HOW  ,4HHW  ,4HH1  ,4HH2  ,4HO   /
      DATA IBLANK/4H     /
      DATA LABWAT/3HWAT /
      DATA IEND/1HE  /
      DATA MAIN/1HM /
      DATA IXYZ/3HXYZ  /,KCION/4HCIO /
C
      if (ioct.eq.1) then
        write(6,*) ' *** pure water - OCT not implemented'
        call mexit(6,1)
      endif
      if (ilink.ne.1) then
        write(6,*)' *** solute from link present (ILINK needs to be 1)'
        call mexit(6,1)
      endif
      NMOLW = NMOL+1      
      IFBOX = 1
      NFRESM(NMOLW) = NTOTRS+1
      IBOND(NMOLW) = NBOND+1
      ITHETA(NMOLW) = NTHETA+1
      IPHI(NMOLW) = NPHI+1
      ipres(nmolw) = 1
C
C     ----- PUT EACH MOLECULE DEFINED BY LINK AS ONE SUB-MOLECULE -----
C
      NSPM = 0
      JFIN = 1
      DO 140 I = 1,NMOL
         JRES = NFRESM(I+1)-NFRESM(I)
         JEND = JFIN+JRES-1
         NSPM = NSPM+1
         NSP(NSPM) = IPRES(JEND+1)-IPRES(JFIN)
         JFIN = JEND+1
  140 CONTINUE
      IPTRES = NFRESM(NMOL+1)-1
C
C     ----- DEFINE ALL THE SOLVENT MOLECULES AND THE COUNTER ION
C           IF ANY FOR GATHERING INTO THE BOX -----
C
      NSPSOL = 0
      DO 160 I = 1,NMOL
         JRES = NFRESM(I)
         IF(LABRES(JRES).EQ.KCION) GO TO 180
            NSPSOL = NSPSOL+1
  160 CONTINUE
  180 CONTINUE
      NSPSOL = NSPSOL+1
C
      WRITE(IOUT,1110)
      WRITE(IOUT,1100)
      WRITE(IOUT,1110)
      READ(IN,9108) KH,KO,NCUBE,itrim
      READ(IN,9118) QH
      IF(KH.EQ.IBLANK) KH = ITY(2)
      IF(KO.EQ.IBLANK) KO = ITY(1)
      IF(NCUBE.LE.0) NCUBE = 3
      QO = -2.0E0*QH
      WRITE (IOUT,1090) QH, QO
      WRITE(IOUT,1180) KH,KO
      WRITE(IOUT,1190) NCUBE
      write(iout,1195) itrim
      if(itrim .eq. 1) then
         read(in,9118) xnew,ynew,znew
         write(iout,1196) xnew,ynew,znew
      endif
C
      IN6 = 35
      IWAT = 0
C
C     ----- READ IN THE SOLVENT COORDINATES FROM A MONTE CARLO
C           SIMULATION. -----
C                       
c     subroutine amopen(lun,fname,fstat,fform,facc)
      call amopen(IN6, boxfil, 'O', 'F', 'R')
      CALL MCPDB(MAXWAT,IN6,NWATER,NCUBE,BOXL,OXY,HYDA,HYDB,IOUT)
      CALL CLOSC(IN6)
      WRITE (IOUT,1010) NWATER
      BETA = 90.0E0
c
c     (if there were any motivation for octhedral trim of a
c      pure water box, this might do it)
c
c     if (itrim.eq.0 .and. ioct.eq.1) then
c        xnew = boxl
c        ynew = boxl
c        znew = boxl
c        itrim = 1
c     endif
      if (itrim.eq.1) then
c  
c         -- translate to center of oxygens.
c
          coox = 0.0
          cooy = 0.0
          cooz = 0.0
          do 55 jn = 1,nwater
             coox = coox + oxy(jn,1)
             cooy = cooy + oxy(jn,2)
             cooz = cooz + oxy(jn,3)
   55     continue
          coox = coox/nwater
          cooy = cooy/nwater
          cooz = cooz/nwater
          do 56 jn = 1,nwater
             oxy(jn,1) = oxy(jn,1)-coox
             oxy(jn,2) = oxy(jn,2)-cooy
             oxy(jn,3) = oxy(jn,3)-cooz
             hyda(jn,1) = hyda(jn,1)-coox
             hyda(jn,2) = hyda(jn,2)-cooy
             hyda(jn,3) = hyda(jn,3)-cooz
             hydb(jn,1) = hydb(jn,1)-coox
             hydb(jn,2) = hydb(jn,2)-cooy
             hydb(jn,3) = hydb(jn,3)-cooz
   56     continue
          newwat = 0
          xlim = xnew/2.
          ylim = ynew/2.
          zlim = znew/2.
          do 57 jn = 1,nwater 
c
c            --- do rectilinear clip ---
c
             if(abs(oxy(jn,1)) .gt. xlim .or. abs(hyda(jn,1)) .gt. xlim
     $        .or. abs(hydb(jn,1)).gt. xlim) go to 57
             if(abs(oxy(jn,2)) .gt. ylim .or. abs(hyda(jn,2)) .gt. ylim
     $        .or. abs(hydb(jn,2)).gt. ylim) go to 57
             if(abs(oxy(jn,3)) .gt. zlim .or. abs(hyda(jn,3)) .gt. zlim
     $        .or. abs(hydb(jn,3)).gt. zlim) go to 57
c
c            --- if octahedron, clip corners too ---
c
c            if (ioct.eq.1) then
c               if((abs(oxy(jn,1)/xlim)+
c    .              abs(oxy(jn,2)/ylim)+
c    .              abs(oxy(jn,3)/zlim)) .gt. 0.75 ) go to 57
c               if((abs(hyda(jn,1)/xlim)+
c    .              abs(hyda(jn,2)/ylim)+          
c    .              abs(hyda(jn,3)/zlim)) .gt. 0.75 ) go to 57
c               if((abs(hydb(jn,1)/xlim)+          
c    .              abs(hydb(jn,2)/ylim)+
c    .              abs(hydb(jn,3)/zlim)) .gt. 0.75 ) go to 57
c            endif
 
             newwat = newwat+1
             oxy(newwat,1) = oxy(jn,1)
             oxy(newwat,2) = oxy(jn,2)
             oxy(newwat,3) = oxy(jn,3)
             hyda(newwat,1) = hyda(jn,1)
             hyda(newwat,2) = hyda(jn,2)
             hyda(newwat,3) = hyda(jn,3)
             hydb(newwat,1) = hydb(jn,1)
             hydb(newwat,2) = hydb(jn,2)
             hydb(newwat,3) = hydb(jn,3)
  57      continue
          box(1) = xnew 
          box(2) = ynew 
          box(3) = znew 
          nwater = newwat
          write(6,8088)nwater
 8088     format(t2,'%EDIT-I-TRIMBOX, waters remaining = ',i5)
      else
C
C         ----- GET THE MAXIMA AND MINMA OF THE COORDINATES -----
C
C
          box(1) = boxl
          box(2) = boxl
          box(3) = boxl
      endif
      NTOTAT = 0
C
C     ---- MAIN DO LOOP. ----
C
      DO 74 I = 1, NWATER
C
      DO 100 JATOM = 1, 3
         CO(1,JATOM) = OXY(I,JATOM) 
         CO(2,JATOM) = HYDA(I,JATOM)
         CO(3,JATOM) = HYDB(I,JATOM)
  100 CONTINUE
      IWAT = IWAT + 1
C
C     ----- THE WATER IS THE RIGHT STUFF -----
C
      DO 5 K = 1,3
         X(NTOTAT+K) = CO(K,1)
         Y(NTOTAT+K) = CO(K,2)
         Z(NTOTAT+K) = CO(K,3)
    5 CONTINUE
      NTOT = NTOTAT
      NTOT1 = NTOTAT+1
      NTOT2 = NTOTAT+2
      NTOTAT = NTOTAT+3
      JOIN(NTOT1) = NTOT-2
      JOIN(NTOT2) = NTOT1
      JOIN(NTOTAT) = NTOT1
c
      IB(NBOND+1) = NTOT1
      JB(NBOND+1) = NTOT2
c
      IB(NBOND+2) = NTOT1
      JB(NBOND+2) = NTOTAT
c
      IB(NBOND+3) = NTOT2
      JB(NBOND+3) = NTOTAT
c
      NBOND = NBOND+3
c
      ISYMBL(NTOT1) = KO
      ISYMBL(NTOT2) = KH
      ISYMBL(NTOTAT) = KH
c
      IGRAPH(NTOT1) = ITY(5)
      IGRAPH(NTOT2) = ITY(3)
      IGRAPH(NTOTAT) = ITY(4)
c
      CHRG(NTOT1) = QO
      CHRG(NTOT2) = QH
      CHRG(NTOTAT) = QH
c
      ITREE(NTOT1) = MAIN
      ITREE(NTOT2) = IEND
      ITREE(NTOTAT) = IEND
c
      IROTAT(NTOT1) = NTOTAT
      IROTAT(NTOT2) = NTOT2
      IROTAT(NTOTAT) = NTOTAT
c
      NUMEX(NTOT1) = 2
      NUMEX(NTOT2) = 1
      NUMEX(NTOTAT) = 1
c
      NEXT1 = NEXT+1
      NEXT2 = NEXT+2
      NEXT3 = NEXT+3
      NEXT = NEXT+4
c
      NATEX(NEXT1) = NTOT2
      NATEX(NEXT2) = NTOTAT
      NATEX(NEXT3) = NTOTAT
      NATEX(NEXT) = 0
C
C     ----- MAKE EACH OF THESE WATERS A SINGLE RESIDUE -----
C           
      NTOTRS = NTOTRS+1
      IF(NTOTRS.GE.MAXRES) GO TO 900
      LABRES(NTOTRS) = LABWAT
      ITRES(NTOTRS) = IXYZ
      IBRES(NTOTRS+1) = NBOND+1
      IPRES(NTOTRS+1) = NTOTAT+1
      NSPM = NSPM+1
      NSP(NSPM) = 3
   74 CONTINUE
C
C     ----- UPDATE THE MOLECULE INFORMATION ARRAY -----
C
      NFRESM(NMOLW+1) = NTOTRS+1
      IBOND(NMOLW+1) = NBOND+1
      ITHETA(NMOLW+1) = NTHETA+1
      IPHI(NMOLW+1) = NPHI+1
      NATML(NMOLW) = NTOTAT
      MOLTYP(NMOLW) = 4
      NMOL = NMOL+1
C
C     ----- PUT THE BOX IN THE POSITIVE QUADRANT -----
c     - add some clearance to prevent boundary overlaps -
C                
      XMIN = GCMIN(NTOTAT,X)
      YMIN = GCMIN(NTOTAT,Y)
      ZMIN = GCMIN(NTOTAT,Z)
      DO 82 I = 1,NTOTAT
        x(I) = x(I)-XMIN + 0.2e0
        y(I) = y(I)-YMIN + 0.2e0
        z(I) = z(I)-ZMIN + 0.2e0
   82 CONTINUE
      box(1) = box(1) + 0.4e0
      box(2) = box(2) + 0.4e0
      box(3) = box(3) + 0.4e0

C
      CGTOT = 0.
      DO 144 I = 1,NTOTAT
         IF(ISYMBL(I).EQ.ISYMDU) GO TO 144
            CGTOT = CGTOT+CHRG(I)
  144 CONTINUE
      WRITE (IOUT,1120) IWAT
      WRITE(IOUT,270) CGTOT
      WRITE(IOUT,9438) BOX(1),BOX(2),BOX(3)
      WRITE(IOUT,9448) NSPM
      WRITE(IOUT,9468) IPTRES,NSPSOL
      RETURN
  900 CONTINUE
      WRITE(IOUT,9508) NTOTRS
      call mexit(iout, 1)
  270 FORMAT(/,t2,'TOTAL CHARGE ON MOLECULE  = ',F9.3,/)
 1010 FORMAT (/,t2,i6,' WATER MOLECULES ARE INITIALLY CONSIDERED')
 1090 FORMAT (/,t2,'HYDROGEN CHARGE = ',F6.3,5X,' OXYGEN CHARGE = ',
     +        F6.3)
 1100 FORMAT (t2,'Generating a liquid')
 1110 FORMAT (t2,'___________________')
 1120 FORMAT (/,t2,i6,' Water molecules comprise the liquid')
 1180 FORMAT(/t2,'ATOM TYPE FOR HYDROGEN = ',A4,2X,'AND FOR OXYGEN = ',
     +        A4,/)
 1190 format(/t2,'Number of 216 molecule water cubes to be generated ='
     +       ,I2)
 1195 format(/t2,'box trim option = ',i3,' (0 = off, 1 = on)')
 1196 format(/t2,'box sizes for trim: ',3f10.3)
 9108 FORMAT(A4,1X,A4,1X,I5,i5)
 9118 FORMAT(5F10.5)
 9438 format(/t2,'box X =',F10.2,' box Y =',F10.2,' box Z =',F10.2)
 9448 FORMAT(/T2,'NUMBER OF SUB-MOLECULES FOR DYNAMICS =',I5,
     +       /T2,'AND THE POINTERS FOR THE SOLUTE IS',/)
 9468 FORMAT(/T2,'THE SOLUTE RESIDUE POINTER FOR SKIPPING THE BC =',I5,
     +       /T2,'THE SUBMOLECULE INDEX FOR THE SOLVENT MOLECULE =',I5)
 9508 FORMAT(t2,'%EDIT-F-TOOMANY, number of residues exceeded',i7)
      END
