c-----------------------------------------------------------------------
      SUBROUTINE WSOL
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c     Generates either a water "BLOB" around entire solute or a "CAP"
c     (Spherical region of water) centered on a point in cartesian
c     space.  IGROUP = 0 for BLOB, +/- 1 for CAP.  see edit.doc
c     Rev A mods by G. Seibel:
c         -The "wall" thing never would have worked, even if anyone
c          had ever tried to use it.  I have removed it.  Not only
c          was it incompatible with the simulation programs ideas
c          about residues, it was never activated here anyway.
c         -fixed uninitialized OX,OY,OZ
c         -changed output format to handle large systems, f6.4 for charges.
c         -Added parameterization, overwrite protection.
c         -Removed dead or useless code.
      LOGICAL KONST,BELLY
C
#include "sizes.h"
      COMMON/CORSOL/OXY(MAXWAT,3),HYDA(MAXWAT,3),HYDB(MAXWAT,3),
     $  cp(maxwat,3)
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU,ioct
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),
     +             IBRES(MAXRES),IPRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +       ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),NATN(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP,ilink
      COMMON/WORKA/MIXC(MAXATM),IWORK(MAXATM)
      COMMON/WATCAP/IFCAP,NATCAP,CUTCAP,XCAP,YCAP,ZCAP
#include "files.h"
      character*4 tmpnam, atnam
C
      DIMENSION CO(3,3),ITY(5)
      DIMENSION RSQ(MAXATM),XC(3),X0(3)
      EQUIVALENCE (MIXC(1),RSQ(1))
C
      DATA ITY/4HOW  ,4HHW  ,4HH1  ,4HH2  ,4HO   /
      DATA IBLANK/4H     /
      DATA LABWAT/3HWAT /
      DATA IEND/1HE  /
      DATA MAIN/1HM /
      DATA IXYZ/3HXYZ  /
C
c     initialize X0 for HP (Veenstra, 10/92)
c
      X0(1) = 0.0
      X0(2) = 0.0
      X0(3) = 0.0
c
      NMOLW = NMOL+1
      NMOLWA = NMOL+2
C
      WRITE(IOUT,1110)
      WRITE(IOUT,1100)
      WRITE(IOUT,1110)
C
C     ----- DISO = DISTANCE ABOUT WATER OXYGEN THAT CONTACT WITH SOLUTE
C                  IS CHECKED
C           DISH = DISTANCE ABOUT WATER HYDROGEN THAT CONTACT WITH SOLUT
C                  IS CHECKED
C           QH   = CHARGE ON EACH HYDROGEN
C                
      READ(IN,9108) KH,KO,NCUBE
      IF(NCUBE.LE.0) NCUBE = 3
      READ(IN,9118) QH,DISO,DISH
      IF(KH.EQ.IBLANK) KH = ITY(2)
      IF(KO.EQ.IBLANK) KO = ITY(1)
      QO = -2.0E0*QH
      WRITE (IOUT,1070) DISO
      WRITE (IOUT,1080) DISH
      WRITE (IOUT,1090) QH, QO
      WRITE(IOUT,1180) KH,KO
      WRITE(IOUT,1190) NCUBE
      DISO = DISO * DISO
      DISH = DISH * DISH
C
      IN6 = 35
      IWAT = 0
      XCM = 0.0
      YCM = 0.0
      ZCM = 0.0
      AWT = 0.0
      NORIGT = NTOTAT
      IFCAP = 0
      NATCAP = NTOTAT
C
      READ(IN,9128)  IORINT, IPRINT,NOWALL,IGROUP
      IF (IORINT .EQ. 0) WRITE(IOUT,1020)
      IF(IORINT.NE.0)  WRITE (IOUT,1030)
C
      READ(IN,9118) CUT,XMOVE,YMOVE,ZMOVE
      WRITE (IOUT,1050) CUT
      IF(IGROUP.NE.0) IFCAP = 1
      IF (IGROUP.lt.0) then
C
C        ----- CAP on xyz: SET THE CENTER OF MASS AS XMOVE ETC 
C
	 WRITE(IOUT, 9119) XMOVE, YMOVE, ZMOVE
         XC(1) = XMOVE
         XC(2) = YMOVE
         XC(3) = ZMOVE
         XCOM = XMOVE
         YCOM = YMOVE
         ZCOM = ZMOVE
      else
C
C        ----- FILLUP THE GROUP ARRAY -----
C
         NATGRP = NORIGT
         NGRP = 0
         KONST = .FALSE.
         BELLY = IGROUP.GT.0
         DO 20 I = 1,NATGRP
            IWORK(I) = 1
  20     CONTINUE
C
C        ----- LOAD THE REGION OF INTEREST AS GROUPS -----
C
         IF (BELLY) then
C
           CALL RGROUP(NORIGT,NATGRP,NTOTRS,NGRP,IPRES,LABRES,IGRAPH,
     +            ISYMBL,ITREE,IWORK,RSQ,RSQ,KONST,BELLY,5)
           NATGRP = 0
           DO 28 I = 1,NORIGT
              IF(IWORK(I).gt.0) NATGRP = NATGRP+1
  28       CONTINUE
           WRITE(IOUT,1130) NATGRP
         endif
         DUM = FLOAT(NATGRP)
C
C        ----- CALCULATE THE CENTER OF MASS OF THE SOLUTE. -----
C
         DO 70 I = 1, NORIGT
            IF(IWORK(I).gt.0) then
              XCM = XCM + R(I)
              YCM = YCM + THETA(I)
              ZCM = ZCM + PHI(I)
            endif
   70    CONTINUE
         XC(1) = XCM/DUM
         XC(2) = YCM/DUM
         XC(3) = ZCM/DUM
         XCOM = XC(1)
         YCOM = XC(2)
         ZCOM = XC(3)
      endif
      CUTCAP = CUT
      XCAP = XCOM
      YCAP = YCOM
      ZCAP = ZCOM
      CUT = CUT*CUT
C
C     ----- READ IN THE SOLVENT COORDINATES FROM A MONTE CARLO
C           SIMULATION. -----
C
c     subr amopen(lun,   fname,fstat,fform,facc)
      call amopen(in6,  boxfil, 'O',  'F',  'R')
      CALL MCPDB(MAXWAT,IN6,NWATER,NCUBE,BOXL,OXY,HYDA,HYDB,IOUT)
      CALL CLOSC(IN6)
      WRITE(IOUT,1010) NWATER
C
C     ----- CALCULATE THE CENTER OF MASS OF THE SOLVENT. -----
C
      OX = 0.0
      OY = 0.0
      OZ = 0.0
      DO 90 I = 1, NWATER
         OX = OX + OXY(I,1)
         OY = OY + OXY(I,2)
         OZ = OZ + OXY(I,3)
  90  CONTINUE
      DUM = FLOAT(NWATER)
      OX = OX/DUM
      OY = OY/DUM
      OZ = OZ/DUM
      XC(1) = XC(1) - OX
      XC(2) = XC(2) - OY
      XC(3) = XC(3) - OZ
C
C     ---- MAIN DO LOOP. ----
C
      DO 740 I = 1, NWATER
C
      DO 100 JATOM = 1, 3
         CO(1,JATOM) = OXY(I,JATOM) + XC(JATOM)
         CO(2,JATOM) = HYDA(I,JATOM) + XC(JATOM)
         CO(3,JATOM) = HYDB(I,JATOM) + XC(JATOM)
  100 CONTINUE
C
C     ---- TESTING ROUTINE.  FOR LARGE SYSTEMS (E.G. PROTEIN IN A
C          LARGE WATER BATH) THEN THE CENTER OF MASS OF IGROUP RESIDUES
C          (E.G. THE ACTIVE SITE RESIDUEE) ARE USED AS AN INITIAL CUTOFF
C          CRITERION CHECK. ----
C
      IF (IGROUP .EQ. 0) GO TO 300
         XX = (CO(1,1) - XCOM) ** 2
         YY = (CO(1,2) - YCOM) ** 2
         ZZ = (CO(1,3) - ZCOM) ** 2
         DIST = XX + YY + ZZ
         IF (DIST .GT. CUT) GO TO 740
  300 CONTINUE
C
      DDO = 9999.0
      DDH = 9999.0
C
C     ----- CHECK DISTANCE ABOUT OXYGEN AND BOTH HYDROGENS. -----
C
      DO 400 J = 1,NORIGT
C
        RSQ(J) = (CO(1,1)-R(J))**2+(CO(1,2)-THETA(J))**2+
     +           (CO(1,3)-PHI(J))**2
        IF(RSQ(J) .LT. DDO) DDO = RSQ(J)
C
C       ----- IF DISH IS SMALL SKIP THIS CRITERION -----
C
        IF(DISH.LE.1.0E-03) GO TO 400
C
        D = (CO(2,1)-R(J))**2+(CO(2,2)-THETA(J))**2+(CO(2,3)-PHI(J))**2
        IF(D .LT. DDH) DDH = D
        D = (CO(3,1)-R(J))**2+(CO(3,2)-THETA(J))**2+(CO(3,3)-PHI(J))**2
        IF(D .LT. DDH) DDH = D
  400 CONTINUE
C
      IF(DDO .LT. DISO) GO TO 740
      IF(DDH .LT. DISH) GO TO 740
      IF(DDO .GT. CUT)  GO TO 740
C
      IWAT = IWAT + 1
C
C     ----- CHECK FOR REORIENTATION OF WATER MOLECULES. -----
C
      IF (IORINT .NE. 0) CALL CALPO(CO,NORIGT,IWAT,IPRINT,RSQ,XC,X0)
      if (ntotat+3 .gt. MAXATM) then
           write(iout,'(/2x,a,i6,a)') 'wsol: MAXATM =',MAXATM,
     +           ' exceeded'
           call mexit(iout, 1)
      endif
      DO 500 K = 1,3
         R(NTOTAT+K) = CO(K,1)
         THETA(NTOTAT+K) = CO(K,2)
         PHI(NTOTAT+K) = CO(K,3)
  500 CONTINUE
      NTOT = NTOTAT
      NTOT1 = NTOTAT+1
      NTOT2 = NTOTAT+2
      NTOTAT = NTOTAT+3
      JOIN(NTOT1) = NTOT-2
      JOIN(NTOT2) = NTOT1
      JOIN(NTOTAT) = NTOT1
      if (nbond+3 .gt. MAXBND) then
           write(iout,'(/2x,a,i6,a)') 'wsol: MAXBND =',MAXBND,
     +           ' exceeded'
           call mexit(iout, 1)
      endif
      IB(NBOND+1) = NTOT1
      JB(NBOND+1) = NTOT2
      IB(NBOND+2) = NTOT1
      JB(NBOND+2) = NTOTAT
      IB(NBOND+3) = NTOT2
      JB(NBOND+3) = NTOTAT
      NBOND = NBOND+3
      ISYMBL(NTOT1) = KO
      ISYMBL(NTOT2) = KH
      ISYMBL(NTOTAT) = KH
      IGRAPH(NTOT1) = ITY(5)
      IGRAPH(NTOT2) = ITY(3)
      IGRAPH(NTOTAT) = ITY(4)
      CHRG(NTOT1) = QO
      CHRG(NTOT2) = QH
      CHRG(NTOTAT) = QH
      ITREE(NTOT1) = MAIN
      ITREE(NTOT2) = IEND
      ITREE(NTOTAT) = IEND
      IROTAT(NTOT1) = NTOTAT
      IROTAT(NTOT2) = NTOT2
      IROTAT(NTOTAT) = NTOTAT
      NUMEX(NTOT1) = 2
      NUMEX(NTOT2) = 1
      NUMEX(NTOTAT) = 1
      NEXT1 = NEXT+1
      NEXT2 = NEXT+2
      NEXT3 = NEXT+3
      NEXT = NEXT+4
      if (next .gt. MAXEXC) then
           write(iout,'(/2x,a,i6,a)') 'wsol: MAXEXC =',MAXEXC,
     +           ' exceeded'
           call mexit(iout, 1)
      endif
      NATEX(NEXT1) = NTOT2
      NATEX(NEXT2) = NTOTAT
      NATEX(NEXT3) = NTOTAT
      NATEX(NEXT) = 0
C
C     ----- MAKE EACH OF THESE WATERS A SINGLE RESIDUE -----
C
      NTOTRS = NTOTRS+1
      if (ntotrs .ge. MAXRES) then
           write(iout,'(/2x,a,i6,a)') 'wsol: MAXRES =',MAXRES,
     +           ' exceeded'
           call mexit(iout, 1)
      endif
      LABRES(NTOTRS) = LABWAT
      ITRES(NTOTRS) = IXYZ
      IBRES(NTOTRS+1) = NBOND+1
      IPRES(NTOTRS+1) = NTOTAT+1
C
  740 CONTINUE
C
C     ----- UPDATE THE MOLECULE INFORMATION ARRAY -----
C
      if (nmol+1 .gt. MAXMOL) then
           write(iout,'(/2x,a,i6,a)') 'wsol: MAXMOL =',MAXMOL,
     +           ' exceeded'
           call mexit(iout, 1)
      endif
      NFRESM(NMOLW+1) = NTOTRS+1
      IBOND(NMOLW+1) = NBOND+1
      ITHETA(NMOLW+1) = NTHETA+1
      IPHI(NMOLW+1) = NPHI+1
      NATML(NMOLW) = NTOTAT
      MOLTYP(NMOLW) = 4
      NMOL = NMOL+1
      CGTOT = 0.
      DO 855 I = 1,NTOTAT
         IF(ISYMBL(I).EQ.ISYMDU) GO TO 855
         CGTOT = CGTOT+CHRG(I)
  855 CONTINUE
      WRITE (IOUT,1120) IWAT
      WRITE(IOUT,270) CGTOT
      RETURN
  270 FORMAT(t2,'TOTAL CHARGE ON MOLECULE  = ',F9.3,/)
 1010 FORMAT (t2,'There are ',I5,' water molecules initially',
     +        ' considered')
 1020 FORMAT (t2,'WATER MOLECULES WILL NOT BE REORIENTED')
 1030 FORMAT (t2,'WATER MOLECULES WILL BE REORIENTED')
 1050 FORMAT (t2,'ALL WATER MOLECULES GREATER THAN ',F6.2,
     +        ' ANGSTROMS',/,6X,'FROM THE SOLUTE WILL BE DISCARDED')
 1070 FORMAT (t2,'ANY WATER WITH AN OXYGEN DISTANCE LESS THAN ',F6.2,
     +        ' ANGSTROMS',/,6X,'FROM THE SOLUTE WILL BE DISCARDED')
 1080 FORMAT (t2,'ANY WATER WITH A HYDROGEN DISTANCE LESS THAN ',
     +       F6.2,' ANGSTROMS',/,6X,'FROM THE SOLUTE WILL BE DISCARDED')
 1090 FORMAT (t2,'HYDROGEN CHARGE = ',F6.4,5X,' OXYGEN CHARGE = ',F6.4)
 1100 FORMAT (t2,'WATER MOLECULES WILL BE PLACED AROUND THE SOLUTE')
 1110 FORMAT (t2,'************************************************')
 1120 FORMAT (t2,I5,' WATER MOLECULES ARE SOLVATING THE SOLUTE')
 1130 FORMAT (t2,I5,' SOLUTE ATOMS FOUND FOR CENTER OF MASS ',
     +        'CALCULATION')
 1180 FORMAT(t2,'ATOM TYPE FOR HYDROGEN = ',A4,2X,'AND FOR OXYGEN = ',
     +        A4,/)
 1190 FORMAT(t2,'NUMBER OF 216WATER CUBES TO BE GENERATED =',I5,'^3')
 9108 FORMAT(A4,1X,A4,1X,I5)
 9118 FORMAT(5F10.5)
 9119 FORMAT(1x,'COORDINATES TO CENTER WATER: ',3F10.5)
 9128 FORMAT(10I5)
      END
