C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
#ifndef DPREC
      REAL FUNCTION DDOTP(N,DX,DY)
#else
      double precision FUNCTION DDOTP(N,DX,DY)
      implicit double precision (a-h,o-z)
#endif
      double precision dum
c     Rev A mods: cpp selectable precision, but force the dot product
c                 to be done double precision all the time.  This should
c                 improve convergence noticeably.
c
c     blas1 note: we do not call the single precision equivalent (sdot)
c     since in the standard code, the value is accumulated as a 
c     double precision then returned as a single precision...
C
C     ----- EVALUATES DOT PRODUCT OF DX AND DY -----
C
      DIMENSION DX(*),DY(*)
C
#if defined(BLAS1) && defined(DPREC)
      DUM = ddot(n,dx,1,dy,1)
#else
      DUM = 0.0D0
      IF(N.LE.0) GO TO 60
      DO 50 I = 1,N
      DUM = DUM+DX(I)*DY(I)
   50 CONTINUE
   60 CONTINUE
#endif /* BLAS1 */
      DDOTP = DUM
      RETURN
      END
