c-----------------------------------------------------------------------
      SUBROUTINE CHKDIH(IS,IF,NPHIS,NPHI)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c     Rev A mod:  Since this dangling improper removal is a normal
c                 behavior, I have removed the cryptic messages that
c                 looked like error output. -GLS, Apr 89
#include "sizes.h"
      CHARACTER*1 NLINK,ICONNR
C
      COMMON/CONNR/NLINK,ICONNR(MAXRES)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),IBRES(MAXRES),
     +             IPRES(MAXRES),IFRES(MAXRES)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
C
C     ----- CHECK THAT NO DIHEDRAL ANGLES IN MOLECULE ARE OUT OF RANGE
C           THIS IS NECESSARY WHEN DEALING WITH FRAGMENTS OF MOLECULES
C           THAT MAY NOT TERMINATE NORMALLY -----
C
      DIMENSION II(4)
C
C     ----- CHECK IF ANY DIHEDRALS ARE DEFINED FOR THIS MOLECULE -----
C
      IF(NPHIS.GT.NPHI) RETURN
C
      IFLAG = 0
      DO 10 I = NPHIS,NPHI
      II(1) = IP(I)
      II(2) = JP(I)
      IT = KP(I)
      II(3) = IABS(IT)
      IT = LP(I)
      II(4) = IABS(IT)
      DO 111 J = 1,4
      IAT = II(J)
      IF(IAT.GE.IS.AND.IAT.LE.IF) GO TO 11
*     WRITE(IOUT,33) (II(L),L = 1,4)
      IFLAG = 1
      IP(I) = 0
      GO TO 10
   11 CONTINUE
C
C     ----- CHECK FOR DIHEDRALS BETWEEN SPACER RESIDUES
C           COULD ELIMINATE THESE IN BLDIT BY CHECKING WHEN ICONN = 0
C           IF ANY ATOM IN DIHEDRAL IS LT 1ST ATOM IN RESIDUE
C           IF DO THIS ALSO MUST CHECK IF NEXT RESIDUE IS
C           CONNECTED -----
C
C           IF NOT - THEN ELIMINATE DIHEDRALS THAT GO TO NEXT RES
C
      CALL FINDRS(IAT,IRES)
      IF(ICONNR(IRES).NE.NLINK) GO TO 111
C
C     ----- NOW MUST CHECK IF ANY OF THE FOUR ATOMS ARE BEFORE RESIDUE
C
      IFRST = IPRES(IRES)
      IF((II(1).GE.IFRST).AND.(II(2).GE.IFRST).AND.
     +   (II(3).GE.IFRST).AND.(II(4).GE.IFRST)) GO TO 111
*     WRITE(IOUT,96) (II(L),L = 1,4)
      IFLAG = 1
      IP(I) = 0
      GO TO 10
  111 CONTINUE
   10 CONTINUE
      IF(IFLAG.EQ.0) RETURN
C
C     ----- DELETE DIHEDRALS THAT SHOULD NOT BE THERE -----
C
      NC = NPHIS-1
      DO 30 I = NPHIS,NPHI
      IF(IP(I).EQ.0) GO TO 30
      NC = NC+1
      IP(NC) = IP(I)
      JP(NC) = JP(I)
      KP(NC) = KP(I)
      LP(NC) = LP(I)
   30 CONTINUE
      NPHI = NC
      RETURN
*  33 FORMAT(1H ,5X,'**** DIHEDRAL ANGLE REMOVED BETWEEN ATOMS IN',
*    +       ' DIFFERENT MOLECULES -',4I5,3X,'********',/)
*  96 FORMAT(1H ,5X,'**** DIHEDRAL REMOVED BETWEEN ATOMS NOT JOINED -',
*    +           4I5,3X,'***********',/)
      END
