c-----------------------------------------------------------------------
      SUBROUTINE EXCLM(IEX,JEX,NEX)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/WORKA/ITMP(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
C
C      INDX0 =  1-NEXT    POINTER TO NEW NATEX ARRAY
C      INDX1 =  1-NTOTAL  POINTER TO REST OF ARRAY NATEX STORED IN ITMP
C      INDX2 =  1-NEX     POINTER TO IEX ARRAY
C      IEX AND JEX ARE THE ARRAY OF NEX EXCLUDED ATOM PAIRS
C
      DIMENSION IEX(*),JEX(*)
C
      IF(NEX.EQ.0) RETURN
C
      INDX2 = 1
      IA1 = IEX(1)
      INDX0 = 0
      IF(IA1.GT.NBUILD) GO TO 11
      DO 10 I = 1,NBUILD
      IF(I.EQ.IA1) GO TO 20
      INDX0 = INDX0+NUMEX(I)
   10 CONTINUE
   11 WRITE(IOUT,137) IA1,NBUILD
      call mexit(iout, 1)
  137 FORMAT(t2,'LINK-F-EXCLUDPROB, first atom to be merged  = ',i5,5x,
     +       'is greater than the last atom in excluded list  = ',/)
   20 CONTINUE
C
C     ----- STORE REST OF ORIGINAL LIST INTO ARRAY ITMP -----
C
      NSTORE = NEXT-INDX0
      IF(NSTORE.GT.MAXEXC) then
         write(iout,999)
999      format(t2,'LINK-F-TOOMANY, too many excluded atom, buffer',
     +          ' overflow')
         call mexit(iout, 1)
      endif
      IF(NSTORE.LE.0) then
         write(iout,998)
998      format(t2,'LINK-F-TOOFEW, there are no excluded atoms for',
     +          ' this reside')
         call mexit(iout, 1)
      endif
      JS = INDX0+1
      NTOTAL = 0
      DO 30 J = JS,NEXT
      NTOTAL = NTOTAL+1
      ITMP(NTOTAL) = NATEX(J)
   30 CONTINUE
      IS = I
      IA2 = IEX(1)
      INDX1 = 1
      INDX2 = 1
C
C     ----- NOW GO THRU ATOMS, STARTING WITH 1ST ONE WITH AN EXCLUDED
C           ATOM TO BE ADDED -----
C
      DO 80 I = IS,NBUILD
      II = 1
      JF = NUMEX(I)
      ITOT = 0
C
C     ----- IF NO ADDITIONS TO BE MADE, STORE ORIGINAL EXCLUDED ATOMS
C           BACK INTO LIST -----
C
      IF(IA2.NE.I) GO TO 41
  100 CONTINUE
      INDX2A = JEX(INDX2)
C
C     ----- MERGE 2 GROUPS OF EXCLUDED ATOMS TOGETHER -----
C
      IF(II.GT.JF) GO TO 42
      INDX1A = ITMP(INDX1)
      IF(INDX2A.LT.INDX1A) GO TO 42
      IF(INDX2A.EQ.INDX1A) GO TO 13
      INDX1 = INDX1+1
      II = II+1
      IF(INDX1A.EQ.0) GO TO 100
      ITOT = ITOT+1
      INDX0 = INDX0+1
      NATEX(INDX0) = INDX1A
      GO TO 100
   42 INDX0 = INDX0+1
      ITOT = ITOT+1
      NATEX(INDX0) = INDX2A
      INDX2 = INDX2+1
      IF(INDX2.GT.NEX) IA2 = -99
      IF(INDX2.GT.NEX) GO TO 41
      IA2 = IEX(INDX2)
      IF(IA2.NE.I) GO TO 41
      GO TO 100
   41 IF(II.GT.JF) GO TO 40
C
C     ----- WHEN REACH THIS POINT, NO MORE NEW ATOMS TO ADD, STORE REST
C           OF EXCLUDED ATOMS BACK INTO LIST -----
C
      DO 50 J = II,JF
      IF(ITOT.GT.0.AND.ITMP(INDX1).EQ.0) GO TO 50
      ITOT = ITOT+1
      INDX0 = INDX0+1
      NATEX(INDX0) = ITMP(INDX1)
      INDX1 = INDX1+1
   50 CONTINUE
   40 NUMEX(I) = ITOT
   80 CONTINUE
      NEXT = INDX0
      RETURN
   13 WRITE(IOUT,103) I,INDX2A
      call mexit(iout, 1)
  103 FORMAT(t2,'LINK-F-EXTWICE atom ',i5,' has excluded atom'
     +      ,i5,' listed twice',/)
      END
