c-----------------------------------------------------------------------
      SUBROUTINE JOINT
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU
      COMMON/CROSSL/IRCRSS,NCROSS,NCROSF,IACRSS(MAXCRS),JACRSS(MAXCRS),
     +              ICROS(MAXCRS),JCROS(MAXCRS)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
C
      DIMENSION NAB0(30),NAB1(30),NABP(30)
      DIMENSION IBEX(400),JBEX(400),IBEXL(400),JBEXL(400)
      DIMENSION NPOINT(400)
C
      EQUIVALENCE (NTHETA,NTH)
      EQUIVALENCE(NPHI,NPH)
C
      NTHO = NTH+1
      NPHO = NPH+1
      CALL FINDBA(NA0,NA1,NATB0,NAB0)
      CALL FINDBA(NA1,NA0,NATB1,NAB1)
      NEX = 1
      IBEX(NEX) = NA0
      JBEX(NEX) = NA1
C
C     ----- DO ANGLES FROM ATOM NA0 TO NA1 -----
C
      IF(NATB0.EQ.0) GO TO 39
      DO 30 I = 1,NATB0
      NTH = NTH+1
      NAP = NAB0(I)
      if (nth .gt. MAXANG) then
           write(iout,'(/,5x,a,i6,a)') 'MAXANG =',MAXANG,' exceeded.'
           call mexit(iout, 1)
      endif
      IT(NTH) = NAP
      JT(NTH) = NA0
      KT(NTH) = NA1
      NEX = NEX+1
      IBEX(NEX) = NAP
      JBEX(NEX) = NA1
      CALL FINDBA(NAP,NA0,NATBP,NABP)
      IF(NATBP.EQ.0) GO TO 34
      DO 35 J = 1,NATBP
C
C     ----- 3 MEMBERED RINGS IN CROSSLINKS CAN RESULT IN THE SAME
C           END ATOM -----
C
      IF(NABP(J).EQ.NA1) GO TO 35
      NPH = NPH+1
      IP(NPH) = NABP(J)
      JP(NPH) = NAP
      KP(NPH) = NA0
      LP(NPH) = NA1
      NEX = NEX+1
      IBEX(NEX) = NABP(J)
      JBEX(NEX) = NA1
   35 CONTINUE
   34 CONTINUE
      IF(NATB1.EQ.0) GO TO 32
      DO 31 J = 1,NATB1
      NAPP = NAB1(J)
      IF(NAP.EQ.NAPP) GO TO 31
      NPH = NPH+1
      IP(NPH) = NAP
      JP(NPH) = NA0
      KP(NPH) = NA1
      LP(NPH) = NAPP
      NEX = NEX+1
      IBEX(NEX) = NAP
      JBEX(NEX) = NAPP
   31 CONTINUE
   32 CONTINUE
   30 CONTINUE
   39 CONTINUE
      IF(NATB1.EQ.0) GO TO 50
      DO 40 I = 1,NATB1
      IA = NAB1(I)
      NTH = NTH+1
      if (nth .gt. MAXANG) then
           write(iout,'(/,5x,a,i6,a)') 'MAXANG =',MAXANG,' exceeded.'
           call mexit(iout, 1)
      endif
      IT(NTH) = NA0
      JT(NTH) = NA1
      KT(NTH) = IA
      NEX = NEX+1
      IBEX(NEX) = NA0
      JBEX(NEX) = IA
      CALL FINDBA(IA,NA1,NATBP,NABP)
      IF(NATBP.EQ.0) GO TO 40
      DO 41 J = 1,NATBP
      IF(NABP(J).EQ.NA0) GO TO 41
      NPH = NPH+1
      IP(NPH) = NA0
      JP(NPH) = NA1
      KP(NPH) = IA
      LP(NPH) = NABP(J)
      NEX = NEX+1
      IBEX(NEX) = NA0
      JBEX(NEX) = NABP(J)
   41 CONTINUE
   40 CONTINUE
   50 CONTINUE
C
      IF(NEX.GT.400) WRITE(IOUT,110) NEX
C
C     ----- ONLY NEED THIS SECTION IF CROSSLINKING 1 ATOM TO 2 DIFFERENT
C            ATOMS -----
C            LOOPS MAY HAVE THE SAME END ATOM (3 MEMBERED RINGS)
C            OR EXTRA NONBONDED INTERACTIONS THAT SHOULDNT BE
C            CALCULATED IN MINM -----
C
C
      IF(NCROSF.EQ.0) GO TO 107
C
C     ----- ORDER ALL ANGLES AND DIHEDRAL ANGLES -----
C
      IF(NTHO.GT.NTH) GO TO 81
      DO 80 I = NTHO,NTH
      IF(IT(I).LT.KT(I)) GO TO 80
      ITMP = IT(I)
      IT(I) = KT(I)
      KT(I) = ITMP
   80 CONTINUE
   81 IF(NPHO.GT.NPH) GO TO 83
      DO 82 I = NPHO,NPH
      IF(IP(I).LT.LP(I)) GO TO 182
      ITMP = IP(I)
      JTMP = JP(I)
      IP(I) = LP(I)
      JP(I) = KP(I)
      KP(I) = JTMP
      LP(I) = ITMP
  182 CONTINUE
C
   82 CONTINUE
   83 CONTINUE
      LEX = 0
      DO 208 I = 1,NEX
      IF(IBEX(I).LT.JBEX(I)) GO TO 108
      ITMP = IBEX(I)
      IBEX(I) = JBEX(I)
      JBEX(I) = ITMP
  108 CONTINUE
      CALL ISEXC(IBEX(I),JBEX(I),ISKIP)
      IF(ISKIP.EQ.1) GO TO 208
      LEX = LEX+1
      IBEX(LEX) = IBEX(I)
      JBEX(LEX) = JBEX(I)
  208 CONTINUE
      NEX = LEX
      IF(NEX.LE.0) RETURN
  107 CONTINUE
      DO 60 I = 1,NEX
   60 NPOINT(I) = I
      CALL SORTS(IBEX,JBEX,NPOINT,NEX)
      IPRE = -999
      JPRE = -999
      ICNT = 0
      DO 61 I = 1,NEX
      J = NPOINT(I)
      IF(IBEX(J).NE.IPRE.OR.JBEX(J).NE.JPRE) GO TO 65
      WRITE(IOUT,66) IPRE,JPRE
      GO TO 61
   65 CONTINUE
      ICNT = ICNT+1
      IBEXL(ICNT) = IBEX(J)
      JBEXL(ICNT) = JBEX(J)
      IPRE = IBEX(J)
      JPRE = JBEX(J)
   61 CONTINUE
      NEX = ICNT
C
C     ----- MERGE THESE EXCLUDED ATOMS INTO EXCLUDED LIST -----
C
      CALL EXCLM(IBEXL,JBEXL,NEX)
      RETURN
  110 FORMAT(5X,'***** NEX  = ',I5,2X,'IS TOO LARGE IN JOINT ****',/)
   66 FORMAT('***2 EXCLUDED ATOMS ARE REPEATED IN JOINT***',2I5,/)
      END
