c-----------------------------------------------------------------------
      PROGRAM LINK
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995, 1997                **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c
c     AMBER Version 5   LINK  
c
c     PARAMETERS:
c
#include "sizes.h"
c
      CHARACTER*1 NLINK,YLINK,ISET,ICONNR
      character*40 KERES
      CHARACTER*80 KDIR
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU
      COMMON/CONNR/NLINK,ICONNR(MAXRES)
      COMMON/CROSSL/IRCRSS,NCROSS,NCROSF,IACRSS(MAXCRS),JACRSS(MAXCRS),
     +              ICROS(MAXCRS),JCROS(MAXCRS)
      COMMON/EXRES/NERES,IERES(MAXEXR),JERES(MAXEXR)
      common/exnam/KERES(MAXEXR)
      COMMON/EXDAT/CHG(150),RTP(3,150),ITYP(3,150),MB(2,300),MT(3,350),
     +  MP(4,400),NC(150),MUMEX(150),MATEX(600),IROT(150),JPLOT(2,400)
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),IBRES(MAXRES),
     +             IPRES(MAXRES),IFRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +             ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
      COMMON/RUNHED/ITITL(20),ITITL1(20)
      COMMON/WORKA/IWORK(MAXEXC)
      common/files/infil,outfil,binfil, prpfil, owrite
      character*80 infil, outfil, binfil, prpfil
      character owrite
C
      DIMENSION LBDUM(20),JTDUM(20),LTYP(4)
C
      DATA LTYP,KSPACE/1HR,1HD,1HP,1HO,4H*** /
      DATA KQUIT,IBLANK,MAIN/4HQUIT,4H    ,1HM/
c
c
      ylink = 'Y'
      nlink = 'N'
      in = 5
      iout = 6
      ioutb = 10
C
c     --- get file names ---
c
      call lnkfil
c
c     --- open output first so there's a standard place for error info ---
c
c     subr amopen(lun,fname,fstat,fform,facc)
      if(outfil.ne.'screen') then
      call amopen(iout,outfil,owrite,'F','W')
      endif
      call amopen(in,infil,'O','F','R')
      call amopen(ioutb,binfil,owrite,'U','W')
      if (owrite.eq.'U') write(6, '(2x,a)') '[-O]verwriting output'
C
C     --- Open the Database ---
C
      CALL OPENDA(2,prpfil)
C
      NEXT = 0
      NMOL = 0
      NBUILD = 0
      NTOTAT = 0
      NCROSF = 0
      LSTDRW = -99
      NCROSS = 0
      NTOTRS = 0
      NBOND = 0
      NTHETA = 0
      NPHI = 0
      IBRES(1) = 1
      IPRES(1) = 1
      IBOND(1) = 1
      ITHETA(1) = 1
      IPHI(1) = 1
      NFRESM(1) = 1
C
C     ----- READ THE INPUT DATA -----
C
      WRITE(IOUT,9108)
      READ(IN,101) ITITL
      WRITE(IOUT,201) ITITL
c
c  --- do a dummy read to preserve compatibility with old link
c      inputs
c
      read(5,'(a80)') kdir
C
C     ----- READ IN NEW RESIDUE TYPES -----
C
C           IERES =  NAME OF RESIDUE (A4)
C           JERES =  0 formatted
C                 =  1 binary
C           KERES =  NAME OF RESIDUE FILE OR COMMENTS (40A1)
C
      DO 220 I = 1, MAXEXR
        READ(IN,1330) IERES(I),JERES(I),KERES(I)
        IF(IERES(I).EQ.IBLANK) GO TO 221
        WRITE(IOUT,1331) I,IERES(I),JERES(I),KERES(I)
  220 CONTINUE
c     --- fall through to here if too many external residues ---
      write(iout,'(/,5x,a,i5,a)') 'Max External Residues =', MAXEXR,
     +       ' exceeded.'
      call mexit(iout, 1)
  221 NERES = I-1
C
C     ----- READ THE DUMMY SYMBOL -----
C
      READ(IN,105) ISYMDU
      WRITE(IOUT,205) ISYMDU
C
C     ----- READ THE PRINTER CONTROL FLAGS -----
C
C           IWO = 0 PRINT R,THETA,PHI FOR EACH ATOM
C           IWI = 1 PRINT INPUT FOR ALL RESIDUES
C           IWN = 1 PRINT NONBONDED EXCLUSIONS FOR ALL ATOMS
C           IWA = 1 PRINT BOND LENGTH,BOND ANGLE,DIHEDRAL ARRAYS
C
      READ(IN,106) IWO,IWI,IWN,IWA
C
C     ----- GRAND LOOP FOR DOING THE LINKING STUFF UNTIL IT FINDS
C           A QUIT CARD -----
C
      DO 10 I = 1, MAXMOL+1
      READ(IN,101) ITITL1
      IF(ITITL1(1).EQ.KQUIT) GO TO 501
C
C     ----- READ THE CROSS LINK ETC INFORMATION -----
C
      READ(IN,102) LBMOL,ICROSL,iconn,NM0,NA0,IFTPRO
      iconn = 0
      ICOROT = 0
C
C     -- SET MOLTYP(I): 1 = R, 2 = D, 3 = P, 4 = O --
C
      DO 20 J = 1,3
          IF(LBMOL.NE.LTYP(J)) GO TO 20
          NCALL = J
          GO TO 30
   20 CONTINUE
      NCALL = 4
   30 CONTINUE
      MOLTYP(I) = NCALL
      IF(MOLTYP(I).EQ.1) WRITE(IOUT,202) I
      IF(MOLTYP(I).EQ.2) WRITE(IOUT,203) I
      IF(MOLTYP(I).EQ.3) WRITE(IOUT,204) I
      IF(MOLTYP(I).EQ.4) WRITE(IOUT,304) I
c
      IF(I.GT.1) GO TO 406
      ICONN = 0
      NA0 = 0
      NA1 = 0
      GO TO 407
  406 CONTINUE
      IF(ICONN.EQ.1) ICOROT = 1
      IF(ICONN.EQ.0) WRITE(IOUT,404) NA0,NM0
      IF(ICONN.NE.0) WRITE(IOUT,405) NA0,NM0
      IF(NA0.EQ.0.OR.NM0.EQ.0) GO TO 920
      IF(ICROSL.EQ.1) WRITE(IOUT,487)
      IF(IFTPRO.EQ.1) WRITE(IOUT,9128)
      IADD = 0
      IF(NM0.EQ.1) GO TO 309
      IADD = NATML(NM0-1)
  309 NA0 = NA0+IADD
      WRITE(IOUT,321) NA0
  407 CONTINUE
      NMOL = I
      NRES = 0
C
C     ----- END INPUT WITH A BLANK CARD -----
C           RESET ISET FOR EACH MOLECULE
C
      ISET = YLINK
      DO 11 J = 1,10000
         READ(IN,103) (LBDUM(K),JTDUM(K),K=1,16)
         IF (J .EQ. 1) ITDUM = JTDUM(1)
         IF(LBDUM(1).EQ.IBLANK) GO TO 14
         DO 12 K = 1,16
            IF(LBDUM(K).EQ.IBLANK) GO TO 13
            IF(LBDUM(K).EQ.KSPACE) ISET = NLINK
            IF(LBDUM(K).EQ.KSPACE) GO TO 12
            IF (JTDUM(K) .EQ. 0) JTDUM(K) = ITDUM
            IF (JTDUM(K) .EQ. 0) GOTO 15
            ITDUM = JTDUM(K)
   15       CONTINUE
            NRES = NRES+1
            NINDX = NTOTRS+NRES
            if (nindx .gt. MAXRES) then
                 write(iout,2000) 'Residues', nindx, 'MAXRES', MAXRES
                 call mexit(iout, 1)
            endif
            LABRES(NINDX) = LBDUM(K)
            IFRES(NINDX) = JTDUM(K)
            ICONNR(NINDX) = ISET
            ISET = YLINK
   12    CONTINUE
   13    CONTINUE
   11 CONTINUE
   14 CONTINUE
      IF(ICROSL.EQ.0) GO TO 454
C
C     ----- READ RESIDUE PAIRS THAT ARE CROSSLINKED -----
C
C           RESIDUE ICROS MUST BE SMALLER THAN RESIDUE JCROS
C           IACRSS AND JACRSS ARE ATOM GRAPH NAMES
C           END INPUT WITH A BLANK CARD
C
      DO 457 III = 1, MAXCRS+1
      NCROSS = NCROSS+1
      IF(NCROSS.GT.MAXCRS) then
           write(iout,2000) 'Crosslinks', ncross, 'MAXCRS', MAXCRS
           call mexit(iout, 1)
      endif
      READ(IN,459) IICROS,JJCROS,
     +                IACRSS(NCROSS),JACRSS(NCROSS),MOLNM
      IF(IICROS.EQ.0) GO TO 458
      NADD = NTOTRS
      IF(MOLNM.GT.0) NADD = NFRESM(MOLNM)-1
      ICROS(NCROSS) = NADD+IICROS
      JCROS(NCROSS) = NTOTRS+JJCROS
C
C     ----- MAKE CERTAIN THAT THE 1ST RESIDUE OCCURS BEFORE THE
C           SECOND ONE -----
C
      IF(ICROS(NCROSS).LT.JCROS(NCROSS)) GO TO 270
      I2TEMP = ICROS(NCROSS)
      ICROS(NCROSS) = JCROS(NCROSS)
      JCROS(NCROSS) = I2TEMP
      I4TEMP = IACRSS(NCROSS)
      IACRSS(NCROSS) = JACRSS(NCROSS)
      JACRSS(NCROSS) = I4TEMP
  270 CONTINUE
      WRITE(IOUT,542) IICROS,JJCROS
      WRITE(IOUT,461) NCROSS,ICROS(NCROSS),JCROS(NCROSS),
     +           IACRSS(NCROSS),JACRSS(NCROSS)
      IF(MOLNM.GT.0) WRITE(IOUT,472) MOLNM
  457 CONTINUE
  458 NCROSS = NCROSS-1
  454 CONTINUE
      NATOMS = 0
      IF(NRES.EQ.0) GO TO 940
C
C     ----- IF IFTPRO.EQ.1 CHANGE TYPE OF PROTEIN END RESIDUES -----
C
      IF(IFTPRO .GT. 0 .AND. MOLTYP(I) .EQ. 3) THEN
          IFRES(NTOTRS+1) = IFRES(NTOTRS+1)*100
          IFRES(NINDX) = IFRES(NINDX)*100+1
      ENDIF
C
      CALL RESINP(LBMOL)
C
C     ----- CORRECT IROTAT FOR MAIN CHAIN ATOMS -----
C
      JS = NTOTAT+1
      JF = JS+NATOMS-1
      DO 45 J = JS,JF
   45 IF(ITREE(J).EQ.MAIN) IROTAT(J) = JF
      IF(ICOROT.EQ.0) GO TO 336
C
C     ----- FIX UP IROTAT OF MOLECULE THAT THIS IS COVALENTLY BONDED
C
      JIND = JOIN(JS)
      DO 335 J = 1,9000
      IF(JIND.LE.0) GO TO 336
      if (jind .gt. MAXATM) go to 336
      IROTAT(JIND) = JF
      JIND = JOIN(JIND)
  335 CONTINUE
  336 CONTINUE
C
C     ----- DELETE IMPROPER TORSION ANGLES THAT REFER TO ATOMS OUTSIDE
C           MOLECULE -----
C
      CALL CHKDIH(JS,JF,IPHI(I),NPHI)
C
C     ----- STORE NUMBER OF FIRST BOND,ANGLE,AND DIHEDRAL IN EACH
C           MOLECULE -----
C
      if (i+1 .gt. MAXMOL) then
           write(iout,2000) 'Molecules', i+1, 'MAXMOL', MAXMOL
           call mexit(iout, 1)
      endif
      IBOND(I+1) = NBOND+1
      ITHETA(I+1) = NTHETA+1
      IPHI(I+1) = NPHI+1
      NTOTAT = NATOMS+NTOTAT
      NFRESM(I+1) = NTOTRS+1
      NATML(I) = NTOTAT
C
   10 CONTINUE
C
C     ----- END OF GRAND LOOP -----
C
  501 CONTINUE
C
C     ----- FORM BL,BA,AND DIHEDRALS FOR CROSSLINKS -----
C
      IF(NCROSS.EQ.0) GO TO 810
      NCROSF = NBOND
      MPHI = NPHI
      MBOND = NBOND
      MTHETA = NTHETA
      DO 801 I = 1,NCROSS
         CALL ATRES(IACRSS(I),ICROS(I),NA0)
         CALL ATRES(JACRSS(I),JCROS(I),NA1)
         NBOND = NBOND+1
         IB(NBOND) = NA0
         JB(NBOND) = NA1
         CALL JOINT
  801 CONTINUE
      IF(MPHI.EQ.NPHI) GO TO 810
      MPLUS = MPHI+1
C
C     ----- CHECK FOR DIHEDRAL ANGLES WITH ATOMS THAT SHOULD NOT HAVE
C           NONBONDED INTERACTIONS -----
C
      DO 146 I = MPLUS,NPHI
      IPI = IP(I)
      LPI = LP(I)
      CALL ISEXC(IPI,LPI,ISKIP)
      IF(ISKIP.NE.1) GO TO 146
C
C     ----- THIS SECTION IS NECESSARY FOR 4 MEMBERED RINGS -----
C
      DO 160 J = 1,NBOND
         IF(IB(J).NE.IPI) GO TO 162
         IF(JB(J).EQ.LPI) GO TO 161
  162    CONTINUE
         IF(IB(J).NE.LPI) GO TO 160
         IF(JB(J).EQ.IPI) GO TO 161
  160 CONTINUE
      GO TO 145
  161 CONTINUE
      KP(I) = -IABS(KP(I))
      GO TO 146
  145 CONTINUE
     
C
C     ----- THIS SECTION NECESSARY FOR 5 MEMBERED RINGS -----
C
      DO 60 J = 1,NTHETA
      IF(IT(J).NE.IPI) GO TO 62
      IF(KT(J).EQ.LPI) GO TO 61
   62 CONTINUE
      IF(IT(J).NE.LPI) GO TO 60
      IF(KT(J).EQ.IPI) GO TO 61
   60 CONTINUE
      GO TO 146
   61 CONTINUE
      KP(I) = -IABS(KP(I))
  146 CONTINUE
C
      DO 990 I = MPLUS,NPHI-1
      IIP = IP(I)
      LLP = LP(I)
      DO 990 J = I+1,NPHI
      IF (IP(J) .NE. IIP .OR. LP(J) .NE. LLP) GO TO 990
      KP(J) = -IABS(KP(J))
  990 CONTINUE
  810 CONTINUE
C
      CALL PRTALL
      NMOLP = NMOL+1
      NRESP = NTOTRS+1
C
C     ----- CHECK FOR POSSIBLE ARRAY OVERFLOWS -----
C
      IF(NRESP.GT.MAXRES) then
           write(iout,2000) 'Residues', nresp, 'MAXRES', MAXRES
           call mexit(iout, 1)
      endif
      IF(NTOTAT.GT.MAXATM) then
           write(iout,2000) 'Atoms', ntotat, 'MAXATM', MAXATM
           call mexit(iout, 1)
      endif
      IF(NBOND.GT.MAXBND) then
           write(iout,2000) 'Bonds', nbond, 'MAXBND', MAXBND
           call mexit(iout, 1)
      endif
      IF(NTHETA.GT.MAXANG) then
           write(iout,2000) 'Angles', ntheta, 'MAXANG', MAXANG
           call mexit(iout, 1)
      endif
      IF(NPHI.GT.MAXDIH) then
           write(iout,2000) 'Dihedrals', nphi, 'MAXDIH', MAXDIH
           call mexit(iout, 1)
      endif
      IF(NEXT.GT.MAXEXC) then
           write(iout,2000) 'Excluded Atoms', next, 'MAXEXC', MAXEXC
           call mexit(iout, 1)
      endif
C
C     ----- OUTPUT THE BINARY FILE -----
C
      CALL WRITEO
      CALL CLOSC(IOUTB)
      CALL CLOSDA
      call mexit(0, 0)
  920 WRITE(IOUT,410)
  410 FORMAT(t2,'LINK-F-MOREINFO, nonzero values for NA0 and NM0',
     +         ' must be specified',/)
      call mexit(iout, 1)
  940 WRITE(IOUT,345)
  345 FORMAT(t2,'LINK-F-NOINPUT, no residues for this molecule',/)
      call mexit(iout, 1)
  101 FORMAT(20A4)
  102 FORMAT(A1,I4,7I5)
  103 FORMAT(16(A4,I1))
  105 FORMAT(A4)
  106 FORMAT(6I5)
  201 FORMAT(/ /,5X,20A4,/)
  202 FORMAT(/ /,5X,'MOLECULE',I5,3X,'IS A R-NUCLEOTIDE',/)
  203 FORMAT(/ /,5X,'MOLECULE',I5,3X,'IS A D-NUCLEOTIDE',/)
  204 FORMAT(/ /,5X,'MOLECULE',I5,3X,'IS A PROTEIN',/)
  205 FORMAT(/,5x,'SYMBOL FOR DUMMY ATOM  = ',2X,A4,/)
  304 FORMAT(/ /,5X,'MOLECULE',I5,3X,'IS AN OTHER',/)
  321 FORMAT(5X,'NA0 = ATOM',I6,/)
  404 FORMAT(5X,'FIRST M ATOM OF PRESENT MOLECULE IS JOINED TO ATOM',
     +      I5,2X,'OF MOLECULE',I5,/,5X,'(WITHOUT A COVALENT BOND)',/)
  405 FORMAT(5X,'FIRST M ATOM OF PRESENT MOLECULE IS JOINED TO ATOM',
     +      I5,2X,'OF MOLECULE',I5,/)
  542 FORMAT(5X,'IICROS  = ',I5,3X,'JJCROS  = ',I5,/)
  459 FORMAT(2I5,2A4,2X,I5)
  461 FORMAT(5X,'CROSSLINK',I4,2X,'IS BETWEEN RESIDUE ',I4,2X,'AND',
     +       I4,3X,'ATOMS ',A4,2X,'AND ',A4,/)
  472 FORMAT(5X,'ONE RESIDUE OF CROSSLINK IS ON MOLECULE',I5,/)
  487 FORMAT(5X,'CROSSLINKS ARE PRESENT',/)
*1330 FORMAT(A4,1X,I5,40A1)
*1331 FORMAT(1H ,5X,I5,3x,A4,1X,I4,3X,40A1)
 1330 FORMAT(A4,1X,I5,A)
 1331 FORMAT(5X,I5,3x,A4,1X,I4,3X,A)
 2000 format(/,5x,'Number of ',a,' =',i6,' exceeds ',a,' =',i6)
 9108 FORMAT(/10X,54(1H-),/10X,
     +       'Amber 4.2        LINK                       UCSF 1996',
     +       /10X,54(1H-))
 9118 FORMAT(A80)
 9128 FORMAT(/5X,'***** THE TERMINAL RESIDUES OF THE PROTEIN',
     +       /5X,'      WILL BE REPLACED BY THE RESPECTIVE CHARGED',
     +       /5X,'      END GROUPS *****',/ /)
      END
