c-----------------------------------------------------------------------
      SUBROUTINE READRS(NF,IFORM)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C     reads an external residue file.
c     Rev A mod:  Bounds checking on internal buffers.  G. Seibel
#include "sizes.h"
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU
      COMMON/EXDAT/CHG(150),RTP(3,150),ITYP(3,150),MB(2,300),MT(3,350),
     +  MP(4,400),NC(150),MUMEX(150),MATEX(600),IROT(150),JPLOT(2,400)
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
c
c     --- Although I find the choice of dimensions in common/exdat/ to
c         be unbalanced with respect to the ratios of such quantities
c         in real systems, I will leave them as such so that we might
c         test some of our older systems to see if any of these buffers
c         have been getting overwritten.  Also, I don't want to encourage
c         the use of overly large residues because of the trouble they
c         cause elsewhere.  -- George Seibel, March 1989.
C
C     ----- READ THE RESIDUE INFORMATION -----
C
      ISTOP = -50
C
C     ----- BRANCH IF BINARY INPUT -----
C
      IF(IFORM.GT.0) GO TO 200
C
      READ(NF,100) MAMRES,ITYPCO,NAT,NBOND,NTHETA,NPHI,IC,NEXT
      IF(MAMRES.NE.NAMRES) GO TO 900
      if (nat .gt. 150 .or. nbond .gt. 300 .or. ntheta .gt. 350 .or.
     +    nphi .gt. 400 .or. next .gt. 600 .or. ic .gt. 400) goto 1000
      READ(NF,101) ((ITYP(K,L),K = 1,3),L = 1,NAT)
      READ(NF,102) ((MB(K,L),K = 1,2),L = 1,NBOND)
      READ(NF,102) ((MT(K,L),K = 1,3),L = 1,NTHETA)
      READ(NF,102) ((MP(K,L),K = 1,4),L = 1,NPHI)
      READ(NF,102) (IROT(K),K = 1,NAT)
      READ(NF,102) (NC(K),K = 1,NAT)
      READ(NF,102) ((JPLOT(K,L),K = 1,2),L = 1,IC)
      READ(NF,102) (MUMEX(K),K = 1,NAT)
      READ(NF,102) (MATEX(K),K = 1,NEXT)
      READ(NF,103) (CHG(K),K = 1,NAT)
      READ(NF,104) ((RTP(K,L),K = 1,3),L = 1,NAT)
      GO TO 220
C
C     ----- BINARY INPUT -----
C
  200 CONTINUE
      READ(NF) MAMRES,ITYPCO,NAT,NBOND,NTHETA,NPHI,IC,NEXT
      IF(MAMRES.NE.NAMRES) GO TO 900
      if (nat .gt. 150 .or. nbond .gt. 300 .or. ntheta .gt. 350 .or.
     +    nphi .gt. 400 .or. next .gt. 600 .or. ic .gt. 400) goto 1000
      READ(NF) ((ITYP(K,L),K = 1,3),L = 1,NAT)
      READ(NF) ((MB(K,L),K = 1,2),L = 1,NBOND)
      READ(NF) ((MT(K,L),K = 1,3),L = 1,NTHETA)
      READ(NF) ((MP(K,L),K = 1,4),L = 1,NPHI)
      READ(NF) (IROT(K),K = 1,NAT)
      READ(NF) (NC(K),K = 1,NAT)
      READ(NF) ((JPLOT(K,L),K = 1,2),L = 1,IC)
      READ(NF) (MUMEX(K),K = 1,NAT)
      READ(NF) (MATEX(K),K = 1,NEXT)
      READ(NF) (CHG(K),K = 1,NAT)
      READ(NF) ((RTP(K,L),K = 1,3),L = 1,NAT)
C
  220 CONTINUE
      NBOND = NBOND+1
      NTHETA = NTHETA+1
      NPHI = NPHI+1
      DO 240 K = 1,4
      IF(K.LT.3) MB(K,NBOND) = ISTOP
      IF(K.LT.4) MT(K,NTHETA) = ISTOP
      MP(K,NPHI) = ISTOP
  240 CONTINUE
      CALL BLDIT(NAT,NC,RTP,ITYP,MB,MT,MP,MUMEX,MATEX,CHG,IROT,JPLOT)
      RETURN
  900 WRITE(IOUT,9008) NAMRES,MAMRES
      call mexit(iout, 1)
 1000 write(iout,'(/,5x,a,a4,a)') 'Residue ',namres,' is too big.'
      call mexit(iout, 1)
 9008 FORMAT(t2,'Residue name ',a4,' does not',
     +' match with ',a4, ' in routine readrs')
  100 FORMAT(A4,A4,6I6)
  101 FORMAT(20A4)
  102 FORMAT(20I4)
  103 FORMAT(10F8.4)
  104 FORMAT(8F10.5)
      END
