c-----------------------------------------------------------------------
      SUBROUTINE RESINP(LBMOL)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
#include "sizes.h"

      CHARACTER*40 KERES
C
C     ----- ROUTINE TO READ ALL RESIDUES FROM EITHER
C           THE DATA BASE OR FROM EXTERNAL SOURCE -----
C
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),IBRES(MAXRES),
     +             IPRES(MAXRES),IFRES(MAXRES)
      COMMON/EXRES/NERES,IERES(MAXEXR),JERES(MAXEXR)
      common/exnam/KERES(MAXEXR)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
      COMMON/DAFIL/IDAF,NREC,NAV,IODA(510,3),HH(10240)
C
C     ----- LOOP THROUGH ALL RESIDUES -----
C
      DO 100 I = 1, NRES
      NTOTRS = NTOTRS+1
      NAMRES = LABRES(NTOTRS)
      NAMR   = NAMRES
      ITYPF  = IFRES(NTOTRS)
      IF(I.EQ.1) GO TO 120
      ICONN = 1
      NA1 = 0
      NA0 = MLAST
  120 CONTINUE
C
C     ----- IF DNA OR RNA APPEND THE NAME OF THE RESIDUE -----
C
      CALL APPEND(LBMOL,NAMR)
C
C     ----- SEARCH FOR RESIDUE IN THE DATA BASE LIST -----
C
      DO 220 J = 1, NREC
      IF(IODA(J,2).NE.ITYPF) GO TO 220
C
C     ----- USE OF NAMR ALLOWS MIXING DNA AND RNA RESIDUES IN SAME
C           MOLECULES -----
C
      IF(IODA(J,1).EQ.NAMRES.OR.IODA(J,1).EQ.NAMR) GO TO 240
  220 CONTINUE
      WRITE(IOUT,9007) NAMRES,ITYPF
 9007 format(2x,'Residue ',a4,' force field type',i4,
     +       ' not in database, searching residue files.')
C
C     ----- UNKNOWN RESIDUE TRY EXTERNAL SOURCE -----
C
      IUNIT = 7
      DO 300 J = 1, NERES
           IF(NAMRES.NE.IERES(J)) GO TO 300
           KFORM = JERES(J)
           CALL OPNEXR(IUNIT,KFORM,KERES(J))
           CALL READRS(IUNIT,KFORM)
           CALL CLOSC(IUNIT)
           GO TO 100
C
  300 CONTINUE
C
C     ----- RESIDUE WAS NOT FOUND IN THE EXTERNAL SOURCE -----
C
      WRITE(IOUT,9008) NAMRES,ITYPF
 9008 FORMAT(2x,'FATAL:  Residue ',a4,' type',i4,
     +       ' was not found in database or residue file.')
      call mexit(iout, 1)
c
c     ----- PLUCKING OUT FROM THE DATA BASE -----
C
  240 CONTINUE
      IREC = J
      CALL DAREAD(IREC)
C
C     ----- TRANSFER DATABASE INFO TO LINK VARIABLES.  FOR EXTERNAL
C           RESIDUES THIS IS READ AS SUCH IN READRS -----
C
      CALL TRANSF
  100 CONTINUE
      RETURN
      END
