c-----------------------------------------------------------------------
      SUBROUTINE TRANSF
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c     Rev A mods by G. Seibel, Mar 1989:
c     - added check on /exdat/ buffer overflow, dimensioned ih() same
c       as hh() so type checking can be used.  Note that this routine
c       assumes sizeof(int) = sizeof(real).   See my comment in READRS.
c     - added common/iofile/ for iout.
C
      COMMON/DAFIL/IDAF,NREC,NAV,IODA(510,3),HH(10240)
      COMMON/EXDAT/CHG(150),RTP(3,150),ITYP(3,150),MB(2,300),MT(3,350),
     +  MP(4,400),NC(150),MUMEX(150),MATEX(600),IROT(150),JPLOT(2,400)
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
C
      DIMENSION IH(10240)
      EQUIVALENCE (IH(1),HH(1))
C
C     ----- TRANSFER DATABASE INFO TO LINK VARIABLES -----
C
      ISTOP = -50
      MAMRES = IH(1)
      ITYPCO = IH(2)
      NAT    = IH(3)
      NBOND  = IH(4)
      NTHETA = IH(5)
      NPHI   = IH(6)
      IC     = IH(7)
      NEXT   = IH(8)
c
c     --- see if /exdat/ buffers will be ok here... ---
c
      if (nat .gt. 150 .or. nbond .gt. 300 .or. ntheta .gt. 350 .or.
     +    nphi .gt. 400 .or. next .gt. 600 .or. ic .gt. 400) goto 1000
C
      LOC    = 8
      DO 100 I = 1, NAT
      ITYP(1,I) = IH(LOC+1)
      ITYP(2,I) = IH(LOC+2)
      ITYP(3,I) = IH(LOC+3)
      CHG(I)    = HH(LOC+4)
      RTP(1,I)  = HH(LOC+5)
      RTP(2,I)  = HH(LOC+6)
      RTP(3,I)  = HH(LOC+7)
      IROT(I)   = IH(LOC+8)
      NC(I)     = IH(LOC+9)
      MUMEX(I)  = IH(LOC+10)
      LOC       = LOC+10
  100 CONTINUE
C
      DO 120 I = 1, NBOND
      MB(1,I) = IH(LOC+1)
      MB(2,I) = IH(LOC+2)
      LOC     = LOC+2
  120 CONTINUE
C
      DO 140 I = 1, NTHETA
      MT(1,I) = IH(LOC+1)
      MT(2,I) = IH(LOC+2)
      MT(3,I) = IH(LOC+3)
      LOC     = LOC+3
  140 CONTINUE
C
      DO 160 I = 1, NPHI
      MP(1,I) = IH(LOC+1)
      MP(2,I) = IH(LOC+2)
      MP(3,I) = IH(LOC+3)
      MP(4,I) = IH(LOC+4)
      LOC     = LOC+4
  160 CONTINUE
C
      DO 180 I = 1, IC
      JPLOT(1,I) = IH(LOC+1)
      JPLOT(2,I) = IH(LOC+2)
      LOC      = LOC+2
  180 CONTINUE
C
      DO 200 I = 1, NEXT
      MATEX(I) = IH(LOC+1)
      LOC    = LOC+1
  200 CONTINUE
      MATEX(NEXT+1) = 0
C
      NBOND = NBOND+1
      NTHETA = NTHETA+1
      NPHI = NPHI+1
      DO 220 K = 1, 4
      IF(K.LT.3) MB(K,NBOND) = ISTOP
      IF(K.LT.4) MT(K,NTHETA) = ISTOP
      MP(K,NPHI) = ISTOP
  220 CONTINUE
      CALL BLDIT(NAT,NC,RTP,ITYP,MB,MT,MP,MUMEX,MATEX,CHG,IROT,JPLOT)
      RETURN
 1000 write(iout,'(/,5x,a,a4,a)') 'Dbase Res ',mamres,' is too big.'
      call mexit(iout, 1)
      END
