c-----------------------------------------------------------------------
      SUBROUTINE GETPER
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO READ THE PERTURBATION LIST AND MAP THE
C           TWO SETS -----
C
#include "sizes.h"
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +             ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),
     +             IAC(MAXATM),AMASS(MAXATM),atpol(MAXATM)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),IBRES(MAXRES),
     +             IPRES(MAXRES)
#include "pertrb.h"
C
      DIMENSION IFLD(20),IVAR(20),IHOL(20),FVAR(20),ITITL(20)
C
      DATA KPERT,KRES,KATOM/4HPERT,4HRES ,4HATOM/
      DATA KEND,KREP/4HEND ,4HREPE/
C
C     ----- LOAD THE UNPERTURBED INFO INTO PERTRB ARRAYS -----
C
      DO 100 I = 1,NTOTAT
         IGRPER(I) = IGRAPH(I)
         ISMPER(I) = ISYMBL(I)
         CGPER(I) = CHRG(I)
         IAPER(I) = 0
         POLPER(I) = atpol(i) 
         ALMPER(I) = 0.0E0
  100 CONTINUE
      DO 120 I = 1,NTOTRS
         LABPER(I) = LABRES(I)
  120 CONTINUE
C
C     ----- NOW READ THE PERTURBATION INFORMATION -----
C
  200 CONTINUE
      READ(5,9008) ITITL
      WRITE(6,9008) ITITL
      IF(ITITL(1).NE.KPERT) GO TO 200
C
      ierr = 0
  220 CONTINUE
        READ(5,9008) ITITL
        WRITE(6,9008) ITITL
        IF(ITITL(1).EQ.KEND) GO TO 700
        IF(ITITL(1).EQ.KREP) GO TO 500
C
C       ----- GET THE TYPE OF INPUT -----
C
        IFLD(1) = 1
        IFLD(2) = 1
        IFLD(3) = 2
        IFLD(4) = 3
        IFLD(5) = 0
        CALL RFREE(IFLD,IHOL,IVAR,FVAR,5,6)
C
        IF(IHOL(1).EQ.KRES) GO TO 300
        IF(IHOL(1).EQ.KATOM) GO TO 400
        IF(IHOL(1).EQ.KEND) GO TO 220
        WRITE(6,9108) ihol(1)
        ierr = ierr + 1
      GO TO 220
C
C     ----- RESIDUE BASED INPUT -----
C
  300 CONTINUE
      IRES = IVAR(1)
      ALMDA = FVAR(1)
      LABPER(IRES) = IHOL(2)
      IFLD(1) = 2
      IFLD(2) = 1
      IFLD(3) = 1
      IFLD(4) = 3
      IFLD(5) = 3
      IFLD(6) = 0
      I1 = IPRES(IRES)
      I2 = IPRES(IRES+1)-1
      DO 320 I = I1,I2
      CALL RFREE(IFLD,IHOL,IVAR,FVAR,5,6)
      IGRPER(I) = IHOL(1)
      ISMPER(I) = IHOL(2)
      CGPER(I) = FVAR(1)
      POLPER(I) = FVAR(2)
      IAPER(I) = 1
  320 CONTINUE
      GO TO 220
C
C     ----- RESIDUE REPEAT -----
C
  500 CONTINUE
      IFLD(1) = 1
      DO 520 I = 2,11
      IFLD(I) = 2
  520 CONTINUE
      IFLD(12) = 0
  540 CONTINUE
      CALL RFREE(IFLD,IHOL,IVAR,FVAR,5,6)
      IF(IHOL(1).EQ.KEND) GO TO 220
      IF(IHOL(1).NE.KRES) then
           WRITE(6,9128)
           call mexit(6,1)
      endif
C
      DO 560 I = 1,10
      JRES = IVAR(I)
      IF(JRES.LE.0) GO TO 560
      J1 = IPRES(JRES)
      J2 = IPRES(JRES+1)-1
      IF(LABRES(IRES).NE.LABRES(JRES)) WRITE(6,9138)
      IF(LABRES(IRES).NE.LABRES(JRES)) GO TO 560
      LABPER(JRES) = LABPER(IRES)
      K = I1
      DO 580 J = J1,J2
      IGRPER(J) = IGRPER(K)
      ISMPER(J) = ISMPER(K)
      CGPER(J) = CGPER(K)
      POLPER(J) = POLPER(K)
      IAPER(J) = IAPER(K)
      K = K+1
  580 CONTINUE
  560 CONTINUE
      GO TO 540
C
C     ----- ATOM INPUT -----
C
  400 CONTINUE
      IFLD(1) = 2
      IFLD(2) = 1
      IFLD(3) = 1
      IFLD(4) = 3
      IFLD(5) = 3
      IFLD(6) = 0
  420 CONTINUE
      CALL RFREE(IFLD,IHOL,IVAR,FVAR,5,6)
      IF(IVAR(1).LE.0) GO TO 220
C
      IAT = IVAR(1)
      IATNM = IHOL(1)
      IATSYM = IHOL(2)
      CGAT = FVAR(1)
      POLAT = FVAR(2)

      IGRPER(IAT) = IATNM
      ISMPER(IAT) = IATSYM
      CGPER(IAT) = CGAT
      POLPER(IAT) = POLAT
      IAPER(IAT) = 1
      GO TO 420
C
C     ----- OUTPUT THE RESULTS -----
C
  700 CONTINUE
      if (ierr.ne.0) call mexit(6,1)
      WRITE(6,9158)
      WRITE(6,9168)
      DUMC1 = 0.0E0
      DUMC2 = 0.0E0
      DO 720 I = 1,NTOTAT
      IF(IAPER(I).LE.0) GO TO 720
      DUMC1 = DUMC1+CHRG(I)
      DUMC2 = DUMC2+CGPER(I)
      WRITE(6,9178) I,IGRAPH(I),ISYMBL(I),CHRG(I)
      WRITE(6,9179)   IGRPER(I),ISMPER(I),CGPER(I),POLPER(I)
  720 CONTINUE
      WRITE(6,9198) DUMC1,DUMC2
      RETURN
c
 9008 FORMAT(20A4)
 9158 FORMAT(/10X,'Listing of PERTURBED atoms:',/ /)
 9168 FORMAT(
     $ t2,'ATOM #',10X,'NAME',3X,'TYPE',6X,'CHARGE',5X
     $ ,'POL (pert only')
 9178 FORMAT(t2,I5,2x,'Unpert: ',2X,A4,2X,A4,2X,2F11.5)
 9179 FORMAT(t2,9X,'pert:   ',A4,2X,A4,2X,2F11.5/)
c
 9108 FORMAT(4X,'PARM-I-UNKNOWN, unknown control word for the',
     +      ' perturbation input: ', a)
 9128 FORMAT(4X,'PARM-F-BADOPT, repeat option applies only to residues')
 9138 FORMAT(4X,'PARM-I-NOMATCH, repeat residue ',i5,' does not match',
     +      ' with res',i5)
 9198 Format(t2,'Total Charge: Unpert = ',f10.5,'  Pert = ',f10.5/)
      END
