C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      SUBROUTINE NBINPT(NAMNB,NXCHG,IXCHG,JXCHG,NO,CN1,CN2,newfrc)
C
#include "sizes.h"
      character*4 header
      logical skip(MAXNBT),newfrc
      COMMON/TYPAT/NATYP,NTYPES,KNDSYM(MAXTYP),IREDEF(MAXTYP),
     +             JREDEF(MAXTYP),IATUSE(MAXTYP),WTB(MAXTYP),
     +             atpb(MAXTYP)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
      COMMON/IOPARM/IN2,IN3,in4,IOUTC,IOUTD,IPARML,IOHB,IONB
C
      DIMENSION LTYNB(MAXNBT)
      DIMENSION CN1(*),CN2(*),NO(MAXNBT,*),IXCHG(*),JXCHG(*)
#ifdef CHARMM
      dimension iatuss(MAXTYP)
#endif
c
c     Rev A mod:
c     - Do the A/C calc double to get better reproducibility
      double precision a, c, rm, ep, den
      double precision POL(MAXNBT),RMIN(MAXNBT),XNEFF(MAXNBT)
C
      DATA IBLANK /2H  /
      DATA IEND /4HEND  /
      DATA KSK /2HSK /
      DATA KRE /2HRE /
      DATA KAC /2HAC /
C
C     ----- READ THE NON-BONDED PARAMETERS -----
C
C           KSK = SLATER-KIRKWOOD PARAMETERS
C           KRE = RADIUS AND WELL DEPTH READ IN
C           KAC = A AND C PARAMETERS READ DIRECTLY
C
#ifdef CHARMM
c
c   --- save iatuse for later call to this routine:
c
      do 1 k=1,MAXTYP
        iatuss(k) = iatuse(k)
    1 continue
c
#endif
      NBFLAG = 0
   10 CONTINUE
      READ(IN2,11) LABEL1,LABEL2,LABEL3,LINDNB
      IF(LABEL1.EQ.IEND) GO TO 20
      IF(LABEL1.EQ.NAMNB) GO TO 30
   12 CONTINUE
      READ(IN2,91) KTYNB
      IF(KTYNB.EQ.IBLANK) GO TO 10
      GO TO 12
   30 CONTINUE
      KINDNB = LINDNB
      WRITE(IOUT,31) LABEL1,LABEL2,LABEL3,KINDNB
      if (iparml .ge. 1 .and. kindnb .eq. KRE) then
           write(iout,'(5x,a)') 'Type        R*      Eps'
           write(iout,'(5x,a)') '-----------------------'
      elseif (iparml .ge. 1 .and. kindnb .eq. KAC) then
           write(iout,'(5x,a)') 'Type         A           C'
           write(iout,'(5x,a)') '------------------------------'
      endif
      I = 0
c
c --- first, read the standard parameters:
c
   40 CONTINUE
      I = I+1
   45 CONTINUE
      if (i .gt. MAXNBT) then
           write(iout,2000) 'NB Atom Types',i,'MAXNBT',MAXNBT
           call mexit(iout, 1)
      endif
      READ(IN2,91) LTYNB(I),POL(I),XNEFF(I),RMIN(I)
      IF(LTYNB(I).EQ.IBLANK) GO TO 135
      CALL RESEQV(LTYNB(I),NXCHG,IXCHG,JXCHG)
      CALL CHKSYM(LTYNB(I),ISKIP)
      IF(ISKIP.EQ.1) GO TO 45
C
      IF (IPARML.ge.1) then
           if (kindnb .eq. kre) then
                 WRITE(IOUT,92) LTYNB(I),POL(I),XNEFF(I)
           elseif (kindnb .eq. kac) then
                 WRITE(IOUT,93) LTYNB(I),POL(I),XNEFF(I)
           else
                 WRITE(IOUT,92) LTYNB(I),POL(I),XNEFF(I),RMIN(I)
           endif
      endif
      GO TO 40
c 
c  --- now read the modifications:
c
  135 if(newfrc) then 
      read(in4,'(a4)',end=200) header
      if (header.ne.'NONB' .and. header.ne.'nonb') go to 135
      i = i - 1
  140 CONTINUE
      I = I+1
  145 CONTINUE
      if (i .gt. MAXNBT) then
           write(iout,2000) 'NB Atom Types',i,'MAXNBT',MAXNBT
           call mexit(iout, 1)
      endif
      READ(in4,91) LTYNB(I),POL(I),XNEFF(I),RMIN(I)
      IF(LTYNB(I).EQ.IBLANK) GO TO 200
      CALL RESEQV(LTYNB(I),NXCHG,IXCHG,JXCHG)
      CALL CHKSYM(LTYNB(I),ISKIP)
      IF(ISKIP.EQ.1) GO TO 145
C
      IF (IPARML.ge.1) then
           if (kindnb .eq. kre) then
                 WRITE(IOUT,992) LTYNB(I),POL(I),XNEFF(I)
           elseif (kindnb .eq. kac) then
                 WRITE(IOUT,993) LTYNB(I),POL(I),XNEFF(I)
           else
                 WRITE(IOUT,992) LTYNB(I),POL(I),XNEFF(I),RMIN(I)
           endif
      endif
      GO TO 140
C
  200 continue 
      endif
      INUM = I-1
      NBFLAG = 1
C
   20 CONTINUE
      IF(NBFLAG.EQ.0) WRITE(IOUT,21) NAMNB
      IF(NBFLAG.EQ.0) GO TO 300
      if (ionb .eq. 1) then
           write(iout,'(/5x,a,/ /,5x,a,/5x,a)')
     +           'Nonbonded Interactions:',
     +           ' Type          A           C           Emin',
     +           '----------------------------------------------'
      endif
c
c  --- check for and eliminate duplicates in the non-bonded list
c      (this just makes the print-out nicer)
c
      skip(inum) = .false.
      do 72 i=1,inum-1
        skip(i) = .false.
        do 71 j=i+1,inum
          if (ltynb(i).eq.ltynb(j)) skip(i) = .true.
   71   continue
   72 continue
c
      DO 87 I = 1,INUM
      if (skip(i)) go to 87
      DO 67 L = 1,NATYP
      IF(KNDSYM(L).EQ.LTYNB(I)) GO TO 68
   67 CONTINUE
      GO TO 150
   68 I1 = JREDEF(L)
      IATUSE(L) = 0
      IF(I1.EQ.0) GO TO 87
      DO 88 J = I,INUM
      if (skip(j)) go to 88
      DO 69 L = 1,NATYP
      IF(KNDSYM(L).EQ.LTYNB(J)) GO TO 196
   69 CONTINUE
      GO TO 150
  196 J1 = JREDEF(L)
      IATUSE(L) = 0
      IF(J1.EQ.0) GO TO 88
      IF(KINDNB.EQ.KAC) GO TO 100
      IF(KINDNB.EQ.KRE) GO TO 101
      IF(KINDNB.NE.KSK) GO TO 180
      DEN = SQRT(POL(I)/XNEFF(I))+SQRT(POL(J)/XNEFF(J))
      C = (362.31d0*POL(I)*POL(J))/DEN
      RM = RMIN(I)+RMIN(J)
      A = 0.5d0*C*(RM**6)
      GO TO 241
  100 CONTINUE
      A = SQRT(POL(I)*POL(J))
      C = SQRT(XNEFF(I)*XNEFF(J))
      if (a .eq. 0.0d0) then
           eng = 0.0d0
      else
           ENG = -C*C/(4.0d0*A)
      endif
      GO TO 242
  101 CONTINUE
      RM = POL(I)+POL(J)
      EP = SQRT(XNEFF(I)*XNEFF(J))
      A = EP*(RM**12)
      C = 2.0d0*EP*(RM**6)
  241 CONTINUE
      if (a .eq. 0.0d0) then
           eng = 0.0d0
      else
           ENG = A/RM**12-C/RM**6
      endif
  242 CONTINUE
      IC = NO(I1,J1)
      CN1(IC) = A
      CN2(IC) = C
*     IF(IONB.EQ.1) WRITE(IOUT,95) LTYNB(I),LTYNB(J),A,C,ENG,IC
      IF(IONB.EQ.1) WRITE(IOUT,95) LTYNB(I),LTYNB(J),A,C,ENG
   88 CONTINUE
   87 CONTINUE
C
C     ----- CHECK THAT ALL ATOM TYPES HAVE NB PARAMETERS -----
C
*     WRITE(IOUT,420)
      ILEFT = 0
      DO 164 I = 1,NATYP
      IF(IATUSE(I).EQ.0) GO TO 164
      ILEFT = 1
      WRITE(IOUT,165) KNDSYM(I)
  164 CONTINUE
      IF(ILEFT.EQ.1) GO TO 300
#ifdef CHARMM
c
c  --- restore original values for iatuse:
c
      do 2 k=1,MAXTYP
        iatuse(k) = iatuss(k)
    2 continue
c
#endif
      RETURN
  150 CONTINUE
      WRITE(IOUT,151) LTYNB(I),LTYNB(J)
      call mexit(iout, 1)
  180 WRITE(IOUT,181) KINDNB
  300 CONTINUE
      write(iout,'(/5x,a)') 'PARM Bailing out.'
      call mexit(iout, 1)
c
   11 FORMAT(2A4,A2,A2)
   31 FORMAT(5X,'NB SET CHOSEN: ',2A4,A2,5X,'TYPE OF PARAMETER =',
     +        1X,A2,/)
   91 FORMAT(2X,A2,6X,3F10.6)
*  92 FORMAT(4X,A2,5X,3F15.6)
   92 FORMAT(5X,A2,4X,3F9.4)
  992 FORMAT('**** ',A2,4X,3F9.4)
   93 FORMAT(5X,A2,4X,2F12.2)
  993 FORMAT('**** ',A2,4X,2F12.2)
*  95 FORMAT(4X,A2,3X,A2,3E15.7,I7)
   95 FORMAT(4X,A2,3X,A2,3E13.4)
* 420 FORMAT(1H ,/)              
c
   21 FORMAT(/4X,'FATAL:  No nonbond parameter set found ',
     +       'with name = ',a4,/)
  151 FORMAT(4X,'PARM-F-MISSING, atom types ',a2,2x,a2,
     +      ' are not both present in the atom type list',/)
  165 FORMAT(4X,'Missing nonbond parameters for atom type ',a2)
  181 FORMAT(4X,'PARM-F-UNRECOG, type of nonbond param. read in',
     +      ' not recognized = ',a2,/)
 2000 format(/,5x,'Number of ',a,' =',i6,' exceeds ',a,' =',i6)
      END
