c-----------------------------------------------------------------------
      SUBROUTINE NBREDF(NTOTAT,IAC,IACPER,PERTUR)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
      LOGICAL PERTUR
C
C     ----- REDEFINE THE NON-BONDED ATOM TYPES BASED ON
C           EQUIVALENCE -----
C
#include "sizes.h"
      COMMON/TYPAT/NATYP,NTYPES,KNDSYM(MAXTYP),IREDEF(MAXTYP),
     +             JREDEF(MAXTYP),IATUSE(MAXTYP),WTB(MAXTYP),
     +             atpb(MAXTYP)
      COMMON/PASHNB/NAMNB,NHB,IZ2,KHT1(MAXHBP),KHT2(MAXHBP),
     +              NHT1(MAXHBP),NHT2(MAXHBP)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
C
      DIMENSION IAC(*),IACPER(*)
      integer newtyp(MAXTYP)
C
      DATA IBLANK /2H   /
C
C     ----- CHECK HB TYPES TO INSURE NO ATOM TYPES ARE EQUIVALENCED
C           TO THEM -----
C
      IF(NHB.EQ.0) GO TO 509
      DO 501 I = 1,NHB
      NHT1(I) = 0
      DO 502 J = 1,2
           IF(J.EQ.1) I1 = KHT1(I)
           IF(J.EQ.2) I1 = KHT2(I)
           IF(I1.EQ.IBLANK) GO TO 501
           DO 503 K = 1,NATYP
                IF(I1.EQ.KNDSYM(K)) GO TO 505
  503      CONTINUE
           WRITE(IOUT,504) I1
           GO TO 920
C
  505      I2 = K
           IF(J.EQ.1) NHT1(I) = K
           IF(J.EQ.2) NHT2(I) = K
C
C     ----- DO NOT EQUIVALENCE THIS TO ANY OTHER ATOM TYPE -----
C
           IREDEF(K) = 0
           DO 506 K = 1,NATYP
                IF(I2.EQ.IREDEF(K)) WRITE(IOUT,508) KNDSYM(K),I1
  506      CONTINUE
  502 CONTINUE
  501 CONTINUE
  509 CONTINUE
*     WRITE(IOUT,498)
*     WRITE(IOUT,100) (I,IATUSE(I),I = 1,NATYP)
*     WRITE(IOUT,299)
*     WRITE(IOUT,198)
*     WRITE(IOUT,100) (I,IREDEF(I),I = 1,NATYP)
C
C     ----- MAKE A UNIQUE SET OF ATOMS USED -----
C
      DO 601 I = 1,NATYP
      II = IREDEF(I)
      IF(II.EQ.0) GO TO 601
      IF(IATUSE(I).EQ.0) GO TO 601
      IATUSE(II) = 1
      IATUSE(I) = 0
  601 CONTINUE
C
C     ----- ASSIGN ATOM NUMBERS TO THOSE ATOMS USED -----
C
      NTYPES = 0
      DO 602 I = 1,NATYP
      JREDEF(I) = 0
      IF(IATUSE(I).EQ.0) GO TO 602
      NTYPES = NTYPES+1
      JREDEF(I) = NTYPES
  602 CONTINUE
*     WRITE(IOUT,299)
*     WRITE(IOUT,99)
*     WRITE(IOUT,100) (I,JREDEF(I),I = 1,NATYP)
c
c     ----- how about some sensible output ---
c
c     iredef(i) = original atom type number that atom i is equiv to,
c                 but equal to zero if first incidence of atom.
c     jredef(i) = pointer to new contiguous list of atom types if first
c                 incidence of an atom type, else zero.
c     newtyp(i) = atom type that this atom is equivalenced to
c
      do 666 i = 1, natyp
           if (iredef(i) .eq. 0) then
                newtyp(i) = kndsym(i)
           else
                newtyp(i) = kndsym(iredef(i))
           endif
  666 continue
      write(iout,'(/,20x,a,/)') 'Nonbonded Parameter Equivalences'
      write(iout,'(4(5x,i3,2x,a2,'' = '',a2))')
     +      (i, kndsym(i), newtyp(i), i=1, natyp)
C
C     ----- PUT REDEFINITION VALUES IN IAC ARRAY -----
C
      DO 700 I = 1,NTOTAT
           I1 = IAC(I)
           IF(I1.EQ.0) GO TO 700
           J1 = IREDEF(I1)
           IF(J1.EQ.0) J1 = I1
           K1 = JREDEF(J1)
           IF(K1.EQ.0) GO TO 900
           IAC(I) = K1
  700 CONTINUE
C
C     ----- PUT THE REDEFINITION VALUES IN IACPER ARRAY -----
C
      IF (PERTUR) then
           DO 800 I = 1,NTOTAT
                I1 = IACPER(I)
                IF(I1.EQ.0) GO TO 800
                J1 = IREDEF(I1)
                IF(J1.EQ.0) J1 = I1
                K1 = JREDEF(J1)
                IF(K1.EQ.0) GO TO 900
                IACPER(I) = K1
  800      CONTINUE
      endif
C
      RETURN
  900 WRITE(IOUT,702) I,I1
  920 CONTINUE
      call mexit(iout, 1)
c
*  99 FORMAT(4X,'UNIQUE ATOM TYPES',/)
* 100 FORMAT(10(3X,I3,'.',1X,I3))
* 198 FORMAT(4X,'REDEFINITION ARRAY',/)
* 299 FORMAT(1H )
* 498 FORMAT(4X,'ATOM TYPES USED',/)
c
  504 FORMAT(4X,'PARM-F-UNKNOWN, (in hydrogen bond section) ',
     +      'unknown atom type  = ',a2)
  508 FORMAT(1H ,'PARM-I-EQUIV, atom type ',a2,
     +      ' equivalenced to hb atom ',a2)
  702 FORMAT(4X,'PARM-F-NOREDEF, atom ',i5,' with original type number'
     +      ,i5, ' has a redefinition value of 0',/)
      END
