c-----------------------------------------------------------------------
      SUBROUTINE PERSEP
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- ROUTINE TO SEPARATE THE BONDS, ANGLES AND DIHEDRALS
C           INVOLVING THE PERTURBED ATOMS -----
C
#include "sizes.h"
#include "pertrb.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/FIXP/MBOND,MTHETA,MPHI,MUMBND,MUMANG,MPTRA,NPTRA
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
      COMMON/PERLIS/NBPER,NGPER,NDPER,MBPER,MGPER,MDPER,IBPER(MAXPVT),
     +              JBPER(MAXPVT),ICBPER(MAXPPT),ITPER(MAXPVT),
     +              JTPER(MAXPVT),KTPER(MAXPVT),ICTPER(MAXPPT),
     +              IPPER(MAXPVT),JPPER(MAXPVT),KPPER(MAXPVT),
     +              LPPER(MAXPVT),ICPPER(MAXPPT)
C
      COMMON/RUNHED/ITITL(20),ITITL1(20)
C
C     ----- SEPARATE THE BONDS -----
C
      NBPER = 0
      MBPER = 0
      IBOND = 0
      DO 100 I = 1,NBOND
      IAT = IB(I)
      JAT = JB(I)
      IF(IAPER(IAT).LE.0 .OR. IAPER(JAT).LE.0) GO TO 120
      NBPER = NBPER+1
      if (nbper .gt. MAXPVT) then
           write(iout,2000) 'Pert Bonds', nbper, 'MAXPVT', MAXPVT
           call mexit(iout, 1)
      endif
      IBPER(NBPER) = IB(I)
      JBPER(NBPER) = JB(I)
      GO TO 100
  120 CONTINUE
      IBOND = IBOND+1
      IB(IBOND) = IB(I)
      JB(IBOND) = JB(I)
  100 CONTINUE
      NBOND = IBOND
      IBOND = 0
      MBPER = NBPER
C
      DO 140 I = 1,NBOND
      IAT = IB(I)
      JAT = JB(I)
      IF(IAPER(IAT).LE.0 .AND. IAPER(JAT).LE.0) GO TO 160
      NBPER = NBPER+1
      if (nbper .gt. MAXPVT) then
           write(iout,2000) 'Pert Bonds', nbper, 'MAXPVT', MAXPVT
           call mexit(iout, 1)
      endif
      IBPER(NBPER) = IB(I)
      JBPER(NBPER) = JB(I)
      GO TO 140
  160 CONTINUE
      IBOND = IBOND+1
      IB(IBOND) = IB(I)
      JB(IBOND) = JB(I)
  140 CONTINUE
      NBOND = IBOND
C
C     ----- SEPARATE THE BOND ANGLES -----
C
      NTET = 0
      NGPER = 0
      MGPER = 0
      DO 200 I = 1,NTHETA
      IAT = IT(I)
      JAT = JT(I)
      KAT = KT(I)
      IF(IAPER(IAT).LE.0 .OR. IAPER(JAT).LE.0 .OR. IAPER(KAT).LE.0)
     +   GO TO 220
      NGPER = NGPER+1
      if (ngper .gt. MAXPVT) then
           write(iout,2000) 'Pert Angles', ngper, 'MAXPVT', MAXPVT
           call mexit(iout, 1)
      endif
      ITPER(NGPER) = IT(I)
      JTPER(NGPER) = JT(I)
      KTPER(NGPER) = KT(I)
      GO TO 200
  220 CONTINUE
      NTET = NTET+1
      IT(NTET) = IT(I)
      JT(NTET) = JT(I)
      KT(NTET) = KT(I)
  200 CONTINUE
      NTHETA = NTET
      NTET = 0
      MGPER = NGPER
C
      DO 240 I = 1,NTHETA
      IAT = IT(I)
      JAT = JT(I)
      KAT = KT(I)
      IF(IAPER(IAT).LE.0 .AND. IAPER(JAT).LE.0 .AND. IAPER(KAT).LE.0)
     +   GO TO 260
      NGPER = NGPER+1
      if (ngper .gt. MAXPVT) then
           write(iout,2000) 'Pert Angles', ngper, 'MAXPVT', MAXPVT
           call mexit(iout, 1)
      endif
      ITPER(NGPER) = IT(I)
      JTPER(NGPER) = JT(I)
      KTPER(NGPER) = KT(I)
      GO TO 240
  260 CONTINUE
      NTET = NTET+1
      IT(NTET) = IT(I)
      JT(NTET) = JT(I)
      KT(NTET) = KT(I)
  240 CONTINUE
      NTHETA = NTET
C
C     ----- SEPARATE THE DIHEDRALS -----
C
      NPH = 0
      NDPER = 0
      MDPER = 0
      DO 300 I = 1,NPHI
      IAT = IP(I)
      JAT = JP(I)
      KAT = IABS(KP(I))
      LAT = IABS(LP(I))
      IF(IAPER(IAT).LE.0 .OR. IAPER(JAT).LE.0 .OR. IAPER(KAT).LE.0
     +   .OR. IAPER(LAT).LE.0) GO TO 320
      NDPER = NDPER+1
      if (ndper .gt. MAXPVT) then
           write(iout,2000) 'Pert Diheds', ndper, 'MAXPVT', MAXPVT
           call mexit(iout, 1)
      endif
      IPPER(NDPER) = IP(I)
      JPPER(NDPER) = JP(I)
      KPPER(NDPER) = KP(I)
      LPPER(NDPER) = LP(I)
      GO TO 300
  320 CONTINUE
      NPH = NPH+1
      IP(NPH) = IP(I)
      JP(NPH) = JP(I)
      KP(NPH) = KP(I)
      LP(NPH) = LP(I)
  300 CONTINUE
      NPHI = NPH
      NPH = 0
      MDPER = NDPER
C
      DO 340 I = 1,NPHI
      IAT = IP(I)
      JAT = JP(I)
      KAT = IABS(KP(I))
      LAT = IABS(LP(I))
      IF(IAPER(IAT).LE.0 .AND. IAPER(JAT).LE.0 .AND. IAPER(KAT).LE.0
     +   .AND. IAPER(LAT).LE.0) GO TO 360
      NDPER = NDPER+1
      if (ndper .gt. MAXPVT) then
           write(iout,2000) 'Pert Diheds', ndper, 'MAXPVT', MAXPVT
           call mexit(iout, 1)
      endif
      IPPER(NDPER) = IP(I)
      JPPER(NDPER) = JP(I)
      KPPER(NDPER) = KP(I)
      LPPER(NDPER) = LP(I)
      GO TO 340
  360 CONTINUE
      NPH = NPH+1
      IP(NPH) = IP(I)
      JP(NPH) = JP(I)
      KP(NPH) = KP(I)
      LP(NPH) = LP(I)
  340 CONTINUE
      NPHI = NPH
      WRITE(IOUT,9008) NBPER,NGPER,NDPER,MBPER,MGPER,MDPER
c
      RETURN
 2000 format(/,5x,'Number of ',a,' =',i6,' exceeds ',a,' =',i6)
 9008 FORMAT(/5X,'NUMBER OF BONDS,ANGLES AND DIHEDRALS INVOLVING',
     +       /5X,'PERTURBED ATOMS',/5X,'NBPER =',I5,5X,'NGPER =',
     +        I5,5X,'NDPER =',I5,/5X,'MBPER =',I5,5X,'MGPER =',
     +        I5,5X,'MDPER =',I5,/)
      END
