c-----------------------------------------------------------------------
      SUBROUTINE PERTD(IP,JP,KP,LP,ICP,ISYMBL,IGRAPH,INDEX,NPHI,NOGO)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- GENERATE THE DIHEDRAL PARAMETER POINTER 
C           NOTE THE DUAL POINTER -----
C
#include "sizes.h"
      COMMON/PASPAR/NUMBND,NUMANG,NUMPHI,NUMPHN,IZ3,IBT(MAXBPT),
     +              JBT(MAXBPT),ITT(MAXAPT),JTT(MAXAPT),KTT(MAXAPT),
     +              IPT(MAXDPT),JPT(MAXDPT),KPT(MAXDPT),LPT(MAXDPT),
     +              IIPT(MAXIPT),JJPT(MAXIPT),KKPT(MAXIPT),
     +              LLPT(MAXIPT),IPNTR(MAXDPT),NO(MAXNBT,MAXNBT)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
C
      DIMENSION IP(*),JP(*),KP(*),LP(*),ICP(*),ISYMBL(*),IGRAPH(*)
C
      DATA ITYPX /2HX /
C
      INDP = (INDEX-1)*NPHI
      DO 1 I = 1,NPHI
      IP1 = IP(I)
      JP1 = JP(I)
      KM = KP(I)
      LM = LP(I)
C
C     ----- MUST REVERSE DIHEDRAL OR WILL LOSE - SIGN INFO
C           I.E. 0 BECOMES -0 IF ATOM NUMBER = 1 AND IT SHOULD BE - ----
C
      IF(KM.EQ.-1.OR.LM.EQ.-1) CALL REVDIH(IP1,JP1,KM,LM)
C
      KN = KM
      LN = LM
      KP1 = IABS(KN)
      LP1 = IABS(LN)
      IS1 = ISYMBL(IP1)
      JS1 = ISYMBL(JP1)
      KS1 = ISYMBL(KP1)
      LS1 = ISYMBL(LP1)
C
C     ----- MULTIPLY THE POINTER ONLY IF INDEX.EQ.2 -----
C
      IF(INDEX.NE.2) GO TO 120
      IP(I) = 3*IP1-3
      JP(I) = 3*JP1-3
      KP(I) = 3*KP1-3
      LP(I) = 3*LP1-3
      IF(KN.LT.0) KP(I) = -KP(I)
      IF(LN.LT.0) LP(I) = -LP(I)
  120 CONTINUE
C
      MTEMP = 0
      IF(LN.LT.0) GO TO 6
C
C     ----- 1ST FIND GENERAL DIHEDRAL TYPE -----
C
      DO 2 J = 1,NUMPHI
C
C     ----- IF 2 END ATOMS ARE NOT BOTH 'X ', THEN NO LONGER HAVE
C           GENERAL DIHEDRAL TYPE -----
C
      IF(IPT(J).NE.ITYPX.OR.LPT(J).NE.ITYPX) GO TO 10
      IF(JS1.EQ.JPT(J).AND.KS1.EQ.KPT(J)) GO TO 3
      IF(KS1.EQ.JPT(J).AND.JS1.EQ.KPT(J)) GO TO 3
    2 CONTINUE
C
C     ----- MIDDLE 2 ATOMS DO NOT OCCUR -- DIHEDRAL TYPE IS
C           NOT PRESENT -----
C
      GO TO 30
    3 MTEMP = J
      J = J+1
      IF(J.GT.NUMPHI) GO TO 30
C
C     ----- LOOKS FOR SPECIFIC DIHEDRAL ANGLE TYPE
C           CHECKS TO SEE IF DIHEDRAL WITH ALL 4 ATOMS SPECIFIED
C           IS PRESENT -----
C
   10 CONTINUE
      DO 4 K = J,NUMPHI
      CALL FNDDIH(IS1,JS1,KS1,LS1,IPT(K),JPT(K),KPT(K),LPT(K),MATCH)
      IF(MATCH.EQ.0)
     +CALL FNDDIH(IS1,JS1,KS1,LS1,LPT(K),KPT(K),JPT(K),IPT(K),MATCH)
      IF(MATCH.EQ.1) GO TO 5
    4 CONTINUE
C
C     ----- SPECIFIC DIHEDRAL TYPE IS NOT PRESENT -----
C
      GO TO 30
    5 MTEMP = K
C     WRITE(IOUT,100) I,IP1,JP1,KP1,LP1,IGRAPH(IP1),IGRAPH(JP1),
C    +              IGRAPH(KP1),IGRAPH(LP1),K
      GO TO 30
    6 CONTINUE
C
C     ----- CHECK FOR IMPROPER DIHEDRALS -----
C
      IF(NUMPHN.EQ.0) GO TO 30
      IT1 = IGRAPH(IP1)
      JT1 = IGRAPH(JP1)
      KT1 = IGRAPH(KP1)
      LT1 = IGRAPH(LP1)
      DO 8 K = 1,NUMPHN
      CALL FNDDIH(IS1,JS1,KS1,LS1,IIPT(K),JJPT(K),KKPT(K),LLPT(K),
     +               MATCH)
      IF(MATCH.EQ.0)
     +CALL FNDDIH(IS1,JS1,KS1,LS1,LLPT(K),KKPT(K),JJPT(K),IIPT(K),
     +                      MATCH)
C
C     ----- USE LAST MATCH FOR DIHEDRAL -----
C
      IF(MATCH.EQ.1) MTEMP = K+NUMPHI
    8 CONTINUE
      IF(MTEMP.EQ.0) GO TO 30
*  29 CONTINUE
   30 CONTINUE
      IF(MTEMP.EQ.0) GO TO 33
      ICP(I+INDP) = IPNTR(MTEMP)
      GO TO 1
   33 CONTINUE
      WRITE(IOUT,95) IS1,JS1,KS1,LS1,IP1,JP1,KP1,LP1
      IF(LN.LT.0.) WRITE(IOUT,76)
      NOGO = NOGO+1
    1 CONTINUE
      RETURN
c
   76 FORMAT(4x,'This is an improper torsion angle')
   95 FORMAT(4x,'Missing dihedral parameter: '
     +      ,a2,'-',a2,'-',a2, '-',a2,
     +      '(atoms ',i5,'-',i5,'-',i5,'-',i5,')')
* 100 FORMAT(1H ,3X,'ANGLE',I5,2X,'WITH ATOMS',4I5,2X,3(A4,'-'),
*    +      A4,2X,'IS SPECIFIC DIHEDRAL  = ',I4)
* 101 FORMAT(1H ,3X,'ANGLE',I5,2X,'WITH ATOMS',4I5,2X,
*    +       3(A4,'-'),A4,2X,'IS IMPROPER DIHEDRAL  = ',I5)
      end
