c-----------------------------------------------------------------------
      subroutine prmfil
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c     Author: George Seibel
*     implicit none
c
c     OUTPUT: (to common)
c
      common /files/ input, output, edtbin, topol, prmcrd, frcfld,
     .               frcmod, owrite
      character*80   input, output, edtbin, topol, prmcrd, frcfld,
     .               frcmod
      character owrite
c
c        PARM files as described in amber v 3.0 Rev A documentation
c
c     INTERNAL:
c
      character*80 arg
c        ... temp for each of the whitespace delimited command line words
      integer iarg, narg
c        ... arg pointer, final number of arguments
c
c     --- default file names ---
c
      input  = 'input'
      output = 'output'
      edtbin = 'edtbin'
      topol  = 'prmtop'
      prmcrd = 'prmcrd'
      frcfld = 'frcfld'
      frcmod = 'frcmod'
c
c     --- default status for writing: new
c
      owrite = 'N'

#ifndef NOGETARG
c
c     --- get com line arguments ---
c
# ifdef HITACHI_GETARG
      iarg = 1
# else
      iarg = 0
# endif
      indx = iargc() 
   10 continue
           iarg = iarg + 1
           call getarg(iarg,arg)
           if (arg .eq. '-i') then
                iarg = iarg + 1
                call getarg(iarg,input)
           elseif (arg .eq. '-o') then
                iarg = iarg + 1
                call getarg(iarg,output)
           elseif (arg .eq. '-e') then
                iarg = iarg + 1
                call getarg(iarg,edtbin)
           elseif (arg .eq. '-f') then
                iarg = iarg + 1
                call getarg(iarg,frcfld)
           elseif (arg .eq. '-c') then
                iarg = iarg + 1
                call getarg(iarg,prmcrd)
           elseif (arg .eq. '-m') then
                iarg = iarg + 1
                call getarg(iarg,frcmod)
           elseif (arg .eq. '-p' .or. arg .eq. '-t') then
                iarg = iarg + 1
                call getarg(iarg,topol)
           elseif (arg .eq. '-O') then
                owrite = 'U'
           else
                if (arg .eq. ' ') go to 20
                write(6,'(/,5x,a,a)') 'unknown flag: ',arg
                write(6,9000)
                call mexit(6, 1)
           endif
      if (iarg .lt. indx) go to 10
c
   20 continue
      narg = iarg - 1
      if (narg .lt. 2) then
           write(6,9000)
           call mexit(6, 1)
      endif
c
#endif
      return
 9000 format(/5x,
     +       'usage: parm [-O] -i input -o output -e edtbin -f frcfld',
     +          /16x, ' -c prmcrd -p prmtop [-m frcmod]')
      end
c-----------------------------------------------------------------------
