c-----------------------------------------------------------------------
      SUBROUTINE RCONST(NOGO)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- READ CONSTRAINT COORDINATES -----
C
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/FIXP/MBOND,MTHETA,MPHI,MUMBND,MUMANG,MPTRA,NPTRA
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +             ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),
     +             IAC(MAXATM),AMASS(MAXATM),atpol(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/PARMS/RK(MAXBPT),REQ(MAXBPT),TK(MAXAPT),TEQ(MAXAPT),
     +             PK(MAXDPT),PN(MAXDPT),PHASE(MAXDPT),CN1(MAXLJP),
     +             CN2(MAXLJP),SOLTY(MAXTYP)
      COMMON/PASPAR/NUMBND,NUMANG,NUMPHI,NUMPHN,IZ3,IBT(MAXBPT),
     +              JBT(MAXBPT),ITT(MAXAPT),JTT(MAXAPT),KTT(MAXAPT),
     +              IPT(MAXDPT),JPT(MAXDPT),KPT(MAXDPT),LPT(MAXDPT),
     +              IIPT(MAXIPT),JJPT(MAXIPT),KKPT(MAXIPT),
     +              LLPT(MAXIPT),IPNTR(MAXDPT),NO(MAXNBT,MAXNBT)
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
      COMMON/IOPARM/IN2,IN3,in4,IOUTC,IOUTD,IPARML,IOHB,IONB
c     Rev A mod:  use double temps
c                 also use doubles for arithmetic on parameters
      double precision conv, req1, conk
      dimension ifld(7),ihol(1),ivar(4),fvar(2)
      data ifld /4*2,2*3,0/
c
c     --- get PI / 180. ---
      CONV = 4.0d0*ATAN(1.0d0)/180.0d0
C
C     ----- PLACE THE CONSTRAINED PARAMETERS AFTER THE TOTAL
C           NUMBER OF BOND, ANGLE AND DIHEDRAL PARAMETERS -----
C
      MBOND = NBOND
      MTHETA = NTHETA
      MPHI = NPHI
      MUMBND = NUMBND
      MUMANG = NUMANG
      MPTRA = NPTRA
C
C     ----- END INPUT WITH A BLANK CARD -----
C
      write(iout,9000)
      i = 0
   51 continue
      i = i + 1
c
c     --- call to rfree mimics the following free-format read,
c         but interprets blanks as zero:
c
c     READ(IN,*) I1,J1,K1,L1,REQ1,CONK
c
      call rfree(ifld,ihol,ivar,fvar,IN,6)
      i1 = ivar(1)
      j1 = ivar(2)
      k1 = ivar(3)
      l1 = ivar(4)
      req1 = fvar(1)
      conk = fvar(2)
      IF(I1.LE.0) GO TO 53
      IF(J1.LE.0) then
           WRITE(IOUT,54) I
           call mexit(iout, 1)
      endif
      IF(K1.GT.0) GO TO 55
C
C     ----- PUT THE BOND CONSTRAINTS -----
C
      WRITE(IOUT,9008) I1,J1,IGRAPH(I1),IGRAPH(J1),REQ1,CONK
      MBOND = MBOND+1
      if (mbond .gt. MAXBND) then
           write(iout,2000) 'Bonds', mbond, 'MAXBND', MAXBND
           call mexit(iout, 1)
      endif
      IB(MBOND) = 3*I1-3
      JB(MBOND) = 3*J1-3
      MUMBND = MUMBND+1
      if (mumbnd .gt. MAXBPT) then
           write(iout,2000) 'Bond Param Types',mumbnd,'MAXBPT',MAXBPT
           call mexit(iout, 1)
      endif
      RK(MUMBND) = CONK
      REQ(MUMBND) = REQ1
      GO TO 51
C
C     ----- PUT THE ANGLE CONSTRAINTS -----
C
   55 IF(L1.GT.0) GO TO 57
      WRITE(IOUT,9018) I1,J1,K1,IGRAPH(I1),IGRAPH(J1),IGRAPH(K1),
     +                 REQ1,CONK
      MTHETA = MTHETA+1
      if (mtheta .gt. MAXANG) then
           write(iout,2000) 'Angles', mtheta, 'MAXANG', MAXANG
           call mexit(iout, 1)
      endif
      IT(MTHETA) = 3*I1-3
      JT(MTHETA) = 3*J1-3
      KT(MTHETA) = 3*K1-3
      MUMANG = MUMANG+1
      if (mumang .gt. MAXAPT) then
           write(iout,2000) 'Angle Param Types',mumang,'MAXAPT',MAXAPT
           call mexit(iout, 1)
      endif
      TEQ(MUMANG) = REQ1*CONV
      TK(MUMANG) = CONK
      GO TO 51
C
C     ----- PUT THE DIHEDRAL CONSTRAINTS -----
C
   57 MPHI = MPHI+1
C
C     ----- REVERSE DIHEDRAL IF NECESSARY -----
C
      IF(K1.EQ.1) CALL REVDIH(I1,J1,K1,L1)
      WRITE(IOUT,9028) I1,J1,K1,L1,IGRAPH(I1),IGRAPH(J1),IGRAPH(K1),
     +                 IGRAPH(L1),REQ1,CONK
      if (mphi .gt. MAXDIH) then
           write(iout,2000) 'Dihedrals', mphi, 'MAXDIH', MAXDIH
           call mexit(iout, 1)
      endif
      IP(MPHI) = 3*I1-3
      JP(MPHI) = 3*J1-3
C
C     ----- MAKE - SO NO NB INTERACTIONS WILL BE CALCULATED -----
C
      KP(MPHI) = -(3*K1-3)
      LP(MPHI) = 3*L1-3
      MPTRA = MPTRA+1
      if (mptra .gt. MAXDPT) then
           write(iout,2000) 'Dihed Param Types',mptra,'MAXDPT',MAXDPT
           call mexit(iout, 1)
      endif
      PK(MPTRA) = CONK
      PN(MPTRA) = 1.0
      IF(REQ1.LT.0.) REQ1 = REQ1+360.0d0
C
C     ----- ADD 180. TO CONVVERT 1+COS TO 1-COS IN DIHEDRAL SECTION ----
C
      PHASE(MPTRA) = CONV*(REQ1+180.0d0)
      go to 51
   53 CONTINUE
      RETURN
   52 FORMAT(4I5,2F10.2)
   54 FORMAT(/2X,'FATAL: Constraint card number ',i5,' is bungled.')
 9000 format(/5x,'Internal Coordinate Constraints:',/5x,'Type',5x,
     + 'Atom Numbers',11x,'Atom Names',13x,'Req',9x,'K',/5x,71('-'))
 9008 FORMAT(5X,'BOND : ',I5,  '-',I5,14X,A4,  '-',A4,10x,2f10.3)
 9018 FORMAT(5X,'ANGLE: ',I5,2('-',I5),8X,A4,2('-',A4),5x,2f10.3)
 9028 FORMAT(5X,'DIHED: ',I5,3('-',I5),2X,A4,3('-',A4),   2f10.3)
 2000 format(/,5x,'Number of ',a,' =',i6,' exceeds ',a,' =',i6)
c
      END
