c-----------------------------------------------------------------------
      SUBROUTINE READIN(IFORM)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
c     Rev A mods: Array bounds checks, parameterization. G. Seibel 1989
#include "sizes.h"
      COMMON/INFOM/NATOMS,NRES,NBOND,NTHETA,NPHI,NBUILD
      COMMON/MISCL/LSTDRW,NTOTRS,ICONN,NA0,NA1,ITYPCO,MLAST,ISYMDU
      COMMON/CROSSL/IRCRSS,NCROSS,NCROSF,IACRSS(MAXCRS),JACRSS(MAXCRS),
     +              ICROS(MAXCRS),JCROS(MAXCRS)
      COMMON/GENL/NTOTAT,NMOL,NUMMOL,NAMRES,IBOND(MAXMOL),
     +            ITHETA(MAXMOL),IPHI(MAXMOL),NATML(MAXMOL),
     +            MOLTYP(MAXMOL),NFRESM(MAXMOL)
      COMMON/INFOR/LABRES(MAXRES),ITRES(MAXRES),IBRES(MAXRES),
     +             IPRES(MAXRES)
      COMMON/ZMAT/R(MAXATM),THETA(MAXATM),PHI(MAXATM)
      COMMON/INFOA/CHRG(MAXATM),IGRAPH(MAXATM),ISYMBL(MAXATM),
     +             ITREE(MAXATM),JOIN(MAXATM),IROTAT(MAXATM),
     +             IAC(MAXATM),AMASS(MAXATM),atpol(MAXATM)
      COMMON/BOND/IB(MAXBND),JB(MAXBND)
      COMMON/ANGL/IT(MAXANG),JT(MAXANG),KT(MAXANG)
      COMMON/DIHED/IP(MAXDIH),JP(MAXDIH),KP(MAXDIH),LP(MAXDIH)
      COMMON/NONBON/NEXT,NUMEX(MAXATM),NATEX(MAXEXC)
      COMMON/BOXPAR/IFBOX,IPTRES,NSPM,NSPSOL,BETA,BOX(3),NSP(MAXRES)
      COMMON/WATCAP/IFCAP,NATCAP,CUTCAP,XCAP,YCAP,ZCAP
      COMMON/IOFILE/IN,IOUT,IOUTB,IWI,IWN,IWA,IWO,INPO,IWP
      COMMON/IOPARM/IN2,IN3,in4,IOUTC,IOUTD,IPARML,IOHB,IONB
      COMMON/RUNHED/ITITL(20),ITITL1(20)
C
      DATA IBIN,IFOR/3HBIN,3HFOR /
C
C     ----- IF FORMATTED EDIT FILE READ ACCORDINGLY -----
C
      IF(IFORM.EQ.IFOR) GO TO 100
C
C     ----- BINARY FILE READING -----
C
      READ(IN3) (ITITL(I),I = 1,20)
      READ(IN3) NTOTAT,NEXT,NMOL,NTOTRS,NBOND,NTHETA,NPHI,INDX,
     +          ISYMDU,IRCRSS,IFBOX,NCROSS,IFCAP
C
      NMOLP = NMOL+1
      NRESP = NTOTRS+1
C
C     --- Check for possible array overflows (binary input only) ---
C      --- if formatted edit file is ever added, repeat below...---
C
      IF(nmolp.GT.MAXMOL) then
           write(iout,2000) 'Molecules', nmolp, 'MAXMOL', MAXMOL
           call mexit(6, 1)
      endif
      IF(NRESP.GT.MAXRES) then
           write(iout,2000) 'Residues', nresp, 'MAXRES', MAXRES
           call mexit(6, 1)
      endif
      IF(NTOTAT.GT.MAXATM) then
           write(iout,2000) 'Atoms', ntotat, 'MAXATM', MAXATM
           call mexit(6, 1)
      endif
      IF(NBOND.GT.MAXBND) then
           write(iout,2000) 'Bonds', nbond, 'MAXBND', MAXBND
           call mexit(6, 1)
      endif
      IF(NTHETA.GT.MAXANG) then
           write(iout,2000) 'Angles', ntheta, 'MAXANG', MAXANG
           call mexit(6, 1)
      endif
      IF(NPHI.GT.MAXDIH) then
           write(iout,2000) 'Dihedrals', nphi, 'MAXDIH', MAXDIH
           call mexit(6, 1)
      endif
      IF(NEXT.GT.MAXEXC) then
           write(iout,2000) 'Excluded Atoms', next, 'MAXEXC', MAXEXC
           call mexit(6, 1)
      endif
      IF(ncross.GT.MAXCRS) then
           write(iout,2000) 'Crosslinks', ncross, 'MAXCRS', MAXCRS
           call mexit(6, 1)
      endif
C
      IF(NCROSS.GT.0)
     +READ(IN3)    (ICROS(I),JCROS(I),I = 1,NCROSS)
      READ(IN3)    (IBOND(I),ITHETA(I),IPHI(I),NFRESM(I),NATML(I),
     +              MOLTYP(I),I = 1,NMOLP)
      READ(IN3)    (LABRES(I),ITRES(I),I = 1,NTOTRS)
      READ(IN3)    (IBRES(I),IPRES(I),I = 1,NRESP)
      READ(IN3)    (IB(I),JB(I),I = 1,NBOND)
      READ(IN3)    (IT(I),JT(I),KT(I),I = 1,NTHETA)
      READ(IN3)    (IP(I),JP(I),KP(I),LP(I),I = 1,NPHI)
      READ(IN3)    (IROTAT(I),JOIN(I),NUMEX(I),I = 1,NTOTAT)
      READ(IN3)    (NATEX(I),I = 1,NEXT)
      READ(IN3)    (ITREE(I),ISYMBL(I),IGRAPH(I),I = 1,NTOTAT)
      READ(IN3)    (CHRG(I),I = 1,NTOTAT)
      READ(IN3)    (R(I),THETA(I),PHI(I),I = 1,NTOTAT)
      IF(IFBOX.LE.0) GO TO 120
      READ(IN3)     IPTRES,NSPM,NSPSOL
      READ(IN3)     (NSP(I),I = 1,NSPM)
      READ(IN3)     BETA,(BOX(I),I=1,3)
  120 CONTINUE
      IF(IFCAP.LE.0) GO TO 220
      READ(IN3)     NATCAP,CUTCAP,XCAP,YCAP,ZCAP
      GO TO 220
C
C     ----- FORMATTED FILE READING -----
C
  100 CONTINUE
C
      READ(IN3,10) (ITITL(I),I = 1,20)
      READ(IN3,11) NTOTAT,NEXT,NMOL,NTOTRS,NBOND,NTHETA,NPHI,INDX,
     +             ISYMDU,IRCRSS,IRCRSS,NCROSS
C
      NMOLP = NMOL+1
      NRESP = NTOTRS+1
C
      IF(NCROSS.GT.0)
     +READ(IN3,12)   (ICROS(I),JCROS(I),I = 1,NCROSS)
      READ(IN3,12)   (IBOND(I),ITHETA(I),IPHI(I),NFRESM(I),NATML(I),
     +                MOLTYP(I),I = 1,NMOLP)
      READ(IN3,13)   (LABRES(I),ITRES(I),I = 1,NTOTRS)
      READ(IN3,12)   (IBRES(I),IPRES(I),I = 1,NRESP)
      READ(IN3,12)   (IB(I),JB(I),I = 1,NBOND)
      READ(IN3,12)   (IT(I),JT(I),KT(I),I = 1,NTHETA)
      READ(IN3,12)   (IP(I),JP(I),KP(I),LP(I),I = 1,NPHI)
      READ(IN3,12)   (IROTAT(I),JOIN(I),NUMEX(I),I = 1,NTOTAT)
      READ(IN3,12)   (NATEX(I),I = 1,NEXT)
      READ(IN3,14)   (ITREE(I),ISYMBL(I),IGRAPH(I),I = 1,NTOTAT)
      READ(IN3,15)   (CHRG(I),I = 1,NTOTAT)
      READ(IN3,16)   (R(I),THETA(I),PHI(I),I = 1,NTOTAT)
C
  220 CONTINUE
      RETURN
c
   10 FORMAT(20A4)
   11 FORMAT(8I5,A2,2A4,I5)
   12 FORMAT(16I5)
   13 FORMAT(11(A4,A3))
   14 FORMAT(11(A1,A2,A4))
   15 FORMAT(8F10.6)
   16 FORMAT(6F12.6)
 2000 format(/,5x,'Number of ',a,' =',i6,' exceeds ',a,' =',i6)
      END
