c-----------------------------------------------------------------------
      SUBROUTINE EXCLUD
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- CALCULATES EXCLUDED ATOMS FROM BOND AND ANGLE LIST
C           LISTS HAVE BEEN SORTED BEFORE CALLING THIS ROUTINE -----
C
c     RevA mod:  revamped 'too many excluded' error message - G. Seibel
      COMMON/INFOA/NATOM,X(1000,3),CHG(1000),IGRAPH(1000),ISYMBL(1000),
     +             ITREE(1000),NC(1000),NB(1000),NA(1000),IROTAT(1000)
      COMMON/BOND/NBOND,IB(1500),JB(1500)
      COMMON/ANGL/NTHETA,IT(2000),JT(2000),KT(2000)
      COMMON/DIHED/NPHI,IPP(2500),JPP(2500),KPP(2500),LPP(2500)
      COMMON/INFOP/NEXT,NUMEX(2500),NATEX(7500),IPB(2500)
      COMMON/MISC/NAMRES,ITYPF,INTX,ISYMDU,IFIXC,IOMIT,IPOS,KFORM,CUT
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
C
      DIMENSION IATEX(90),IPOINT(90)
      DIMENSION JOIN(1000)
      EQUIVALENCE (JOIN(1),NC(1))
C
      WRITE(IOUT,100)
      IBOND = 0
      JP = 0
      DO 10 I = 1,NATOM
        IATEX(1) = 0
        IPOINT(1) = 1
        INUM = 0
        IF(ISYMBL(I).EQ.ISYMDU) GO TO 11
   20   continue
          IBOND = IBOND+1
          IF(IBOND.GT.NBOND) GO TO 30
          IBN = IB(IBOND)
          IF(IBN.GT.I) GO TO 30
          IF(IBN.LT.I) GO TO 20
          INUM = INUM+1
          IATEX(INUM) = JB(IBOND)
          IPOINT(INUM) = INUM
        GO TO 20
   30   continue
        IBOND = IBOND-1
        IF(NTHETA.EQ.0) GO TO 41
        DO 40 J = 1,NTHETA
          IF(I.LT.IT(J)) GO TO 41
          IF(I.NE.IT(J)) GO TO 40
          INUM = INUM+1
          IATEX(INUM) = KT(J)
          IPOINT(INUM) = INUM
   40   CONTINUE
   41   CONTINUE
C
C       -----  EXCLUDE 1-4 INTERACTIONS -----
C
        IPRE = -999
        IF (NPHI.EQ.0) GO TO 11
        DO 70 J = 1,NPHI
c
c         --- don't consider impropers ---
c
          if (lpp(j).lt.0) goto 70
c
          IF(I.LT.IPP(J)) GO TO 11
          IF(I.NE.IPP(J)) GO TO 70
          IF(LPP(J).EQ.IPRE) GO TO 70
C
C         ----- DO NOT EXCLUDE ATOMS OUTSIDE OF RESIDUE THAT ARE IN
C               DIHEDRALS BECAUSE OF IMPROPER TORSION ANGLES -----
C
          IF(LPP(J).GT.NATOM) GO TO 70
          INUM = INUM+1
          IATEX(INUM) = IABS(LPP(J))
          IPOINT(INUM) = INUM
          IPRE = LPP(J)
   70   CONTINUE
   11   CONTINUE
        IF(INUM.EQ.0) INUM = 1
        IF(INUM.EQ.1) GO TO 50
        IF(INUM.GT.90) then
            write(iout,302) i
            call mexit(iout, 1)
        endif
        CALL SORTS(IATEX,IATEX,IPOINT,INUM)
   50   CONTINUE
        JM = JP+1
C
C       ----- CHECK FOR DUPLICATE ATOM NUMBERS NECESSARY BECAUSE OF
C             IMPROPER TORSION ANGLES AND 4 AND 5 MEMBERED RINGS -----
C
        IPRE = -999
        DO 60 J = 1,INUM
          IPN = IPOINT(J)
          INEW = IATEX(IPN)
          IF(INEW.EQ.IPRE) GO TO 60
          JP = JP+1
          NATEX(JP) = INEW
          IPRE = INEW
   60   CONTINUE
        NUMEX(I) = JP-JM+1
        WRITE(IOUT,101) I,NUMEX(I),(NATEX(J),J = JM,JP)
   10 CONTINUE
      NEXT = JP
      WRITE(IOUT,102) NEXT
      if(jp.gt.7500) then
         write(6,'(a)')' excluded atom overflow...redimension NATEX'
         call mexit(6,1)
      endif
      RETURN
  100 FORMAT(1x ,/ /,15X,'EXCLUDED ATOMS ',/ /,4x,'AT NAT   ATOMS..' )
  102 FORMAT(t2,'TOTAL NUMBER OF EXCLUDED ATOMS  = ',I7,/)
  101 FORMAT(1x ,I5,I4,1X,30I4)
c
  302 FORMAT(t2,'PREP-FATAL: Atom',i5,' has too many excluded atoms')
      END
