c-----------------------------------------------------------------------
      SUBROUTINE GETMOL(MAXATM,NAT,X,Y,Z,CHG,IGRAPH,ISYMBL,ITREE,SKIP)
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c     21-Feb-89: added MAXATM to arg list; G. Seibel
      LOGICAL SKIP
C
      COMMON/MISC/NAMRES,ITYPF,INTX,ISYMDU,IFIXC,IOMIT,IPOS,KFORM,CUT
      COMMON/CONST/PI,CONV,CONVV
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
C
      DIMENSION X(*),Y(*),Z(*),CHG(*),IGRAPH(*),ISYMBL(*),ITREE(*)
      DIMENSION IFLD(80),IHOL(10),IVAR(10),FVAR(10)
C
      EQUIVALENCE (IVAR(1),JNUM),(IVAR(2),NNC),(IVAR(3),NNB),
     +            (NNA,IVAR(4)),(IHOL(1),I1),(IHOL(2),I2),(IHOL(3),I3),
     +            (FVAR(1),R1),(FVAR(2),T1),(FVAR(3),P1),(FVAR(4),CHRG)
C
      DATA IFLD/1*2, 3*1, 4*3, 72*0/
C
C     ----- READ THE INITIAL MOLECULAR TOPOLOGY -----
C
      I = 0
      IFLD(5) = 3
      IFLD(6) = 3
      IFLD(7) = 3
      IFLD(8) = 3
      IFLD(9) = 0
      WRITE(IOUT,9008)
C
C     ----- READ ATOMS -----
C
  120 CONTINUE
         I = I+1
         if (i .gt. MAXATM) then
           write(iout,'(/5x,a,i6,a)') 'MAXATM =',MAXATM,' exceeded.'
           call mexit(iout, 1)
         endif
         CALL RFREE(IFLD,IHOL,IVAR,FVAR,IN,IOUT)
         IF(JNUM.EQ.0) GO TO 140
         WRITE(IOUT,9018) JNUM,I1,I2,I3,R1,T1,P1
         IGRAPH(JNUM) = I1
         ISYMBL(JNUM) = I2
         ITREE(JNUM) = I3
         X(JNUM) = R1
         Y(JNUM) = T1
         Z(JNUM) = P1
         CHG(JNUM) = CHRG
      GO TO 120
  140 CONTINUE
C
C     ----- AT LEAST THREE ATOMS ARE NECESSARY FOR FIXING THE
C           SPACE AXIS - EXIT IF FEWER -----
C
      IF (I.lt.4) then
         WRITE(IOUT,9028)
         SKIP = .TRUE.
         return
      endif
C
C     ----- READ THE INTERNAL COORDINATES -----
C
      WRITE(IOUT,9108)
      IFLD(5) = 2
      IFLD(6) = 2
      IFLD(7) = 2
      IFLD(8) = 3
      IFLD(9) = 3
      IFLD(10) = 3
      IFLD(11) = 3
      J = I-1
  180 CONTINUE
         J = J+1
         CALL RFREE(IFLD,IHOL,IVAR,FVAR,IN,IOUT)
         IF(JNUM.EQ.0) GO TO 200
         WRITE(IOUT,9118) JNUM,I1,I2,I3,NNC,NNB,NNA,R1,T1,P1
         IGRAPH(JNUM) = I1
         ISYMBL(JNUM) = I2
         ITREE(JNUM) = I3
         CHG(JNUM) = CHRG
C
C        ----- RESET THE FIRST 3 ATOMS -----
C
         IF(JNUM.gt.3) then
            P2 = 360.0E0 - P1
            CALL COORD(NNA,NNB,NNC,JNUM,X,Y,Z,R1,T1,P2)
            GO TO 180
         endif
C
         GO TO (240,260,280) , JNUM
  240       X(JNUM) = 0.0E0
            Y(JNUM) = 0.0E0
            Z(JNUM) = 0.0E0
            GO TO 180
  260       X(JNUM) = R1
            Y(JNUM) = 0.0E0
            Z(JNUM) = 0.0E0
            GO TO 180
  280       TH = (180.0E0 - T1) * CONV
            X(JNUM) = X(2) + R1 * COS(TH)
            Y(JNUM) = R1 * SIN(TH)
            Z(JNUM) = 0.0E0
            GO TO 180
  200 continue
      NAT = J-1
C
C     ----- RESET THE DUMMYS -----
C
      IF(ISYMBL(1).NE.ISYMDU) then
         X(1) = 0.0E0
         Y(1) = 0.0E0
         Z(1) = 0.0E0
      endif
      IF(ISYMBL(2).eq.ISYMDU) then
         X(2) = 1.0E0
         Y(2) = 0.0E0
         Z(2) = 0.0E0
      endif
      IF(ISYMBL(3).eq.ISYMDU) then
         X(3) = 1.0E0
         Y(3) = 1.0E0
         Z(3) = 0.0E0
      endif
      RETURN
 9008 FORMAT(/ /,t10,'INITIAL X,Y,Z COORDINATES',/)
 9018 FORMAT(I5,3X,A4,2X,A4,2X,A4,5X,3F12.6)
 9108 FORMAT(/ /,t10,'INITIAL INTERNAL COORDINATES',/)
 9118 FORMAT(I5,3X,A4,2X,A4,2X,A4,3I5,4F12.5,I5)
c
 9028 FORMAT(t2,'PREP-F-TOOFEW, there must be at least 3 X,Y,Z cards',/)
      END
