      PROGRAM PREP
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995, 1997                **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
c
c     AMBER Version 5 PREP  
c
c
      LOGICAL SKIP,DBGEN,DBPUN
      CHARACTER*80 NAMDBF,NAMF
      COMMON/CONST/PI,CONV,CONVV
      COMMON/INFOA/NATOM,X(1000,3),CHG(1000),IGRAPH(1000),ISYMBL(1000),
     +             ITREE(1000),NC(1000),NB(1000),NA(1000),IROTAT(1000)
      COMMON/ZMAT/R(1000),THETA(1000),PHI(1000)
      COMMON/BOND/NBOND,IB(1500),JB(1500)
      COMMON/ANGL/NTHETA,IT(2000),JT(2000),KT(2000)
      COMMON/DIHED/NPHI,IPP(2500),JPP(2500),KPP(2500),LPP(2500)
      COMMON/INFOP/NEXT,IP(2500),JP(2500),KP(2500),LP(2500),IPB(2500)
      COMMON/MISC/NAMRES,ITYPF,INTX,ISYMDU,IFIXC,IOMIT,IPOS,KFORM,CUT
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
      COMMON/RUNHED/ITITL(20),ITLR(20)
      common /files/ input, output, params, owrite
      character*80 input, output, params
      character owrite
      character*12 owr2
C
      DIMENSION IFLD(80),IHOL(10),IVAR(10),FVAR(10)
      DIMENSION JOIN(1000)
      EQUIVALENCE (JOIN(1),NC(1))
C
      DATA LOOP,IMPR,KDONE,ICORR,KOMIT,KBEG,KFIN,KALL,KCHANG,IBLNK,
     +     ICHARG,KINT,KXYZ/
     +     4HLOOP,4HIMPR,4HDONE,4HCORR,4HOMIT,4HBEG ,4HEND ,4HALL ,
     +     4HCHAN,4H    ,4HCHAR,4HINT ,4HXYZ /
C
C     ----- EVALUATE SOME CONSTANTS -----
C
      IN = 5
      IOUT = 6
      IOUTB = 10
      IOUTC = 20
C
      PI = 4.0E0*ATAN(1.0E0)
      CONV = PI/180.0E0
      CONVV = 180.0E0/PI
      MAXATM = 1000
C
C     ----- OPEN THE INPUT AND OUTPUT FILE -----
C
      call prpfil
c     subr amopen(lun,fname,fstat,fform,facc)
      call amopen(iout,output,owrite,'F','W')
      call amopen(in,  input, 'O','F','R')
      call amopen(3,   params,owrite,'F','W')
      write(iout,9100)
      if (owrite.eq.'U') then
          write(6, '(/2x,a)') '[-O]verwriting output'
          owr2 = 'unknown'
      else
          owr2 = 'new'
      endif
      
C
C     ----- READ THE MASTER CONTROL FOR DATA BASE GENERATION -----
C
      IFLD(1) = 2
      IFLD(2) = 2
      IFLD(3) = 2
      IFLD(4) = 2
      IFLD(5) = 0
      CALL RFREE(IFLD,IHOL,IVAR,FVAR,IN,IOUT)
      IDBGEN = IVAR(1)
      IREST = IVAR(2)
      ITYPF = IVAR(3)
      IFDATP = IVAR(4)
      DBPUN = IFDATP.GT.0
c     massage irest for openda
      if (IREST.ne.0) IREST = 1
      if (irest.eq.0 .and. owrite.eq.'U') irest = -1
C
C     ----- IF THE INPUT DATA HAS TO BE OUTPUT IN A NEAT FORMATTED FORM
C           OPEN THE FILE -----
c           (unsupported option; hardwire file name)
C
      IF(DBPUN) CALL amopen(IOUTC,'neat.dat','N','F','W')
      IF(DBPUN) WRITE(IOUTC,9908) IDBGEN,IREST,ITYPF
C
      READ(IN,9508) NAMDBF
      IF(DBPUN) WRITE(IOUTC,9508) NAMDBF
C
      DBGEN = IDBGEN.GT.0
      IF(.NOT.DBGEN) GO TO 200
C
      WRITE(IOUT,9518)
      WRITE(IOUT,9528) IREST,ITYPF,NAMDBF
      CALL OPENDA(IREST,NAMDBF)
C
  200 CONTINUE
C
C     ----- LOOP OVER VARIOUS RESIDUES -----
C
 1000 CONTINUE
C
C     ----- CLEAN UP VARIOUS ARRAYS -----
C
      CALL CLEAR(3*MAXATM,X)
      CALL CLEAR(3*MAXATM,R)
C
      NTHETA = 0
      NPHI = 0
      NBOND = 0
C
C     ----- READ THE CONTROL DATA FOR THE RUN -----
C
      SKIP = .FALSE.
      CALL GETDAT(SKIP,NAMF)
C
C     ----- TERMINATE THE RUN IF NECESSARY -----
C
      IF(SKIP) GO TO 600
      IF(IFIXC.EQ.ICORR) GO TO 12
      IF(IFIXC.NE.KCHANG) then
          write(iout,8088) ifixc
          GO TO 600
      endif
C
C     ----- READ THE CARTESIAN COORDINATES FOR THE TOPOLOGY -----
C
      SKIP = .FALSE.
      CALL GETMOL(MAXATM,NATOM,X(1,1),X(1,2),X(1,3),CHG,IGRAPH,ISYMBL,
     +            ITREE,SKIP)
      IF(SKIP) GO TO 600
C
C     ----- GENERATE THE CONNECTIVITY ETC -----
C
      CALL TREE
      CALL ZMATX(NATOM,X(1,1),X(1,2),X(1,3),R,THETA,PHI,NC,NB,NA)
      IF(IOMIT.EQ.KOMIT) CALL EDITDU(0)
      GO TO 19
C
C     ----- READ THE INTERNAL COORDINATES TOPOLOGY -----
C
   12 CONTINUE
      SKIP = .FALSE.
      CALL PGETCOR(MAXATM,NATOM,IGRAPH,ISYMBL,ITREE,R,THETA,PHI,CHG,
     +                                SKIP)
      IF(SKIP) GO TO 600
C
      CALL TREE
      WRITE(IOUT,9308)
      DO 29 I = 1,NATOM
      WRITE(IOUT,9218) I,IGRAPH(I),ISYMBL(I),ITREE(I),NC(I),NB(I),NA(I),
     +                    R(I),THETA(I),PHI(I)
      IF(DBPUN) WRITE(IOUTC,9918) I,IGRAPH(I),ISYMBL(I),ITREE(I),
     +                          NC(I),NB(I),NA(I),R(I),THETA(I),PHI(I)
   29 CONTINUE
      X(2,1) = R(2)
      TH = (180.-THETA(3))*CONV
      X(3,1) = X(2,1)+R(3)*COS(TH)
      X(3,2) = R(3)*SIN(TH)
      DO 27 I = 4,NATOM
      P2 = 360.-PHI(I)
      NAI = NA(I)
      NBI = NB(I)
      NCI = NC(I)
      CALL COORD(NAI,NBI,NCI,I,X(1,1),X(1,2),X(1,3),R(I),
     +           THETA(I),P2)
   27 CONTINUE
      IF(IOMIT.EQ.KOMIT) CALL EDITDU(0)
C
   19 CONTINUE
C
C     ----- READ ADDITIONAL INFORMATION -----
C
C           IOPR = CHARGE  TO READ NEW CHARGES
C                = LOOP    TO READ IN LOOP CLOSING BONDS
C                = IMPROPER TO READ IN IMPROPER TORSION ANGLES
C                = DONE TO EXIT THIS SECTION
C                  THERE MAY BE ANY NUMBER OF BLANK CARDS BETWEEN
C                  OPTIONS
C
      READ(IN,9008) IOPR
      IF(DBPUN) WRITE(IOUTC,9008) IOPR
C
      IF(IOPR.EQ.IBLNK) GO TO 19
      IF(IOPR.EQ.KDONE) GO TO 460
C
      IF(IOPR.EQ.ICHARG) GO TO 120
      IF(IOPR.EQ.LOOP) GO TO 140
      IF(IOPR.EQ.IMPR) GO TO 160
      WRITE(IOUT,9028) IOPR
      GO TO 19
C
  120 CONTINUE
C
C     ----- READ THE NEW CHARGES -----
C
      CALL GETCHG(NATOM,ISYMDU,ISYMBL,CHG)
      GO TO 459
  140 CONTINUE
C
C     ----- READ THE LOOP CLOSING INFORMATION -----
C
      CALL LOOPI(NATOM,NBOND,IGRAPH,IT,JT)
      GO TO 459
  160 CONTINUE
C
C     ----- READ IN IMPROPER TORSION ANGLES -----
C
      CALL DIHEDI(NATOM,NPHI,IGRAPH,IP,JP,KP,LP)
C
  459 CONTINUE
      GO TO 19
C
  460 CONTINUE
      IF(NBOND.EQ.0) WRITE(IOUT,9038)
      IF(NPHI.EQ.0) WRITE(IOUT,9048)
C
C     ----- END OF READING ADDITIONAL INFORMATION -----
C
      WRITE(IOUT,9108)
      DO 31 I = 1,NATOM
      WRITE(IOUT,9228) I,IGRAPH(I),ISYMBL(I),ITREE(I),X(I,1),X(I,2),
     +                 X(I,3)
   31 CONTINUE
      WRITE(IOUT,9118)
      DO 32 I = 1,NATOM
      WRITE(IOUT,9218) I,IGRAPH(I),ISYMBL(I),ITREE(I),NC(I),NB(I),NA(I),
     +                    R(I),THETA(I),PHI(I),CHG(I),IROTAT(I)
   32 CONTINUE
      CHGTOT = 0.
      DO 331 I = 1,NATOM
  331 CHGTOT = CHGTOT+CHG(I)
      WRITE(IOUT,9208)  CHGTOT
C
C     ----- MAKE THE FINAL EDITING -----
C
      CUT = CUT*CUT
      CALL BONDFM
      IF(NBOND.GT.1) CALL ANGPIK
      IF(NBOND.GT.2 .or. NPHI.GT.0) CALL DIHPIK
      CALL EXCLUD
      CALL DRAWL(NATOM,ISYMDU,ISYMBL,ITREE)
C
C     ----- IF DATA BASE GENERATION BRANCH -----
C
      IF(DBGEN) GO TO 220
C
C     ----- OPEN THE OUTPUT FILE AND WRITE THE STUFF -----
C
      CALL GENLIS
c
c     --- these opens have to be hardwired for our dumb vms interface ---
c
      if (kform .gt. 0) then
           open(unit=ioutb,file=namf,status=owr2,form='unformatted',
     +          iostat=ios)
           if (ios .ne. 0) then
                write(6,'(/2x,a,a)') 'ERROR on OPEN: ',namf
                call mexit(6, 1)
           endif
      else
      
           open(unit=ioutb,file=namf,status=owr2,iostat=ios)
           if (ios .ne. 0) then 
                write(6,'(/2x,a,a)') 'ERROR on OPEN: ',namf 
                call mexit(6, 1)
           endif
      endif
      CALL WRITEO
      CALL CLOSC(IOUTB)
      GO TO 1000
C
C     ----- DATA BASE GENERATION -----
C
  220 CONTINUE
      CALL PUTRES
C
C     ----- END OF MAIN LOOP -----
C
      GO TO 1000
  600 CONTINUE
      IF(DBGEN) CALL DAFIN
 9008 FORMAT(A4,4X,I2,A40)
 9038 FORMAT(t2,'NO LOOP CLOSING BONDS ',/)
 9048 FORMAT(t2,'NO IMPROPER TORSION ANGLES ',/)
 9100 FORMAT(/10X,54(1H-),/10X,
     +       'Amber 5     PREP                            UCSF 1997',
     +       /10X,54(1H-))
 9108 FORMAT(/ /,t10,'FINAL X,Y,Z COORDINATES',/)
 9118 FORMAT(/ /,t10,'FINAL INTERNAL COORDINATES',/)
 9208 FORMAT(/ /,5X,'TOTAL CHARGE  = ',F11.6,/ /)
 9308 FORMAT(/ /t10,'INITIAL INTERNAL COORDINATES ',/)
 9218 FORMAT(I5,3X,A4,2X,A4,2X,A4,3I4,4F8.3,I5)
*9228 FORMAT(I5,3X,A4,2X,A4,2X,A4,5X,3F12.6)
 9228 FORMAT(I5,3X,A4,2X,A4,1X,A4,3F8.3)
 9908 FORMAT(10I5)
 9918 FORMAT(I4,3X,A4,2X,A4,2X,A4,3I4,1X,3F12.4)
 9508 FORMAT(A80)
 9518 FORMAT(/ /10X,'DATA BASE GENERATION IS IN PROGRESS',/ /)
 9528 FORMAT(/5X,'MODE OF GENERATION   =',I5,
     +       /5X,'FORCE FIELD TYPE     =',I5,
     +       /5X,'NAME OF THE FILE     =',A80,/ /)
c
 8088 format(t2,'PREP-F-IFIXC, Choose either CORRECT or CHANGE not' ,
     + A4)
 9028 FORMAT(5X,'PREP-WARNING: Unidentified Option = ',A4)
      call mexit(0, 0)
      END
