c-----------------------------------------------------------------------
      SUBROUTINE PUTRES
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
c     21-Feb-88 added check to prevent dbase overflow:  G. Seibel
c
c     Note that this routine assumes sizeof(int) == sizeof(real)
c
      COMMON/INFOA/NATOM,X(1000,3),CHG(1000),IGRAPH(1000),ISYMBL(1000),
     +             ITREE(1000),NC(1000),NB(1000),NA(1000),IROTAT(1000)
      COMMON/ZMAT/R(1000),THETA(1000),PHI(1000)
      COMMON/BOND/NBOND,IB(1500),JB(1500)
      COMMON/ANGL/NTHETA,IT(2000),JT(2000),KT(2000)
      COMMON/DIHED/NPHI,IP(2500),JP(2500),KP(2500),LP(2500)
      COMMON/INFOP/NEXT,NUMEX(2500),NATEX(7500),IPB(2500)
      COMMON/MISC/NAMRES,ITYPF,INTX,ISYMDU,IFIXC,IOMIT,IPOS,KFORM,CUT
      COMMON/DRAWP/IC,ICODE(2,2000)
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
      COMMON/DAFIL/IDAF,NREC,NAV,IODA(510,3),HH(10240)
C
      DIMENSION IH(10240)
      EQUIVALENCE (HH(1),IH(1))
      DATA IXYZ / 3HXYZ/
C
      MAXREC = 510
      ISTOP = -50
      NBOND = NBOND+1
      NTHETA = NTHETA+1
      NPHI = NPHI+1
      IB(NBOND) = ISTOP
      JB(NBOND) = ISTOP
      IT(NTHETA) = ISTOP
      JT(NTHETA) = ISTOP
      KT(NTHETA) = ISTOP
      IP(NPHI) = ISTOP
      JP(NPHI) = ISTOP
      KP(NPHI) = ISTOP
      LP(NPHI) = ISTOP
c
c     --- make sure we dont overrun internal buffer ---
c
      if (8+10*natom+2*nbond+3*ntheta+4*nphi+2*ic+next .gt. 10240) then
           write(iout,'(/5x,a)') 'putres: internal buffer exceeded'
           call mexit(iout, 1)
      endif
C
C     ----- STUFF ALL THE INFORMATION INTO THE ARRAY H FOR
C           WRITING INTO THE DATA BASE FILE -----
C
      IH(1) = NAMRES
      IH(2) = INTX
      IH(3) = NATOM
      IH(4) = NBOND
      IH(5) = NTHETA
      IH(6) = NPHI
      IH(7) = IC
      IH(8) = NEXT
C
      ILOC = 8
      DO 100 I = 1,NATOM
      IH(ILOC+1) = ITREE(I)
      IH(ILOC+2) = ISYMBL(I)
      IH(ILOC+3) = IGRAPH(I)
      HH(ILOC+4) = CHG(I)
      HH(ILOC+5) = R(I)
      HH(ILOC+6) = THETA(I)
      HH(ILOC+7) = PHI(I)
      IH(ILOC+8) = IROTAT(I)
      IH(ILOC+9) = NC(I)
      IH(ILOC+10) = NUMEX(I)
      ILOC = ILOC+10
  100 CONTINUE
C
      DO 120 I = 1,NBOND
      IH(ILOC+1) = IB(I)
      IH(ILOC+2) = JB(I)
      ILOC = ILOC+2
  120 CONTINUE
C
      DO 140 I = 1,NTHETA
      IH(ILOC+1) = IT(I)
      IH(ILOC+2) = JT(I)
      IH(ILOC+3) = KT(I)
      ILOC = ILOC+3
  140 CONTINUE
C
      DO 160 I = 1,NPHI
      IH(ILOC+1) = IP(I)
      IH(ILOC+2) = JP(I)
      IH(ILOC+3) = KP(I)
      IH(ILOC+4) = LP(I)
      ILOC = ILOC+4
  160 CONTINUE
C
      DO 180 I = 1,IC
      IH(ILOC+1) = ICODE(1,I)
      IH(ILOC+2) = ICODE(2,I)
      ILOC = ILOC+2
  180 CONTINUE
C
      DO 200 I = 1,NEXT
      IH(ILOC+1) = NATEX(I)
      ILOC = ILOC+1
  200 CONTINUE
C
C     ----- WRITE THE INFORMATION IN THE DATA BASE FILE -----
C
      NREC = NREC+1
      if (nrec .gt. MAXREC) then
           write(iout,'(/5x,a,i5,a)') 'putres: more than ',MAXREC,
     +           ' residues in database'
           call mexit(iout, 1)
      endif
      IODA(NREC,1) = NAMRES
      IODA(NREC,2) = ITYPF
      LEN = ILOC+1
      CALL DAWRIT(LEN)
      RETURN
      END
