c-----------------------------------------------------------------------
      SUBROUTINE TREE
C
C************************************************************************
C                              AMBER                                   **
C                                                                      **
C                  Copyright (c) 1986, 1991, 1995                      **
C             Regents of the University of California                  **
C                       All Rights Reserved.                           ** 
C                                                                      **
C  This software provided pursuant to a license agreement containing   **
C  restrictions on its disclosure, duplication, and use. This software **
C  contains confidential and proprietary information, and may not be   **
C  extracted or distributed, in whole or in part, for any purpose      **
C  whatsoever, without the express written permission of the authors.  **
C  This notice, and the associated author list, must be attached to    **
C  all copies, or extracts, of this software. Any additional           **
C  restrictions set forth in the license agreement also apply to this  **
C  software.                                                           **
C************************************************************************
C
C
C     ----- CALCULATES SHORTEST PATH TO FIRST ATOM FOR EACH ATOM AND
C           WHICH ATOMS ARE AFFECTED BY ROTATION OF A GIVEN ATOM -----
C
C           DEFINE ATOMS ALONG SHORTEST BRANCHES FIRST
C           FIRST ATOM MUST BE A MAIN CHAIN ATOM
C
      COMMON/INFOA/NATOM,X(1000,3),CHG(1000),IGRAPH(1000),ISYMBL(1000),
     +             ITREE(1000),NC(1000),NB(1000),NA(1000),IROTAT(1000)
      COMMON/IOFILE/IN,IN2,IN3,IN4,IOUT,IOUTB,IOUTC,IFDATP
C
      DIMENSION IP(1000),IPV(1000),IBR(1000)
C
      DATA MAIN /1HM/
      DATA KSIDE / 1HS/
      DATA KBR2 / 1HB/
      DATA KBR3 / 1H3/
      DATA KBR4 / 1H4/
      DATA KBR5 / 1H5/
      DATA KBR6 / 1H6/
      DATA KEND /1HE/
C
      IP(3) = 0
      IP(2) = -1
      IP(1) = -2
      JS = 3
      IA = 0
      IF(ITREE(1).EQ.MAIN) GO TO 1
      WRITE(IOUT,200) ITREE(1)
      GO TO 1000
C
    1 CONTINUE
      DO 75 I = 1,NATOM
      IBR(I) = 0
   75 CONTINUE
   31 CONTINUE
      IA = IA+1
      IF(IA.GT.NATOM) GO TO 40
      NC(IA) = IP(JS)
      NB(IA) = IP(JS-1)
      NA(IA) = IP(JS-2)
      JSMBE = ITREE(IA)
      IF(JSMBE.EQ.MAIN) GO TO 32
      IF(JSMBE.EQ.KEND) GO TO 33
C
C     ----- ADD TO STACK -----
C
      JS = JS+1
      IF(JSMBE.EQ.KSIDE) IPV(JS) = 1
      IF(JSMBE.EQ.KBR2) IPV(JS) = 2
      IF(JSMBE.EQ.KBR3) IPV(JS) = 3
      IF(JSMBE.EQ.KBR4) IPV(JS) = 4
      IF(JSMBE.EQ.KBR5) IPV(JS) = 5
      IF(JSMBE.EQ.KBR6) IPV(JS) = 6
      IP(JS) = IA
      GO TO 31
C
C     ----- WHEN M ATOM IS REACHED,JS SHOULD BE 3 -----
C
   32 CONTINUE
      IF(JS.NE.3) GO TO 91
C
C     ----- ONLY STORE LAST 3 MAIN CHAIN ATOMS -----
C
      IP(1) = IP(2)
      IP(2) = IP(3)
      IP(3) = IA
      GO TO 31
C
C     ----- UNLOAD STACK UNTIL GET TO BRANCH OR MAIN ATOM -----
C
   33 CONTINUE
      IROTAT(IA) = IA
   42 CONTINUE
      IF(JS.EQ.3) GO TO 31
      IPV(JS) = IPV(JS)-1
      IF(IPV(JS).GT.0) GO TO 31
      IATOM = IP(JS)
      IROTAT(IATOM) = IA
      JS = JS-1
      GO TO 42
C
C     ----- ERROR SECTION -----
C
   91 CONTINUE
      WRITE(IOUT,97) IA,IGRAPH(IA),ITREE(IA),NC(IA)
      GO TO 1000
C
   40 CONTINUE
      IF(JS.NE.3) GO TO 91
      DO 50 I = 1,NATOM
      IF(ITREE(I).EQ.MAIN) IROTAT(I) = NATOM
   50 CONTINUE
C
C     ----- IF ERROR IS MADE THAT IS NOT CAUGHT,AN ATOM WILL HAVE TOO
C           MANY BRANCHES -----
C
      DO 76 I = 2,NATOM
      L = NC(I)
      IBR(I) = IBR(I)+1
      IBR(L) = IBR(L)+1
   76 CONTINUE
c      DO 356 I = 1,NATOM
c      WRITE(IOUT,88) I,IGRAPH(I),ITREE(I),NC(I),NB(I),NA(I),
c    +       IROTAT(I),IBR(I)
* 356 CONTINUE
      RETURN
c
c     error exit
c
 1000 CONTINUE
      call mexit(iout, 1)
*  88 FORMAT(1H ,5X,I5,3X,A4,2X,A4,3I6,3X,'ROTATION AFFECTS ALL ATOMS TO
*    +',I5,3X,'NUMBER OF BRANCHES  = ',I6)
c
  200 FORMAT(t2,'PREP-F-FIRST, First atom must be a main atom,not  = '
     +       ,A4,/)
   97 format(t2,'PREP-F-BADCON, error with atom',i5,5x,a4,3x,a4,3x,
     +       'connected with atom',i5)
      END
